# dbpedia-api
This is the API of the DBpedia Ontology

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v0.0.1
- Package version: 0.0.1
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/mintproject/model-catalog-python-api-client.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/mintproject/model-catalog-python-api-client.git`)

Then import the package:
```python
import dbpedia
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import dbpedia
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function

import time
import dbpedia
from dbpedia.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://dbpedia.mosorio.me/v0.0.1
# See configuration.py for a list of all supported configuration parameters.
configuration = dbpedia.Configuration(
    host = "https://dbpedia.mosorio.me/v0.0.1"
)



# Enter a context with an instance of the API client
with dbpedia.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = dbpedia.AbbeyApi(api_client)
    label = 'label_example' # str | Filter by label (optional)
page = 1 # int | Page number (optional) (default to 1)
per_page = 100 # int | Items per page (optional) (default to 100)

    try:
        # List all instances of Abbey
        api_response = api_instance.abbeys_get(label=label, page=page, per_page=per_page)
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AbbeyApi->abbeys_get: %s\n" % e)
    
```

## Documentation for API Endpoints

All URIs are relative to *https://dbpedia.mosorio.me/v0.0.1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AbbeyApi* | [**abbeys_get**](docs/AbbeyApi.md#abbeys_get) | **GET** /abbeys | List all instances of Abbey
*AbbeyApi* | [**abbeys_id_get**](docs/AbbeyApi.md#abbeys_id_get) | **GET** /abbeys/{id} | Get a single Abbey by its id
*AcademicJournalApi* | [**academicjournals_get**](docs/AcademicJournalApi.md#academicjournals_get) | **GET** /academicjournals | List all instances of AcademicJournal
*AcademicJournalApi* | [**academicjournals_id_get**](docs/AcademicJournalApi.md#academicjournals_id_get) | **GET** /academicjournals/{id} | Get a single AcademicJournal by its id
*ActivityApi* | [**activitys_get**](docs/ActivityApi.md#activitys_get) | **GET** /activitys | List all instances of Activity
*ActivityApi* | [**activitys_id_get**](docs/ActivityApi.md#activitys_id_get) | **GET** /activitys/{id} | Get a single Activity by its id
*ActorApi* | [**actors_get**](docs/ActorApi.md#actors_get) | **GET** /actors | List all instances of Actor
*ActorApi* | [**actors_id_get**](docs/ActorApi.md#actors_id_get) | **GET** /actors/{id} | Get a single Actor by its id
*AdministrativeRegionApi* | [**administrativeregions_get**](docs/AdministrativeRegionApi.md#administrativeregions_get) | **GET** /administrativeregions | List all instances of AdministrativeRegion
*AdministrativeRegionApi* | [**administrativeregions_id_get**](docs/AdministrativeRegionApi.md#administrativeregions_id_get) | **GET** /administrativeregions/{id} | Get a single AdministrativeRegion by its id
*AdultActorApi* | [**adultactors_get**](docs/AdultActorApi.md#adultactors_get) | **GET** /adultactors | List all instances of AdultActor
*AdultActorApi* | [**adultactors_id_get**](docs/AdultActorApi.md#adultactors_id_get) | **GET** /adultactors/{id} | Get a single AdultActor by its id
*AgentApi* | [**agents_get**](docs/AgentApi.md#agents_get) | **GET** /agents | List all instances of Agent
*AgentApi* | [**agents_id_get**](docs/AgentApi.md#agents_id_get) | **GET** /agents/{id} | Get a single Agent by its id
*AgglomerationApi* | [**agglomerations_get**](docs/AgglomerationApi.md#agglomerations_get) | **GET** /agglomerations | List all instances of Agglomeration
*AgglomerationApi* | [**agglomerations_id_get**](docs/AgglomerationApi.md#agglomerations_id_get) | **GET** /agglomerations/{id} | Get a single Agglomeration by its id
*AircraftApi* | [**aircrafts_get**](docs/AircraftApi.md#aircrafts_get) | **GET** /aircrafts | List all instances of Aircraft
*AircraftApi* | [**aircrafts_id_get**](docs/AircraftApi.md#aircrafts_id_get) | **GET** /aircrafts/{id} | Get a single Aircraft by its id
*AirlineApi* | [**airlines_get**](docs/AirlineApi.md#airlines_get) | **GET** /airlines | List all instances of Airline
*AirlineApi* | [**airlines_id_get**](docs/AirlineApi.md#airlines_id_get) | **GET** /airlines/{id} | Get a single Airline by its id
*AirportApi* | [**airports_get**](docs/AirportApi.md#airports_get) | **GET** /airports | List all instances of Airport
*AirportApi* | [**airports_id_get**](docs/AirportApi.md#airports_id_get) | **GET** /airports/{id} | Get a single Airport by its id
*AlbumApi* | [**albums_get**](docs/AlbumApi.md#albums_get) | **GET** /albums | List all instances of Album
*AlbumApi* | [**albums_id_get**](docs/AlbumApi.md#albums_id_get) | **GET** /albums/{id} | Get a single Album by its id
*AlgerianSettlementApi* | [**algeriansettlements_get**](docs/AlgerianSettlementApi.md#algeriansettlements_get) | **GET** /algeriansettlements | List all instances of AlgerianSettlement
*AlgerianSettlementApi* | [**algeriansettlements_id_get**](docs/AlgerianSettlementApi.md#algeriansettlements_id_get) | **GET** /algeriansettlements/{id} | Get a single AlgerianSettlement by its id
*AltitudeApi* | [**altitudes_get**](docs/AltitudeApi.md#altitudes_get) | **GET** /altitudes | List all instances of Altitude
*AltitudeApi* | [**altitudes_id_get**](docs/AltitudeApi.md#altitudes_id_get) | **GET** /altitudes/{id} | Get a single Altitude by its id
*AmateurBoxerApi* | [**amateurboxers_get**](docs/AmateurBoxerApi.md#amateurboxers_get) | **GET** /amateurboxers | List all instances of AmateurBoxer
*AmateurBoxerApi* | [**amateurboxers_id_get**](docs/AmateurBoxerApi.md#amateurboxers_id_get) | **GET** /amateurboxers/{id} | Get a single AmateurBoxer by its id
*AmbassadorApi* | [**ambassadors_get**](docs/AmbassadorApi.md#ambassadors_get) | **GET** /ambassadors | List all instances of Ambassador
*AmbassadorApi* | [**ambassadors_id_get**](docs/AmbassadorApi.md#ambassadors_id_get) | **GET** /ambassadors/{id} | Get a single Ambassador by its id
*AmericanFootballCoachApi* | [**americanfootballcoachs_get**](docs/AmericanFootballCoachApi.md#americanfootballcoachs_get) | **GET** /americanfootballcoachs | List all instances of AmericanFootballCoach
*AmericanFootballCoachApi* | [**americanfootballcoachs_id_get**](docs/AmericanFootballCoachApi.md#americanfootballcoachs_id_get) | **GET** /americanfootballcoachs/{id} | Get a single AmericanFootballCoach by its id
*AmericanFootballLeagueApi* | [**americanfootballleagues_get**](docs/AmericanFootballLeagueApi.md#americanfootballleagues_get) | **GET** /americanfootballleagues | List all instances of AmericanFootballLeague
*AmericanFootballLeagueApi* | [**americanfootballleagues_id_get**](docs/AmericanFootballLeagueApi.md#americanfootballleagues_id_get) | **GET** /americanfootballleagues/{id} | Get a single AmericanFootballLeague by its id
*AmericanFootballPlayerApi* | [**americanfootballplayers_get**](docs/AmericanFootballPlayerApi.md#americanfootballplayers_get) | **GET** /americanfootballplayers | List all instances of AmericanFootballPlayer
*AmericanFootballPlayerApi* | [**americanfootballplayers_id_get**](docs/AmericanFootballPlayerApi.md#americanfootballplayers_id_get) | **GET** /americanfootballplayers/{id} | Get a single AmericanFootballPlayer by its id
*AmericanFootballTeamApi* | [**americanfootballteams_get**](docs/AmericanFootballTeamApi.md#americanfootballteams_get) | **GET** /americanfootballteams | List all instances of AmericanFootballTeam
*AmericanFootballTeamApi* | [**americanfootballteams_id_get**](docs/AmericanFootballTeamApi.md#americanfootballteams_id_get) | **GET** /americanfootballteams/{id} | Get a single AmericanFootballTeam by its id
*AmphibianApi* | [**amphibians_get**](docs/AmphibianApi.md#amphibians_get) | **GET** /amphibians | List all instances of Amphibian
*AmphibianApi* | [**amphibians_id_get**](docs/AmphibianApi.md#amphibians_id_get) | **GET** /amphibians/{id} | Get a single Amphibian by its id
*AmusementParkAttractionApi* | [**amusementparkattractions_get**](docs/AmusementParkAttractionApi.md#amusementparkattractions_get) | **GET** /amusementparkattractions | List all instances of AmusementParkAttraction
*AmusementParkAttractionApi* | [**amusementparkattractions_id_get**](docs/AmusementParkAttractionApi.md#amusementparkattractions_id_get) | **GET** /amusementparkattractions/{id} | Get a single AmusementParkAttraction by its id
*AnatomicalStructureApi* | [**anatomicalstructures_get**](docs/AnatomicalStructureApi.md#anatomicalstructures_get) | **GET** /anatomicalstructures | List all instances of AnatomicalStructure
*AnatomicalStructureApi* | [**anatomicalstructures_id_get**](docs/AnatomicalStructureApi.md#anatomicalstructures_id_get) | **GET** /anatomicalstructures/{id} | Get a single AnatomicalStructure by its id
*AnimalApi* | [**animals_get**](docs/AnimalApi.md#animals_get) | **GET** /animals | List all instances of Animal
*AnimalApi* | [**animals_id_get**](docs/AnimalApi.md#animals_id_get) | **GET** /animals/{id} | Get a single Animal by its id
*AnimangaCharacterApi* | [**animangacharacters_get**](docs/AnimangaCharacterApi.md#animangacharacters_get) | **GET** /animangacharacters | List all instances of AnimangaCharacter
*AnimangaCharacterApi* | [**animangacharacters_id_get**](docs/AnimangaCharacterApi.md#animangacharacters_id_get) | **GET** /animangacharacters/{id} | Get a single AnimangaCharacter by its id
*AnimeApi* | [**animes_get**](docs/AnimeApi.md#animes_get) | **GET** /animes | List all instances of Anime
*AnimeApi* | [**animes_id_get**](docs/AnimeApi.md#animes_id_get) | **GET** /animes/{id} | Get a single Anime by its id
*AnnotationApi* | [**annotations_get**](docs/AnnotationApi.md#annotations_get) | **GET** /annotations | List all instances of Annotation
*AnnotationApi* | [**annotations_id_get**](docs/AnnotationApi.md#annotations_id_get) | **GET** /annotations/{id} | Get a single Annotation by its id
*ArachnidApi* | [**arachnids_get**](docs/ArachnidApi.md#arachnids_get) | **GET** /arachnids | List all instances of Arachnid
*ArachnidApi* | [**arachnids_id_get**](docs/ArachnidApi.md#arachnids_id_get) | **GET** /arachnids/{id} | Get a single Arachnid by its id
*ArchaeaApi* | [**archaeas_get**](docs/ArchaeaApi.md#archaeas_get) | **GET** /archaeas | List all instances of Archaea
*ArchaeaApi* | [**archaeas_id_get**](docs/ArchaeaApi.md#archaeas_id_get) | **GET** /archaeas/{id} | Get a single Archaea by its id
*ArcheologistApi* | [**archeologists_get**](docs/ArcheologistApi.md#archeologists_get) | **GET** /archeologists | List all instances of Archeologist
*ArcheologistApi* | [**archeologists_id_get**](docs/ArcheologistApi.md#archeologists_id_get) | **GET** /archeologists/{id} | Get a single Archeologist by its id
*ArchipelagoApi* | [**archipelagos_get**](docs/ArchipelagoApi.md#archipelagos_get) | **GET** /archipelagos | List all instances of Archipelago
*ArchipelagoApi* | [**archipelagos_id_get**](docs/ArchipelagoApi.md#archipelagos_id_get) | **GET** /archipelagos/{id} | Get a single Archipelago by its id
*ArchitectApi* | [**architects_get**](docs/ArchitectApi.md#architects_get) | **GET** /architects | List all instances of Architect
*ArchitectApi* | [**architects_id_get**](docs/ArchitectApi.md#architects_id_get) | **GET** /architects/{id} | Get a single Architect by its id
*ArchitecturalStructureApi* | [**architecturalstructures_get**](docs/ArchitecturalStructureApi.md#architecturalstructures_get) | **GET** /architecturalstructures | List all instances of ArchitecturalStructure
*ArchitecturalStructureApi* | [**architecturalstructures_id_get**](docs/ArchitecturalStructureApi.md#architecturalstructures_id_get) | **GET** /architecturalstructures/{id} | Get a single ArchitecturalStructure by its id
*ArchiveApi* | [**archives_get**](docs/ArchiveApi.md#archives_get) | **GET** /archives | List all instances of Archive
*ArchiveApi* | [**archives_id_get**](docs/ArchiveApi.md#archives_id_get) | **GET** /archives/{id} | Get a single Archive by its id
*AreaApi* | [**areas_get**](docs/AreaApi.md#areas_get) | **GET** /areas | List all instances of Area
*AreaApi* | [**areas_id_get**](docs/AreaApi.md#areas_id_get) | **GET** /areas/{id} | Get a single Area by its id
*ArenaApi* | [**arenas_get**](docs/ArenaApi.md#arenas_get) | **GET** /arenas | List all instances of Arena
*ArenaApi* | [**arenas_id_get**](docs/ArenaApi.md#arenas_id_get) | **GET** /arenas/{id} | Get a single Arena by its id
*AristocratApi* | [**aristocrats_get**](docs/AristocratApi.md#aristocrats_get) | **GET** /aristocrats | List all instances of Aristocrat
*AristocratApi* | [**aristocrats_id_get**](docs/AristocratApi.md#aristocrats_id_get) | **GET** /aristocrats/{id} | Get a single Aristocrat by its id
*ArteryApi* | [**arterys_get**](docs/ArteryApi.md#arterys_get) | **GET** /arterys | List all instances of Artery
*ArteryApi* | [**arterys_id_get**](docs/ArteryApi.md#arterys_id_get) | **GET** /arterys/{id} | Get a single Artery by its id
*ArtificialSatelliteApi* | [**artificialsatellites_get**](docs/ArtificialSatelliteApi.md#artificialsatellites_get) | **GET** /artificialsatellites | List all instances of ArtificialSatellite
*ArtificialSatelliteApi* | [**artificialsatellites_id_get**](docs/ArtificialSatelliteApi.md#artificialsatellites_id_get) | **GET** /artificialsatellites/{id} | Get a single ArtificialSatellite by its id
*ArtistApi* | [**artists_get**](docs/ArtistApi.md#artists_get) | **GET** /artists | List all instances of Artist
*ArtistApi* | [**artists_id_get**](docs/ArtistApi.md#artists_id_get) | **GET** /artists/{id} | Get a single Artist by its id
*ArtistDiscographyApi* | [**artistdiscographys_get**](docs/ArtistDiscographyApi.md#artistdiscographys_get) | **GET** /artistdiscographys | List all instances of ArtistDiscography
*ArtistDiscographyApi* | [**artistdiscographys_id_get**](docs/ArtistDiscographyApi.md#artistdiscographys_id_get) | **GET** /artistdiscographys/{id} | Get a single ArtistDiscography by its id
*ArtworkApi* | [**artworks_get**](docs/ArtworkApi.md#artworks_get) | **GET** /artworks | List all instances of Artwork
*ArtworkApi* | [**artworks_id_get**](docs/ArtworkApi.md#artworks_id_get) | **GET** /artworks/{id} | Get a single Artwork by its id
*AsteroidApi* | [**asteroids_get**](docs/AsteroidApi.md#asteroids_get) | **GET** /asteroids | List all instances of Asteroid
*AsteroidApi* | [**asteroids_id_get**](docs/AsteroidApi.md#asteroids_id_get) | **GET** /asteroids/{id} | Get a single Asteroid by its id
*AstronautApi* | [**astronauts_get**](docs/AstronautApi.md#astronauts_get) | **GET** /astronauts | List all instances of Astronaut
*AstronautApi* | [**astronauts_id_get**](docs/AstronautApi.md#astronauts_id_get) | **GET** /astronauts/{id} | Get a single Astronaut by its id
*AthleteApi* | [**athletes_get**](docs/AthleteApi.md#athletes_get) | **GET** /athletes | List all instances of Athlete
*AthleteApi* | [**athletes_id_get**](docs/AthleteApi.md#athletes_id_get) | **GET** /athletes/{id} | Get a single Athlete by its id
*AthleticsApi* | [**athleticss_get**](docs/AthleticsApi.md#athleticss_get) | **GET** /athleticss | List all instances of Athletics
*AthleticsApi* | [**athleticss_id_get**](docs/AthleticsApi.md#athleticss_id_get) | **GET** /athleticss/{id} | Get a single Athletics by its id
*AthleticsPlayerApi* | [**athleticsplayers_get**](docs/AthleticsPlayerApi.md#athleticsplayers_get) | **GET** /athleticsplayers | List all instances of AthleticsPlayer
*AthleticsPlayerApi* | [**athleticsplayers_id_get**](docs/AthleticsPlayerApi.md#athleticsplayers_id_get) | **GET** /athleticsplayers/{id} | Get a single AthleticsPlayer by its id
*AtollApi* | [**atolls_get**](docs/AtollApi.md#atolls_get) | **GET** /atolls | List all instances of Atoll
*AtollApi* | [**atolls_id_get**](docs/AtollApi.md#atolls_id_get) | **GET** /atolls/{id} | Get a single Atoll by its id
*AustralianFootballLeagueApi* | [**australianfootballleagues_get**](docs/AustralianFootballLeagueApi.md#australianfootballleagues_get) | **GET** /australianfootballleagues | List all instances of AustralianFootballLeague
*AustralianFootballLeagueApi* | [**australianfootballleagues_id_get**](docs/AustralianFootballLeagueApi.md#australianfootballleagues_id_get) | **GET** /australianfootballleagues/{id} | Get a single AustralianFootballLeague by its id
*AustralianFootballTeamApi* | [**australianfootballteams_get**](docs/AustralianFootballTeamApi.md#australianfootballteams_get) | **GET** /australianfootballteams | List all instances of AustralianFootballTeam
*AustralianFootballTeamApi* | [**australianfootballteams_id_get**](docs/AustralianFootballTeamApi.md#australianfootballteams_id_get) | **GET** /australianfootballteams/{id} | Get a single AustralianFootballTeam by its id
*AustralianRulesFootballPlayerApi* | [**australianrulesfootballplayers_get**](docs/AustralianRulesFootballPlayerApi.md#australianrulesfootballplayers_get) | **GET** /australianrulesfootballplayers | List all instances of AustralianRulesFootballPlayer
*AustralianRulesFootballPlayerApi* | [**australianrulesfootballplayers_id_get**](docs/AustralianRulesFootballPlayerApi.md#australianrulesfootballplayers_id_get) | **GET** /australianrulesfootballplayers/{id} | Get a single AustralianRulesFootballPlayer by its id
*AustrianAdministrativeRegionApi* | [**austrianadministrativeregions_get**](docs/AustrianAdministrativeRegionApi.md#austrianadministrativeregions_get) | **GET** /austrianadministrativeregions | List all instances of AustrianAdministrativeRegion
*AustrianAdministrativeRegionApi* | [**austrianadministrativeregions_id_get**](docs/AustrianAdministrativeRegionApi.md#austrianadministrativeregions_id_get) | **GET** /austrianadministrativeregions/{id} | Get a single AustrianAdministrativeRegion by its id
*AustrianSettlementApi* | [**austriansettlements_get**](docs/AustrianSettlementApi.md#austriansettlements_get) | **GET** /austriansettlements | List all instances of AustrianSettlement
*AustrianSettlementApi* | [**austriansettlements_id_get**](docs/AustrianSettlementApi.md#austriansettlements_id_get) | **GET** /austriansettlements/{id} | Get a single AustrianSettlement by its id
*AutoRacingLeagueApi* | [**autoracingleagues_get**](docs/AutoRacingLeagueApi.md#autoracingleagues_get) | **GET** /autoracingleagues | List all instances of AutoRacingLeague
*AutoRacingLeagueApi* | [**autoracingleagues_id_get**](docs/AutoRacingLeagueApi.md#autoracingleagues_id_get) | **GET** /autoracingleagues/{id} | Get a single AutoRacingLeague by its id
*AutomobileApi* | [**automobiles_get**](docs/AutomobileApi.md#automobiles_get) | **GET** /automobiles | List all instances of Automobile
*AutomobileApi* | [**automobiles_id_get**](docs/AutomobileApi.md#automobiles_id_get) | **GET** /automobiles/{id} | Get a single Automobile by its id
*AutomobileEngineApi* | [**automobileengines_get**](docs/AutomobileEngineApi.md#automobileengines_get) | **GET** /automobileengines | List all instances of AutomobileEngine
*AutomobileEngineApi* | [**automobileengines_id_get**](docs/AutomobileEngineApi.md#automobileengines_id_get) | **GET** /automobileengines/{id} | Get a single AutomobileEngine by its id
*AwardApi* | [**awards_get**](docs/AwardApi.md#awards_get) | **GET** /awards | List all instances of Award
*AwardApi* | [**awards_id_get**](docs/AwardApi.md#awards_id_get) | **GET** /awards/{id} | Get a single Award by its id
*BackSceneApi* | [**backscenes_get**](docs/BackSceneApi.md#backscenes_get) | **GET** /backscenes | List all instances of BackScene
*BackSceneApi* | [**backscenes_id_get**](docs/BackSceneApi.md#backscenes_id_get) | **GET** /backscenes/{id} | Get a single BackScene by its id
*BacteriaApi* | [**bacterias_get**](docs/BacteriaApi.md#bacterias_get) | **GET** /bacterias | List all instances of Bacteria
*BacteriaApi* | [**bacterias_id_get**](docs/BacteriaApi.md#bacterias_id_get) | **GET** /bacterias/{id} | Get a single Bacteria by its id
*BadmintonPlayerApi* | [**badmintonplayers_get**](docs/BadmintonPlayerApi.md#badmintonplayers_get) | **GET** /badmintonplayers | List all instances of BadmintonPlayer
*BadmintonPlayerApi* | [**badmintonplayers_id_get**](docs/BadmintonPlayerApi.md#badmintonplayers_id_get) | **GET** /badmintonplayers/{id} | Get a single BadmintonPlayer by its id
*BandApi* | [**bands_get**](docs/BandApi.md#bands_get) | **GET** /bands | List all instances of Band
*BandApi* | [**bands_id_get**](docs/BandApi.md#bands_id_get) | **GET** /bands/{id} | Get a single Band by its id
*BaronetApi* | [**baronets_get**](docs/BaronetApi.md#baronets_get) | **GET** /baronets | List all instances of Baronet
*BaronetApi* | [**baronets_id_get**](docs/BaronetApi.md#baronets_id_get) | **GET** /baronets/{id} | Get a single Baronet by its id
*BaseballLeagueApi* | [**baseballleagues_get**](docs/BaseballLeagueApi.md#baseballleagues_get) | **GET** /baseballleagues | List all instances of BaseballLeague
*BaseballLeagueApi* | [**baseballleagues_id_get**](docs/BaseballLeagueApi.md#baseballleagues_id_get) | **GET** /baseballleagues/{id} | Get a single BaseballLeague by its id
*BaseballPlayerApi* | [**baseballplayers_get**](docs/BaseballPlayerApi.md#baseballplayers_get) | **GET** /baseballplayers | List all instances of BaseballPlayer
*BaseballPlayerApi* | [**baseballplayers_id_get**](docs/BaseballPlayerApi.md#baseballplayers_id_get) | **GET** /baseballplayers/{id} | Get a single BaseballPlayer by its id
*BaseballSeasonApi* | [**baseballseasons_get**](docs/BaseballSeasonApi.md#baseballseasons_get) | **GET** /baseballseasons | List all instances of BaseballSeason
*BaseballSeasonApi* | [**baseballseasons_id_get**](docs/BaseballSeasonApi.md#baseballseasons_id_get) | **GET** /baseballseasons/{id} | Get a single BaseballSeason by its id
*BaseballTeamApi* | [**baseballteams_get**](docs/BaseballTeamApi.md#baseballteams_get) | **GET** /baseballteams | List all instances of BaseballTeam
*BaseballTeamApi* | [**baseballteams_id_get**](docs/BaseballTeamApi.md#baseballteams_id_get) | **GET** /baseballteams/{id} | Get a single BaseballTeam by its id
*BasketballLeagueApi* | [**basketballleagues_get**](docs/BasketballLeagueApi.md#basketballleagues_get) | **GET** /basketballleagues | List all instances of BasketballLeague
*BasketballLeagueApi* | [**basketballleagues_id_get**](docs/BasketballLeagueApi.md#basketballleagues_id_get) | **GET** /basketballleagues/{id} | Get a single BasketballLeague by its id
*BasketballPlayerApi* | [**basketballplayers_get**](docs/BasketballPlayerApi.md#basketballplayers_get) | **GET** /basketballplayers | List all instances of BasketballPlayer
*BasketballPlayerApi* | [**basketballplayers_id_get**](docs/BasketballPlayerApi.md#basketballplayers_id_get) | **GET** /basketballplayers/{id} | Get a single BasketballPlayer by its id
*BasketballTeamApi* | [**basketballteams_get**](docs/BasketballTeamApi.md#basketballteams_get) | **GET** /basketballteams | List all instances of BasketballTeam
*BasketballTeamApi* | [**basketballteams_id_get**](docs/BasketballTeamApi.md#basketballteams_id_get) | **GET** /basketballteams/{id} | Get a single BasketballTeam by its id
*BeachVolleyballPlayerApi* | [**beachvolleyballplayers_get**](docs/BeachVolleyballPlayerApi.md#beachvolleyballplayers_get) | **GET** /beachvolleyballplayers | List all instances of BeachVolleyballPlayer
*BeachVolleyballPlayerApi* | [**beachvolleyballplayers_id_get**](docs/BeachVolleyballPlayerApi.md#beachvolleyballplayers_id_get) | **GET** /beachvolleyballplayers/{id} | Get a single BeachVolleyballPlayer by its id
*BeautyQueenApi* | [**beautyqueens_get**](docs/BeautyQueenApi.md#beautyqueens_get) | **GET** /beautyqueens | List all instances of BeautyQueen
*BeautyQueenApi* | [**beautyqueens_id_get**](docs/BeautyQueenApi.md#beautyqueens_id_get) | **GET** /beautyqueens/{id} | Get a single BeautyQueen by its id
*BeerApi* | [**beers_get**](docs/BeerApi.md#beers_get) | **GET** /beers | List all instances of Beer
*BeerApi* | [**beers_id_get**](docs/BeerApi.md#beers_id_get) | **GET** /beers/{id} | Get a single Beer by its id
*BelgiumSettlementApi* | [**belgiumsettlements_get**](docs/BelgiumSettlementApi.md#belgiumsettlements_get) | **GET** /belgiumsettlements | List all instances of BelgiumSettlement
*BelgiumSettlementApi* | [**belgiumsettlements_id_get**](docs/BelgiumSettlementApi.md#belgiumsettlements_id_get) | **GET** /belgiumsettlements/{id} | Get a single BelgiumSettlement by its id
*BeverageApi* | [**beverages_get**](docs/BeverageApi.md#beverages_get) | **GET** /beverages | List all instances of Beverage
*BeverageApi* | [**beverages_id_get**](docs/BeverageApi.md#beverages_id_get) | **GET** /beverages/{id} | Get a single Beverage by its id
*BiologicalDatabaseApi* | [**biologicaldatabases_get**](docs/BiologicalDatabaseApi.md#biologicaldatabases_get) | **GET** /biologicaldatabases | List all instances of BiologicalDatabase
*BiologicalDatabaseApi* | [**biologicaldatabases_id_get**](docs/BiologicalDatabaseApi.md#biologicaldatabases_id_get) | **GET** /biologicaldatabases/{id} | Get a single BiologicalDatabase by its id
*BiomoleculeApi* | [**biomolecules_get**](docs/BiomoleculeApi.md#biomolecules_get) | **GET** /biomolecules | List all instances of Biomolecule
*BiomoleculeApi* | [**biomolecules_id_get**](docs/BiomoleculeApi.md#biomolecules_id_get) | **GET** /biomolecules/{id} | Get a single Biomolecule by its id
*BirdApi* | [**birds_get**](docs/BirdApi.md#birds_get) | **GET** /birds | List all instances of Bird
*BirdApi* | [**birds_id_get**](docs/BirdApi.md#birds_id_get) | **GET** /birds/{id} | Get a single Bird by its id
*BirthApi* | [**births_get**](docs/BirthApi.md#births_get) | **GET** /births | List all instances of Birth
*BirthApi* | [**births_id_get**](docs/BirthApi.md#births_id_get) | **GET** /births/{id} | Get a single Birth by its id
*BlazonApi* | [**blazons_get**](docs/BlazonApi.md#blazons_get) | **GET** /blazons | List all instances of Blazon
*BlazonApi* | [**blazons_id_get**](docs/BlazonApi.md#blazons_id_get) | **GET** /blazons/{id} | Get a single Blazon by its id
*BoardGameApi* | [**boardgames_get**](docs/BoardGameApi.md#boardgames_get) | **GET** /boardgames | List all instances of BoardGame
*BoardGameApi* | [**boardgames_id_get**](docs/BoardGameApi.md#boardgames_id_get) | **GET** /boardgames/{id} | Get a single BoardGame by its id
*BodyOfWaterApi* | [**bodyofwaters_get**](docs/BodyOfWaterApi.md#bodyofwaters_get) | **GET** /bodyofwaters | List all instances of BodyOfWater
*BodyOfWaterApi* | [**bodyofwaters_id_get**](docs/BodyOfWaterApi.md#bodyofwaters_id_get) | **GET** /bodyofwaters/{id} | Get a single BodyOfWater by its id
*BodybuilderApi* | [**bodybuilders_get**](docs/BodybuilderApi.md#bodybuilders_get) | **GET** /bodybuilders | List all instances of Bodybuilder
*BodybuilderApi* | [**bodybuilders_id_get**](docs/BodybuilderApi.md#bodybuilders_id_get) | **GET** /bodybuilders/{id} | Get a single Bodybuilder by its id
*BoneApi* | [**bones_get**](docs/BoneApi.md#bones_get) | **GET** /bones | List all instances of Bone
*BoneApi* | [**bones_id_get**](docs/BoneApi.md#bones_id_get) | **GET** /bones/{id} | Get a single Bone by its id
*BookApi* | [**books_get**](docs/BookApi.md#books_get) | **GET** /books | List all instances of Book
*BookApi* | [**books_id_get**](docs/BookApi.md#books_id_get) | **GET** /books/{id} | Get a single Book by its id
*BowlingLeagueApi* | [**bowlingleagues_get**](docs/BowlingLeagueApi.md#bowlingleagues_get) | **GET** /bowlingleagues | List all instances of BowlingLeague
*BowlingLeagueApi* | [**bowlingleagues_id_get**](docs/BowlingLeagueApi.md#bowlingleagues_id_get) | **GET** /bowlingleagues/{id} | Get a single BowlingLeague by its id
*BoxerApi* | [**boxers_get**](docs/BoxerApi.md#boxers_get) | **GET** /boxers | List all instances of Boxer
*BoxerApi* | [**boxers_id_get**](docs/BoxerApi.md#boxers_id_get) | **GET** /boxers/{id} | Get a single Boxer by its id
*BoxingApi* | [**boxings_get**](docs/BoxingApi.md#boxings_get) | **GET** /boxings | List all instances of Boxing
*BoxingApi* | [**boxings_id_get**](docs/BoxingApi.md#boxings_id_get) | **GET** /boxings/{id} | Get a single Boxing by its id
*BoxingCategoryApi* | [**boxingcategorys_get**](docs/BoxingCategoryApi.md#boxingcategorys_get) | **GET** /boxingcategorys | List all instances of BoxingCategory
*BoxingCategoryApi* | [**boxingcategorys_id_get**](docs/BoxingCategoryApi.md#boxingcategorys_id_get) | **GET** /boxingcategorys/{id} | Get a single BoxingCategory by its id
*BoxingLeagueApi* | [**boxingleagues_get**](docs/BoxingLeagueApi.md#boxingleagues_get) | **GET** /boxingleagues | List all instances of BoxingLeague
*BoxingLeagueApi* | [**boxingleagues_id_get**](docs/BoxingLeagueApi.md#boxingleagues_id_get) | **GET** /boxingleagues/{id} | Get a single BoxingLeague by its id
*BoxingStyleApi* | [**boxingstyles_get**](docs/BoxingStyleApi.md#boxingstyles_get) | **GET** /boxingstyles | List all instances of BoxingStyle
*BoxingStyleApi* | [**boxingstyles_id_get**](docs/BoxingStyleApi.md#boxingstyles_id_get) | **GET** /boxingstyles/{id} | Get a single BoxingStyle by its id
*BrainApi* | [**brains_get**](docs/BrainApi.md#brains_get) | **GET** /brains | List all instances of Brain
*BrainApi* | [**brains_id_get**](docs/BrainApi.md#brains_id_get) | **GET** /brains/{id} | Get a single Brain by its id
*BreweryApi* | [**brewerys_get**](docs/BreweryApi.md#brewerys_get) | **GET** /brewerys | List all instances of Brewery
*BreweryApi* | [**brewerys_id_get**](docs/BreweryApi.md#brewerys_id_get) | **GET** /brewerys/{id} | Get a single Brewery by its id
*BridgeApi* | [**bridges_get**](docs/BridgeApi.md#bridges_get) | **GET** /bridges | List all instances of Bridge
*BridgeApi* | [**bridges_id_get**](docs/BridgeApi.md#bridges_id_get) | **GET** /bridges/{id} | Get a single Bridge by its id
*BritishRoyaltyApi* | [**britishroyaltys_get**](docs/BritishRoyaltyApi.md#britishroyaltys_get) | **GET** /britishroyaltys | List all instances of BritishRoyalty
*BritishRoyaltyApi* | [**britishroyaltys_id_get**](docs/BritishRoyaltyApi.md#britishroyaltys_id_get) | **GET** /britishroyaltys/{id} | Get a single BritishRoyalty by its id
*BroadcastNetworkApi* | [**broadcastnetworks_get**](docs/BroadcastNetworkApi.md#broadcastnetworks_get) | **GET** /broadcastnetworks | List all instances of BroadcastNetwork
*BroadcastNetworkApi* | [**broadcastnetworks_id_get**](docs/BroadcastNetworkApi.md#broadcastnetworks_id_get) | **GET** /broadcastnetworks/{id} | Get a single BroadcastNetwork by its id
*BroadcasterApi* | [**broadcasters_get**](docs/BroadcasterApi.md#broadcasters_get) | **GET** /broadcasters | List all instances of Broadcaster
*BroadcasterApi* | [**broadcasters_id_get**](docs/BroadcasterApi.md#broadcasters_id_get) | **GET** /broadcasters/{id} | Get a single Broadcaster by its id
*BrownDwarfApi* | [**browndwarfs_get**](docs/BrownDwarfApi.md#browndwarfs_get) | **GET** /browndwarfs | List all instances of BrownDwarf
*BrownDwarfApi* | [**browndwarfs_id_get**](docs/BrownDwarfApi.md#browndwarfs_id_get) | **GET** /browndwarfs/{id} | Get a single BrownDwarf by its id
*BuildingApi* | [**buildings_get**](docs/BuildingApi.md#buildings_get) | **GET** /buildings | List all instances of Building
*BuildingApi* | [**buildings_id_get**](docs/BuildingApi.md#buildings_id_get) | **GET** /buildings/{id} | Get a single Building by its id
*BullfighterApi* | [**bullfighters_get**](docs/BullfighterApi.md#bullfighters_get) | **GET** /bullfighters | List all instances of Bullfighter
*BullfighterApi* | [**bullfighters_id_get**](docs/BullfighterApi.md#bullfighters_id_get) | **GET** /bullfighters/{id} | Get a single Bullfighter by its id
*BusCompanyApi* | [**buscompanys_get**](docs/BusCompanyApi.md#buscompanys_get) | **GET** /buscompanys | List all instances of BusCompany
*BusCompanyApi* | [**buscompanys_id_get**](docs/BusCompanyApi.md#buscompanys_id_get) | **GET** /buscompanys/{id} | Get a single BusCompany by its id
*BusinessPersonApi* | [**businesspersons_get**](docs/BusinessPersonApi.md#businesspersons_get) | **GET** /businesspersons | List all instances of BusinessPerson
*BusinessPersonApi* | [**businesspersons_id_get**](docs/BusinessPersonApi.md#businesspersons_id_get) | **GET** /businesspersons/{id} | Get a single BusinessPerson by its id
*CameraApi* | [**cameras_get**](docs/CameraApi.md#cameras_get) | **GET** /cameras | List all instances of Camera
*CameraApi* | [**cameras_id_get**](docs/CameraApi.md#cameras_id_get) | **GET** /cameras/{id} | Get a single Camera by its id
*CanadianFootballLeagueApi* | [**canadianfootballleagues_get**](docs/CanadianFootballLeagueApi.md#canadianfootballleagues_get) | **GET** /canadianfootballleagues | List all instances of CanadianFootballLeague
*CanadianFootballLeagueApi* | [**canadianfootballleagues_id_get**](docs/CanadianFootballLeagueApi.md#canadianfootballleagues_id_get) | **GET** /canadianfootballleagues/{id} | Get a single CanadianFootballLeague by its id
*CanadianFootballPlayerApi* | [**canadianfootballplayers_get**](docs/CanadianFootballPlayerApi.md#canadianfootballplayers_get) | **GET** /canadianfootballplayers | List all instances of CanadianFootballPlayer
*CanadianFootballPlayerApi* | [**canadianfootballplayers_id_get**](docs/CanadianFootballPlayerApi.md#canadianfootballplayers_id_get) | **GET** /canadianfootballplayers/{id} | Get a single CanadianFootballPlayer by its id
*CanadianFootballTeamApi* | [**canadianfootballteams_get**](docs/CanadianFootballTeamApi.md#canadianfootballteams_get) | **GET** /canadianfootballteams | List all instances of CanadianFootballTeam
*CanadianFootballTeamApi* | [**canadianfootballteams_id_get**](docs/CanadianFootballTeamApi.md#canadianfootballteams_id_get) | **GET** /canadianfootballteams/{id} | Get a single CanadianFootballTeam by its id
*CanalApi* | [**canals_get**](docs/CanalApi.md#canals_get) | **GET** /canals | List all instances of Canal
*CanalApi* | [**canals_id_get**](docs/CanalApi.md#canals_id_get) | **GET** /canals/{id} | Get a single Canal by its id
*CanoeistApi* | [**canoeists_get**](docs/CanoeistApi.md#canoeists_get) | **GET** /canoeists | List all instances of Canoeist
*CanoeistApi* | [**canoeists_id_get**](docs/CanoeistApi.md#canoeists_id_get) | **GET** /canoeists/{id} | Get a single Canoeist by its id
*CapitalApi* | [**capitals_get**](docs/CapitalApi.md#capitals_get) | **GET** /capitals | List all instances of Capital
*CapitalApi* | [**capitals_id_get**](docs/CapitalApi.md#capitals_id_get) | **GET** /capitals/{id} | Get a single Capital by its id
*CapitalOfRegionApi* | [**capitalofregions_get**](docs/CapitalOfRegionApi.md#capitalofregions_get) | **GET** /capitalofregions | List all instances of CapitalOfRegion
*CapitalOfRegionApi* | [**capitalofregions_id_get**](docs/CapitalOfRegionApi.md#capitalofregions_id_get) | **GET** /capitalofregions/{id} | Get a single CapitalOfRegion by its id
*CardinalApi* | [**cardinals_get**](docs/CardinalApi.md#cardinals_get) | **GET** /cardinals | List all instances of Cardinal
*CardinalApi* | [**cardinals_id_get**](docs/CardinalApi.md#cardinals_id_get) | **GET** /cardinals/{id} | Get a single Cardinal by its id
*CareerStationApi* | [**careerstations_get**](docs/CareerStationApi.md#careerstations_get) | **GET** /careerstations | List all instances of CareerStation
*CareerStationApi* | [**careerstations_id_get**](docs/CareerStationApi.md#careerstations_id_get) | **GET** /careerstations/{id} | Get a single CareerStation by its id
*CartoonApi* | [**cartoons_get**](docs/CartoonApi.md#cartoons_get) | **GET** /cartoons | List all instances of Cartoon
*CartoonApi* | [**cartoons_id_get**](docs/CartoonApi.md#cartoons_id_get) | **GET** /cartoons/{id} | Get a single Cartoon by its id
*CaseApi* | [**cases_get**](docs/CaseApi.md#cases_get) | **GET** /cases | List all instances of Case
*CaseApi* | [**cases_id_get**](docs/CaseApi.md#cases_id_get) | **GET** /cases/{id} | Get a single Case by its id
*CasinoApi* | [**casinos_get**](docs/CasinoApi.md#casinos_get) | **GET** /casinos | List all instances of Casino
*CasinoApi* | [**casinos_id_get**](docs/CasinoApi.md#casinos_id_get) | **GET** /casinos/{id} | Get a single Casino by its id
*CastleApi* | [**castles_get**](docs/CastleApi.md#castles_get) | **GET** /castles | List all instances of Castle
*CastleApi* | [**castles_id_get**](docs/CastleApi.md#castles_id_get) | **GET** /castles/{id} | Get a single Castle by its id
*CaveApi* | [**caves_get**](docs/CaveApi.md#caves_get) | **GET** /caves | List all instances of Cave
*CaveApi* | [**caves_id_get**](docs/CaveApi.md#caves_id_get) | **GET** /caves/{id} | Get a single Cave by its id
*CelebrityApi* | [**celebritys_get**](docs/CelebrityApi.md#celebritys_get) | **GET** /celebritys | List all instances of Celebrity
*CelebrityApi* | [**celebritys_id_get**](docs/CelebrityApi.md#celebritys_id_get) | **GET** /celebritys/{id} | Get a single Celebrity by its id
*CelestialBodyApi* | [**celestialbodys_get**](docs/CelestialBodyApi.md#celestialbodys_get) | **GET** /celestialbodys | List all instances of CelestialBody
*CelestialBodyApi* | [**celestialbodys_id_get**](docs/CelestialBodyApi.md#celestialbodys_id_get) | **GET** /celestialbodys/{id} | Get a single CelestialBody by its id
*CemeteryApi* | [**cemeterys_get**](docs/CemeteryApi.md#cemeterys_get) | **GET** /cemeterys | List all instances of Cemetery
*CemeteryApi* | [**cemeterys_id_get**](docs/CemeteryApi.md#cemeterys_id_get) | **GET** /cemeterys/{id} | Get a single Cemetery by its id
*ChancellorApi* | [**chancellors_get**](docs/ChancellorApi.md#chancellors_get) | **GET** /chancellors | List all instances of Chancellor
*ChancellorApi* | [**chancellors_id_get**](docs/ChancellorApi.md#chancellors_id_get) | **GET** /chancellors/{id} | Get a single Chancellor by its id
*ChartsPlacementsApi* | [**chartsplacementss_get**](docs/ChartsPlacementsApi.md#chartsplacementss_get) | **GET** /chartsplacementss | List all instances of ChartsPlacements
*ChartsPlacementsApi* | [**chartsplacementss_id_get**](docs/ChartsPlacementsApi.md#chartsplacementss_id_get) | **GET** /chartsplacementss/{id} | Get a single ChartsPlacements by its id
*CheeseApi* | [**cheeses_get**](docs/CheeseApi.md#cheeses_get) | **GET** /cheeses | List all instances of Cheese
*CheeseApi* | [**cheeses_id_get**](docs/CheeseApi.md#cheeses_id_get) | **GET** /cheeses/{id} | Get a single Cheese by its id
*ChefApi* | [**chefs_get**](docs/ChefApi.md#chefs_get) | **GET** /chefs | List all instances of Chef
*ChefApi* | [**chefs_id_get**](docs/ChefApi.md#chefs_id_get) | **GET** /chefs/{id} | Get a single Chef by its id
*ChemicalCompoundApi* | [**chemicalcompounds_get**](docs/ChemicalCompoundApi.md#chemicalcompounds_get) | **GET** /chemicalcompounds | List all instances of ChemicalCompound
*ChemicalCompoundApi* | [**chemicalcompounds_id_get**](docs/ChemicalCompoundApi.md#chemicalcompounds_id_get) | **GET** /chemicalcompounds/{id} | Get a single ChemicalCompound by its id
*ChemicalElementApi* | [**chemicalelements_get**](docs/ChemicalElementApi.md#chemicalelements_get) | **GET** /chemicalelements | List all instances of ChemicalElement
*ChemicalElementApi* | [**chemicalelements_id_get**](docs/ChemicalElementApi.md#chemicalelements_id_get) | **GET** /chemicalelements/{id} | Get a single ChemicalElement by its id
*ChemicalSubstanceApi* | [**chemicalsubstances_get**](docs/ChemicalSubstanceApi.md#chemicalsubstances_get) | **GET** /chemicalsubstances | List all instances of ChemicalSubstance
*ChemicalSubstanceApi* | [**chemicalsubstances_id_get**](docs/ChemicalSubstanceApi.md#chemicalsubstances_id_get) | **GET** /chemicalsubstances/{id} | Get a single ChemicalSubstance by its id
*ChessPlayerApi* | [**chessplayers_get**](docs/ChessPlayerApi.md#chessplayers_get) | **GET** /chessplayers | List all instances of ChessPlayer
*ChessPlayerApi* | [**chessplayers_id_get**](docs/ChessPlayerApi.md#chessplayers_id_get) | **GET** /chessplayers/{id} | Get a single ChessPlayer by its id
*ChristianBishopApi* | [**christianbishops_get**](docs/ChristianBishopApi.md#christianbishops_get) | **GET** /christianbishops | List all instances of ChristianBishop
*ChristianBishopApi* | [**christianbishops_id_get**](docs/ChristianBishopApi.md#christianbishops_id_get) | **GET** /christianbishops/{id} | Get a single ChristianBishop by its id
*ChristianDoctrineApi* | [**christiandoctrines_get**](docs/ChristianDoctrineApi.md#christiandoctrines_get) | **GET** /christiandoctrines | List all instances of ChristianDoctrine
*ChristianDoctrineApi* | [**christiandoctrines_id_get**](docs/ChristianDoctrineApi.md#christiandoctrines_id_get) | **GET** /christiandoctrines/{id} | Get a single ChristianDoctrine by its id
*ChristianPatriarchApi* | [**christianpatriarchs_get**](docs/ChristianPatriarchApi.md#christianpatriarchs_get) | **GET** /christianpatriarchs | List all instances of ChristianPatriarch
*ChristianPatriarchApi* | [**christianpatriarchs_id_get**](docs/ChristianPatriarchApi.md#christianpatriarchs_id_get) | **GET** /christianpatriarchs/{id} | Get a single ChristianPatriarch by its id
*ChurchApi* | [**churchs_get**](docs/ChurchApi.md#churchs_get) | **GET** /churchs | List all instances of Church
*ChurchApi* | [**churchs_id_get**](docs/ChurchApi.md#churchs_id_get) | **GET** /churchs/{id} | Get a single Church by its id
*CityApi* | [**citys_get**](docs/CityApi.md#citys_get) | **GET** /citys | List all instances of City
*CityApi* | [**citys_id_get**](docs/CityApi.md#citys_id_get) | **GET** /citys/{id} | Get a single City by its id
*CityDistrictApi* | [**citydistricts_get**](docs/CityDistrictApi.md#citydistricts_get) | **GET** /citydistricts | List all instances of CityDistrict
*CityDistrictApi* | [**citydistricts_id_get**](docs/CityDistrictApi.md#citydistricts_id_get) | **GET** /citydistricts/{id} | Get a single CityDistrict by its id
*ClassicalMusicArtistApi* | [**classicalmusicartists_get**](docs/ClassicalMusicArtistApi.md#classicalmusicartists_get) | **GET** /classicalmusicartists | List all instances of ClassicalMusicArtist
*ClassicalMusicArtistApi* | [**classicalmusicartists_id_get**](docs/ClassicalMusicArtistApi.md#classicalmusicartists_id_get) | **GET** /classicalmusicartists/{id} | Get a single ClassicalMusicArtist by its id
*ClassicalMusicCompositionApi* | [**classicalmusiccompositions_get**](docs/ClassicalMusicCompositionApi.md#classicalmusiccompositions_get) | **GET** /classicalmusiccompositions | List all instances of ClassicalMusicComposition
*ClassicalMusicCompositionApi* | [**classicalmusiccompositions_id_get**](docs/ClassicalMusicCompositionApi.md#classicalmusiccompositions_id_get) | **GET** /classicalmusiccompositions/{id} | Get a single ClassicalMusicComposition by its id
*ClericApi* | [**clerics_get**](docs/ClericApi.md#clerics_get) | **GET** /clerics | List all instances of Cleric
*ClericApi* | [**clerics_id_get**](docs/ClericApi.md#clerics_id_get) | **GET** /clerics/{id} | Get a single Cleric by its id
*ClericalAdministrativeRegionApi* | [**clericaladministrativeregions_get**](docs/ClericalAdministrativeRegionApi.md#clericaladministrativeregions_get) | **GET** /clericaladministrativeregions | List all instances of ClericalAdministrativeRegion
*ClericalAdministrativeRegionApi* | [**clericaladministrativeregions_id_get**](docs/ClericalAdministrativeRegionApi.md#clericaladministrativeregions_id_get) | **GET** /clericaladministrativeregions/{id} | Get a single ClericalAdministrativeRegion by its id
*ClericalOrderApi* | [**clericalorders_get**](docs/ClericalOrderApi.md#clericalorders_get) | **GET** /clericalorders | List all instances of ClericalOrder
*ClericalOrderApi* | [**clericalorders_id_get**](docs/ClericalOrderApi.md#clericalorders_id_get) | **GET** /clericalorders/{id} | Get a single ClericalOrder by its id
*ClubMossApi* | [**clubmosss_get**](docs/ClubMossApi.md#clubmosss_get) | **GET** /clubmosss | List all instances of ClubMoss
*ClubMossApi* | [**clubmosss_id_get**](docs/ClubMossApi.md#clubmosss_id_get) | **GET** /clubmosss/{id} | Get a single ClubMoss by its id
*CoachApi* | [**coachs_get**](docs/CoachApi.md#coachs_get) | **GET** /coachs | List all instances of Coach
*CoachApi* | [**coachs_id_get**](docs/CoachApi.md#coachs_id_get) | **GET** /coachs/{id} | Get a single Coach by its id
*CollectionOfValuablesApi* | [**collectionofvaluabless_get**](docs/CollectionOfValuablesApi.md#collectionofvaluabless_get) | **GET** /collectionofvaluabless | List all instances of CollectionOfValuables
*CollectionOfValuablesApi* | [**collectionofvaluabless_id_get**](docs/CollectionOfValuablesApi.md#collectionofvaluabless_id_get) | **GET** /collectionofvaluabless/{id} | Get a single CollectionOfValuables by its id
*CollegeApi* | [**colleges_get**](docs/CollegeApi.md#colleges_get) | **GET** /colleges | List all instances of College
*CollegeApi* | [**colleges_id_get**](docs/CollegeApi.md#colleges_id_get) | **GET** /colleges/{id} | Get a single College by its id
*CollegeCoachApi* | [**collegecoachs_get**](docs/CollegeCoachApi.md#collegecoachs_get) | **GET** /collegecoachs | List all instances of CollegeCoach
*CollegeCoachApi* | [**collegecoachs_id_get**](docs/CollegeCoachApi.md#collegecoachs_id_get) | **GET** /collegecoachs/{id} | Get a single CollegeCoach by its id
*ColourApi* | [**colours_get**](docs/ColourApi.md#colours_get) | **GET** /colours | List all instances of Colour
*ColourApi* | [**colours_id_get**](docs/ColourApi.md#colours_id_get) | **GET** /colours/{id} | Get a single Colour by its id
*ComedianApi* | [**comedians_get**](docs/ComedianApi.md#comedians_get) | **GET** /comedians | List all instances of Comedian
*ComedianApi* | [**comedians_id_get**](docs/ComedianApi.md#comedians_id_get) | **GET** /comedians/{id} | Get a single Comedian by its id
*ComedyGroupApi* | [**comedygroups_get**](docs/ComedyGroupApi.md#comedygroups_get) | **GET** /comedygroups | List all instances of ComedyGroup
*ComedyGroupApi* | [**comedygroups_id_get**](docs/ComedyGroupApi.md#comedygroups_id_get) | **GET** /comedygroups/{id} | Get a single ComedyGroup by its id
*ComicApi* | [**comics_get**](docs/ComicApi.md#comics_get) | **GET** /comics | List all instances of Comic
*ComicApi* | [**comics_id_get**](docs/ComicApi.md#comics_id_get) | **GET** /comics/{id} | Get a single Comic by its id
*ComicStripApi* | [**comicstrips_get**](docs/ComicStripApi.md#comicstrips_get) | **GET** /comicstrips | List all instances of ComicStrip
*ComicStripApi* | [**comicstrips_id_get**](docs/ComicStripApi.md#comicstrips_id_get) | **GET** /comicstrips/{id} | Get a single ComicStrip by its id
*ComicsApi* | [**comicss_get**](docs/ComicsApi.md#comicss_get) | **GET** /comicss | List all instances of Comics
*ComicsApi* | [**comicss_id_get**](docs/ComicsApi.md#comicss_id_get) | **GET** /comicss/{id} | Get a single Comics by its id
*ComicsCharacterApi* | [**comicscharacters_get**](docs/ComicsCharacterApi.md#comicscharacters_get) | **GET** /comicscharacters | List all instances of ComicsCharacter
*ComicsCharacterApi* | [**comicscharacters_id_get**](docs/ComicsCharacterApi.md#comicscharacters_id_get) | **GET** /comicscharacters/{id} | Get a single ComicsCharacter by its id
*ComicsCreatorApi* | [**comicscreators_get**](docs/ComicsCreatorApi.md#comicscreators_get) | **GET** /comicscreators | List all instances of ComicsCreator
*ComicsCreatorApi* | [**comicscreators_id_get**](docs/ComicsCreatorApi.md#comicscreators_id_get) | **GET** /comicscreators/{id} | Get a single ComicsCreator by its id
*CommunityApi* | [**communitys_get**](docs/CommunityApi.md#communitys_get) | **GET** /communitys | List all instances of Community
*CommunityApi* | [**communitys_id_get**](docs/CommunityApi.md#communitys_id_get) | **GET** /communitys/{id} | Get a single Community by its id
*CompanyApi* | [**companys_get**](docs/CompanyApi.md#companys_get) | **GET** /companys | List all instances of Company
*CompanyApi* | [**companys_id_get**](docs/CompanyApi.md#companys_id_get) | **GET** /companys/{id} | Get a single Company by its id
*CompetitionApi* | [**competitions_get**](docs/CompetitionApi.md#competitions_get) | **GET** /competitions | List all instances of Competition
*CompetitionApi* | [**competitions_id_get**](docs/CompetitionApi.md#competitions_id_get) | **GET** /competitions/{id} | Get a single Competition by its id
*CongressmanApi* | [**congressmans_get**](docs/CongressmanApi.md#congressmans_get) | **GET** /congressmans | List all instances of Congressman
*CongressmanApi* | [**congressmans_id_get**](docs/CongressmanApi.md#congressmans_id_get) | **GET** /congressmans/{id} | Get a single Congressman by its id
*ConiferApi* | [**conifers_get**](docs/ConiferApi.md#conifers_get) | **GET** /conifers | List all instances of Conifer
*ConiferApi* | [**conifers_id_get**](docs/ConiferApi.md#conifers_id_get) | **GET** /conifers/{id} | Get a single Conifer by its id
*ConstellationApi* | [**constellations_get**](docs/ConstellationApi.md#constellations_get) | **GET** /constellations | List all instances of Constellation
*ConstellationApi* | [**constellations_id_get**](docs/ConstellationApi.md#constellations_id_get) | **GET** /constellations/{id} | Get a single Constellation by its id
*ContestApi* | [**contests_get**](docs/ContestApi.md#contests_get) | **GET** /contests | List all instances of Contest
*ContestApi* | [**contests_id_get**](docs/ContestApi.md#contests_id_get) | **GET** /contests/{id} | Get a single Contest by its id
*ContinentApi* | [**continents_get**](docs/ContinentApi.md#continents_get) | **GET** /continents | List all instances of Continent
*ContinentApi* | [**continents_id_get**](docs/ContinentApi.md#continents_id_get) | **GET** /continents/{id} | Get a single Continent by its id
*ControlledDesignationOfOriginWineApi* | [**controlleddesignationoforiginwines_get**](docs/ControlledDesignationOfOriginWineApi.md#controlleddesignationoforiginwines_get) | **GET** /controlleddesignationoforiginwines | List all instances of ControlledDesignationOfOriginWine
*ControlledDesignationOfOriginWineApi* | [**controlleddesignationoforiginwines_id_get**](docs/ControlledDesignationOfOriginWineApi.md#controlleddesignationoforiginwines_id_get) | **GET** /controlleddesignationoforiginwines/{id} | Get a single ControlledDesignationOfOriginWine by its id
*ConventionApi* | [**conventions_get**](docs/ConventionApi.md#conventions_get) | **GET** /conventions | List all instances of Convention
*ConventionApi* | [**conventions_id_get**](docs/ConventionApi.md#conventions_id_get) | **GET** /conventions/{id} | Get a single Convention by its id
*CountryApi* | [**countrys_get**](docs/CountryApi.md#countrys_get) | **GET** /countrys | List all instances of Country
*CountryApi* | [**countrys_id_get**](docs/CountryApi.md#countrys_id_get) | **GET** /countrys/{id} | Get a single Country by its id
*CountrySeatApi* | [**countryseats_get**](docs/CountrySeatApi.md#countryseats_get) | **GET** /countryseats | List all instances of CountrySeat
*CountrySeatApi* | [**countryseats_id_get**](docs/CountrySeatApi.md#countryseats_id_get) | **GET** /countryseats/{id} | Get a single CountrySeat by its id
*CraterApi* | [**craters_get**](docs/CraterApi.md#craters_get) | **GET** /craters | List all instances of Crater
*CraterApi* | [**craters_id_get**](docs/CraterApi.md#craters_id_get) | **GET** /craters/{id} | Get a single Crater by its id
*CricketGroundApi* | [**cricketgrounds_get**](docs/CricketGroundApi.md#cricketgrounds_get) | **GET** /cricketgrounds | List all instances of CricketGround
*CricketGroundApi* | [**cricketgrounds_id_get**](docs/CricketGroundApi.md#cricketgrounds_id_get) | **GET** /cricketgrounds/{id} | Get a single CricketGround by its id
*CricketLeagueApi* | [**cricketleagues_get**](docs/CricketLeagueApi.md#cricketleagues_get) | **GET** /cricketleagues | List all instances of CricketLeague
*CricketLeagueApi* | [**cricketleagues_id_get**](docs/CricketLeagueApi.md#cricketleagues_id_get) | **GET** /cricketleagues/{id} | Get a single CricketLeague by its id
*CricketTeamApi* | [**cricketteams_get**](docs/CricketTeamApi.md#cricketteams_get) | **GET** /cricketteams | List all instances of CricketTeam
*CricketTeamApi* | [**cricketteams_id_get**](docs/CricketTeamApi.md#cricketteams_id_get) | **GET** /cricketteams/{id} | Get a single CricketTeam by its id
*CricketerApi* | [**cricketers_get**](docs/CricketerApi.md#cricketers_get) | **GET** /cricketers | List all instances of Cricketer
*CricketerApi* | [**cricketers_id_get**](docs/CricketerApi.md#cricketers_id_get) | **GET** /cricketers/{id} | Get a single Cricketer by its id
*CriminalApi* | [**criminals_get**](docs/CriminalApi.md#criminals_get) | **GET** /criminals | List all instances of Criminal
*CriminalApi* | [**criminals_id_get**](docs/CriminalApi.md#criminals_id_get) | **GET** /criminals/{id} | Get a single Criminal by its id
*CrustaceanApi* | [**crustaceans_get**](docs/CrustaceanApi.md#crustaceans_get) | **GET** /crustaceans | List all instances of Crustacean
*CrustaceanApi* | [**crustaceans_id_get**](docs/CrustaceanApi.md#crustaceans_id_get) | **GET** /crustaceans/{id} | Get a single Crustacean by its id
*CultivatedVarietyApi* | [**cultivatedvarietys_get**](docs/CultivatedVarietyApi.md#cultivatedvarietys_get) | **GET** /cultivatedvarietys | List all instances of CultivatedVariety
*CultivatedVarietyApi* | [**cultivatedvarietys_id_get**](docs/CultivatedVarietyApi.md#cultivatedvarietys_id_get) | **GET** /cultivatedvarietys/{id} | Get a single CultivatedVariety by its id
*CurlerApi* | [**curlers_get**](docs/CurlerApi.md#curlers_get) | **GET** /curlers | List all instances of Curler
*CurlerApi* | [**curlers_id_get**](docs/CurlerApi.md#curlers_id_get) | **GET** /curlers/{id} | Get a single Curler by its id
*CurlingLeagueApi* | [**curlingleagues_get**](docs/CurlingLeagueApi.md#curlingleagues_get) | **GET** /curlingleagues | List all instances of CurlingLeague
*CurlingLeagueApi* | [**curlingleagues_id_get**](docs/CurlingLeagueApi.md#curlingleagues_id_get) | **GET** /curlingleagues/{id} | Get a single CurlingLeague by its id
*CurrencyApi* | [**currencys_get**](docs/CurrencyApi.md#currencys_get) | **GET** /currencys | List all instances of Currency
*CurrencyApi* | [**currencys_id_get**](docs/CurrencyApi.md#currencys_id_get) | **GET** /currencys/{id} | Get a single Currency by its id
*CycadApi* | [**cycads_get**](docs/CycadApi.md#cycads_get) | **GET** /cycads | List all instances of Cycad
*CycadApi* | [**cycads_id_get**](docs/CycadApi.md#cycads_id_get) | **GET** /cycads/{id} | Get a single Cycad by its id
*CyclingCompetitionApi* | [**cyclingcompetitions_get**](docs/CyclingCompetitionApi.md#cyclingcompetitions_get) | **GET** /cyclingcompetitions | List all instances of CyclingCompetition
*CyclingCompetitionApi* | [**cyclingcompetitions_id_get**](docs/CyclingCompetitionApi.md#cyclingcompetitions_id_get) | **GET** /cyclingcompetitions/{id} | Get a single CyclingCompetition by its id
*CyclingLeagueApi* | [**cyclingleagues_get**](docs/CyclingLeagueApi.md#cyclingleagues_get) | **GET** /cyclingleagues | List all instances of CyclingLeague
*CyclingLeagueApi* | [**cyclingleagues_id_get**](docs/CyclingLeagueApi.md#cyclingleagues_id_get) | **GET** /cyclingleagues/{id} | Get a single CyclingLeague by its id
*CyclingRaceApi* | [**cyclingraces_get**](docs/CyclingRaceApi.md#cyclingraces_get) | **GET** /cyclingraces | List all instances of CyclingRace
*CyclingRaceApi* | [**cyclingraces_id_get**](docs/CyclingRaceApi.md#cyclingraces_id_get) | **GET** /cyclingraces/{id} | Get a single CyclingRace by its id
*CyclingTeamApi* | [**cyclingteams_get**](docs/CyclingTeamApi.md#cyclingteams_get) | **GET** /cyclingteams | List all instances of CyclingTeam
*CyclingTeamApi* | [**cyclingteams_id_get**](docs/CyclingTeamApi.md#cyclingteams_id_get) | **GET** /cyclingteams/{id} | Get a single CyclingTeam by its id
*CyclistApi* | [**cyclists_get**](docs/CyclistApi.md#cyclists_get) | **GET** /cyclists | List all instances of Cyclist
*CyclistApi* | [**cyclists_id_get**](docs/CyclistApi.md#cyclists_id_get) | **GET** /cyclists/{id} | Get a single Cyclist by its id
*DamApi* | [**dams_get**](docs/DamApi.md#dams_get) | **GET** /dams | List all instances of Dam
*DamApi* | [**dams_id_get**](docs/DamApi.md#dams_id_get) | **GET** /dams/{id} | Get a single Dam by its id
*DancerApi* | [**dancers_get**](docs/DancerApi.md#dancers_get) | **GET** /dancers | List all instances of Dancer
*DancerApi* | [**dancers_id_get**](docs/DancerApi.md#dancers_id_get) | **GET** /dancers/{id} | Get a single Dancer by its id
*DartsPlayerApi* | [**dartsplayers_get**](docs/DartsPlayerApi.md#dartsplayers_get) | **GET** /dartsplayers | List all instances of DartsPlayer
*DartsPlayerApi* | [**dartsplayers_id_get**](docs/DartsPlayerApi.md#dartsplayers_id_get) | **GET** /dartsplayers/{id} | Get a single DartsPlayer by its id
*DatabaseApi* | [**databases_get**](docs/DatabaseApi.md#databases_get) | **GET** /databases | List all instances of Database
*DatabaseApi* | [**databases_id_get**](docs/DatabaseApi.md#databases_id_get) | **GET** /databases/{id} | Get a single Database by its id
*DeaneryApi* | [**deanerys_get**](docs/DeaneryApi.md#deanerys_get) | **GET** /deanerys | List all instances of Deanery
*DeaneryApi* | [**deanerys_id_get**](docs/DeaneryApi.md#deanerys_id_get) | **GET** /deanerys/{id} | Get a single Deanery by its id
*DeathApi* | [**deaths_get**](docs/DeathApi.md#deaths_get) | **GET** /deaths | List all instances of Death
*DeathApi* | [**deaths_id_get**](docs/DeathApi.md#deaths_id_get) | **GET** /deaths/{id} | Get a single Death by its id
*DecorationApi* | [**decorations_get**](docs/DecorationApi.md#decorations_get) | **GET** /decorations | List all instances of Decoration
*DecorationApi* | [**decorations_id_get**](docs/DecorationApi.md#decorations_id_get) | **GET** /decorations/{id} | Get a single Decoration by its id
*DeityApi* | [**deitys_get**](docs/DeityApi.md#deitys_get) | **GET** /deitys | List all instances of Deity
*DeityApi* | [**deitys_id_get**](docs/DeityApi.md#deitys_id_get) | **GET** /deitys/{id} | Get a single Deity by its id
*DemographicsApi* | [**demographicss_get**](docs/DemographicsApi.md#demographicss_get) | **GET** /demographicss | List all instances of Demographics
*DemographicsApi* | [**demographicss_id_get**](docs/DemographicsApi.md#demographicss_id_get) | **GET** /demographicss/{id} | Get a single Demographics by its id
*DepartmentApi* | [**departments_get**](docs/DepartmentApi.md#departments_get) | **GET** /departments | List all instances of Department
*DepartmentApi* | [**departments_id_get**](docs/DepartmentApi.md#departments_id_get) | **GET** /departments/{id} | Get a single Department by its id
*DepthApi* | [**depths_get**](docs/DepthApi.md#depths_get) | **GET** /depths | List all instances of Depth
*DepthApi* | [**depths_id_get**](docs/DepthApi.md#depths_id_get) | **GET** /depths/{id} | Get a single Depth by its id
*DeputyApi* | [**deputys_get**](docs/DeputyApi.md#deputys_get) | **GET** /deputys | List all instances of Deputy
*DeputyApi* | [**deputys_id_get**](docs/DeputyApi.md#deputys_id_get) | **GET** /deputys/{id} | Get a single Deputy by its id
*DesertApi* | [**deserts_get**](docs/DesertApi.md#deserts_get) | **GET** /deserts | List all instances of Desert
*DesertApi* | [**deserts_id_get**](docs/DesertApi.md#deserts_id_get) | **GET** /deserts/{id} | Get a single Desert by its id
*DeviceApi* | [**devices_get**](docs/DeviceApi.md#devices_get) | **GET** /devices | List all instances of Device
*DeviceApi* | [**devices_id_get**](docs/DeviceApi.md#devices_id_get) | **GET** /devices/{id} | Get a single Device by its id
*DigitalCameraApi* | [**digitalcameras_get**](docs/DigitalCameraApi.md#digitalcameras_get) | **GET** /digitalcameras | List all instances of DigitalCamera
*DigitalCameraApi* | [**digitalcameras_id_get**](docs/DigitalCameraApi.md#digitalcameras_id_get) | **GET** /digitalcameras/{id} | Get a single DigitalCamera by its id
*DioceseApi* | [**dioceses_get**](docs/DioceseApi.md#dioceses_get) | **GET** /dioceses | List all instances of Diocese
*DioceseApi* | [**dioceses_id_get**](docs/DioceseApi.md#dioceses_id_get) | **GET** /dioceses/{id} | Get a single Diocese by its id
*DiplomaApi* | [**diplomas_get**](docs/DiplomaApi.md#diplomas_get) | **GET** /diplomas | List all instances of Diploma
*DiplomaApi* | [**diplomas_id_get**](docs/DiplomaApi.md#diplomas_id_get) | **GET** /diplomas/{id} | Get a single Diploma by its id
*DiseaseApi* | [**diseases_get**](docs/DiseaseApi.md#diseases_get) | **GET** /diseases | List all instances of Disease
*DiseaseApi* | [**diseases_id_get**](docs/DiseaseApi.md#diseases_id_get) | **GET** /diseases/{id} | Get a single Disease by its id
*DisneyCharacterApi* | [**disneycharacters_get**](docs/DisneyCharacterApi.md#disneycharacters_get) | **GET** /disneycharacters | List all instances of DisneyCharacter
*DisneyCharacterApi* | [**disneycharacters_id_get**](docs/DisneyCharacterApi.md#disneycharacters_id_get) | **GET** /disneycharacters/{id} | Get a single DisneyCharacter by its id
*DistrictApi* | [**districts_get**](docs/DistrictApi.md#districts_get) | **GET** /districts | List all instances of District
*DistrictApi* | [**districts_id_get**](docs/DistrictApi.md#districts_id_get) | **GET** /districts/{id} | Get a single District by its id
*DistrictWaterBoardApi* | [**districtwaterboards_get**](docs/DistrictWaterBoardApi.md#districtwaterboards_get) | **GET** /districtwaterboards | List all instances of DistrictWaterBoard
*DistrictWaterBoardApi* | [**districtwaterboards_id_get**](docs/DistrictWaterBoardApi.md#districtwaterboards_id_get) | **GET** /districtwaterboards/{id} | Get a single DistrictWaterBoard by its id
*DivorceApi* | [**divorces_get**](docs/DivorceApi.md#divorces_get) | **GET** /divorces | List all instances of Divorce
*DivorceApi* | [**divorces_id_get**](docs/DivorceApi.md#divorces_id_get) | **GET** /divorces/{id} | Get a single Divorce by its id
*DocumentApi* | [**documents_get**](docs/DocumentApi.md#documents_get) | **GET** /documents | List all instances of Document
*DocumentApi* | [**documents_id_get**](docs/DocumentApi.md#documents_id_get) | **GET** /documents/{id} | Get a single Document by its id
*DocumentTypeApi* | [**documenttypes_get**](docs/DocumentTypeApi.md#documenttypes_get) | **GET** /documenttypes | List all instances of DocumentType
*DocumentTypeApi* | [**documenttypes_id_get**](docs/DocumentTypeApi.md#documenttypes_id_get) | **GET** /documenttypes/{id} | Get a single DocumentType by its id
*DogApi* | [**dogs_get**](docs/DogApi.md#dogs_get) | **GET** /dogs | List all instances of Dog
*DogApi* | [**dogs_id_get**](docs/DogApi.md#dogs_id_get) | **GET** /dogs/{id} | Get a single Dog by its id
*DramaApi* | [**dramas_get**](docs/DramaApi.md#dramas_get) | **GET** /dramas | List all instances of Drama
*DramaApi* | [**dramas_id_get**](docs/DramaApi.md#dramas_id_get) | **GET** /dramas/{id} | Get a single Drama by its id
*DrugApi* | [**drugs_get**](docs/DrugApi.md#drugs_get) | **GET** /drugs | List all instances of Drug
*DrugApi* | [**drugs_id_get**](docs/DrugApi.md#drugs_id_get) | **GET** /drugs/{id} | Get a single Drug by its id
*EconomistApi* | [**economists_get**](docs/EconomistApi.md#economists_get) | **GET** /economists | List all instances of Economist
*EconomistApi* | [**economists_id_get**](docs/EconomistApi.md#economists_id_get) | **GET** /economists/{id} | Get a single Economist by its id
*EducationalInstitutionApi* | [**educationalinstitutions_get**](docs/EducationalInstitutionApi.md#educationalinstitutions_get) | **GET** /educationalinstitutions | List all instances of EducationalInstitution
*EducationalInstitutionApi* | [**educationalinstitutions_id_get**](docs/EducationalInstitutionApi.md#educationalinstitutions_id_get) | **GET** /educationalinstitutions/{id} | Get a single EducationalInstitution by its id
*EgyptologistApi* | [**egyptologists_get**](docs/EgyptologistApi.md#egyptologists_get) | **GET** /egyptologists | List all instances of Egyptologist
*EgyptologistApi* | [**egyptologists_id_get**](docs/EgyptologistApi.md#egyptologists_id_get) | **GET** /egyptologists/{id} | Get a single Egyptologist by its id
*ElectionApi* | [**elections_get**](docs/ElectionApi.md#elections_get) | **GET** /elections | List all instances of Election
*ElectionApi* | [**elections_id_get**](docs/ElectionApi.md#elections_id_get) | **GET** /elections/{id} | Get a single Election by its id
*ElectionDiagramApi* | [**electiondiagrams_get**](docs/ElectionDiagramApi.md#electiondiagrams_get) | **GET** /electiondiagrams | List all instances of ElectionDiagram
*ElectionDiagramApi* | [**electiondiagrams_id_get**](docs/ElectionDiagramApi.md#electiondiagrams_id_get) | **GET** /electiondiagrams/{id} | Get a single ElectionDiagram by its id
*EmbryologyApi* | [**embryologys_get**](docs/EmbryologyApi.md#embryologys_get) | **GET** /embryologys | List all instances of Embryology
*EmbryologyApi* | [**embryologys_id_get**](docs/EmbryologyApi.md#embryologys_id_get) | **GET** /embryologys/{id} | Get a single Embryology by its id
*EmployerApi* | [**employers_get**](docs/EmployerApi.md#employers_get) | **GET** /employers | List all instances of Employer
*EmployerApi* | [**employers_id_get**](docs/EmployerApi.md#employers_id_get) | **GET** /employers/{id} | Get a single Employer by its id
*EngineerApi* | [**engineers_get**](docs/EngineerApi.md#engineers_get) | **GET** /engineers | List all instances of Engineer
*EngineerApi* | [**engineers_id_get**](docs/EngineerApi.md#engineers_id_get) | **GET** /engineers/{id} | Get a single Engineer by its id
*EntomologistApi* | [**entomologists_get**](docs/EntomologistApi.md#entomologists_get) | **GET** /entomologists | List all instances of Entomologist
*EntomologistApi* | [**entomologists_id_get**](docs/EntomologistApi.md#entomologists_id_get) | **GET** /entomologists/{id} | Get a single Entomologist by its id
*EnzymeApi* | [**enzymes_get**](docs/EnzymeApi.md#enzymes_get) | **GET** /enzymes | List all instances of Enzyme
*EnzymeApi* | [**enzymes_id_get**](docs/EnzymeApi.md#enzymes_id_get) | **GET** /enzymes/{id} | Get a single Enzyme by its id
*EthnicGroupApi* | [**ethnicgroups_get**](docs/EthnicGroupApi.md#ethnicgroups_get) | **GET** /ethnicgroups | List all instances of EthnicGroup
*EthnicGroupApi* | [**ethnicgroups_id_get**](docs/EthnicGroupApi.md#ethnicgroups_id_get) | **GET** /ethnicgroups/{id} | Get a single EthnicGroup by its id
*EukaryoteApi* | [**eukaryotes_get**](docs/EukaryoteApi.md#eukaryotes_get) | **GET** /eukaryotes | List all instances of Eukaryote
*EukaryoteApi* | [**eukaryotes_id_get**](docs/EukaryoteApi.md#eukaryotes_id_get) | **GET** /eukaryotes/{id} | Get a single Eukaryote by its id
*EurovisionSongContestEntryApi* | [**eurovisionsongcontestentrys_get**](docs/EurovisionSongContestEntryApi.md#eurovisionsongcontestentrys_get) | **GET** /eurovisionsongcontestentrys | List all instances of EurovisionSongContestEntry
*EurovisionSongContestEntryApi* | [**eurovisionsongcontestentrys_id_get**](docs/EurovisionSongContestEntryApi.md#eurovisionsongcontestentrys_id_get) | **GET** /eurovisionsongcontestentrys/{id} | Get a single EurovisionSongContestEntry by its id
*EventApi* | [**events_get**](docs/EventApi.md#events_get) | **GET** /events | List all instances of Event
*EventApi* | [**events_id_get**](docs/EventApi.md#events_id_get) | **GET** /events/{id} | Get a single Event by its id
*FactoryApi* | [**factorys_get**](docs/FactoryApi.md#factorys_get) | **GET** /factorys | List all instances of Factory
*FactoryApi* | [**factorys_id_get**](docs/FactoryApi.md#factorys_id_get) | **GET** /factorys/{id} | Get a single Factory by its id
*FamilyApi* | [**familys_get**](docs/FamilyApi.md#familys_get) | **GET** /familys | List all instances of Family
*FamilyApi* | [**familys_id_get**](docs/FamilyApi.md#familys_id_get) | **GET** /familys/{id} | Get a single Family by its id
*FarmerApi* | [**farmers_get**](docs/FarmerApi.md#farmers_get) | **GET** /farmers | List all instances of Farmer
*FarmerApi* | [**farmers_id_get**](docs/FarmerApi.md#farmers_id_get) | **GET** /farmers/{id} | Get a single Farmer by its id
*FashionApi* | [**fashions_get**](docs/FashionApi.md#fashions_get) | **GET** /fashions | List all instances of Fashion
*FashionApi* | [**fashions_id_get**](docs/FashionApi.md#fashions_id_get) | **GET** /fashions/{id} | Get a single Fashion by its id
*FashionDesignerApi* | [**fashiondesigners_get**](docs/FashionDesignerApi.md#fashiondesigners_get) | **GET** /fashiondesigners | List all instances of FashionDesigner
*FashionDesignerApi* | [**fashiondesigners_id_get**](docs/FashionDesignerApi.md#fashiondesigners_id_get) | **GET** /fashiondesigners/{id} | Get a single FashionDesigner by its id
*FencerApi* | [**fencers_get**](docs/FencerApi.md#fencers_get) | **GET** /fencers | List all instances of Fencer
*FencerApi* | [**fencers_id_get**](docs/FencerApi.md#fencers_id_get) | **GET** /fencers/{id} | Get a single Fencer by its id
*FernApi* | [**ferns_get**](docs/FernApi.md#ferns_get) | **GET** /ferns | List all instances of Fern
*FernApi* | [**ferns_id_get**](docs/FernApi.md#ferns_id_get) | **GET** /ferns/{id} | Get a single Fern by its id
*FictionalCharacterApi* | [**fictionalcharacters_get**](docs/FictionalCharacterApi.md#fictionalcharacters_get) | **GET** /fictionalcharacters | List all instances of FictionalCharacter
*FictionalCharacterApi* | [**fictionalcharacters_id_get**](docs/FictionalCharacterApi.md#fictionalcharacters_id_get) | **GET** /fictionalcharacters/{id} | Get a single FictionalCharacter by its id
*FieldHockeyLeagueApi* | [**fieldhockeyleagues_get**](docs/FieldHockeyLeagueApi.md#fieldhockeyleagues_get) | **GET** /fieldhockeyleagues | List all instances of FieldHockeyLeague
*FieldHockeyLeagueApi* | [**fieldhockeyleagues_id_get**](docs/FieldHockeyLeagueApi.md#fieldhockeyleagues_id_get) | **GET** /fieldhockeyleagues/{id} | Get a single FieldHockeyLeague by its id
*FigureSkaterApi* | [**figureskaters_get**](docs/FigureSkaterApi.md#figureskaters_get) | **GET** /figureskaters | List all instances of FigureSkater
*FigureSkaterApi* | [**figureskaters_id_get**](docs/FigureSkaterApi.md#figureskaters_id_get) | **GET** /figureskaters/{id} | Get a single FigureSkater by its id
*FilmApi* | [**films_get**](docs/FilmApi.md#films_get) | **GET** /films | List all instances of Film
*FilmApi* | [**films_id_get**](docs/FilmApi.md#films_id_get) | **GET** /films/{id} | Get a single Film by its id
*FilmFestivalApi* | [**filmfestivals_get**](docs/FilmFestivalApi.md#filmfestivals_get) | **GET** /filmfestivals | List all instances of FilmFestival
*FilmFestivalApi* | [**filmfestivals_id_get**](docs/FilmFestivalApi.md#filmfestivals_id_get) | **GET** /filmfestivals/{id} | Get a single FilmFestival by its id
*FishApi* | [**fishs_get**](docs/FishApi.md#fishs_get) | **GET** /fishs | List all instances of Fish
*FishApi* | [**fishs_id_get**](docs/FishApi.md#fishs_id_get) | **GET** /fishs/{id} | Get a single Fish by its id
*FlagApi* | [**flags_get**](docs/FlagApi.md#flags_get) | **GET** /flags | List all instances of Flag
*FlagApi* | [**flags_id_get**](docs/FlagApi.md#flags_id_get) | **GET** /flags/{id} | Get a single Flag by its id
*FloweringPlantApi* | [**floweringplants_get**](docs/FloweringPlantApi.md#floweringplants_get) | **GET** /floweringplants | List all instances of FloweringPlant
*FloweringPlantApi* | [**floweringplants_id_get**](docs/FloweringPlantApi.md#floweringplants_id_get) | **GET** /floweringplants/{id} | Get a single FloweringPlant by its id
*FoodApi* | [**foods_get**](docs/FoodApi.md#foods_get) | **GET** /foods | List all instances of Food
*FoodApi* | [**foods_id_get**](docs/FoodApi.md#foods_id_get) | **GET** /foods/{id} | Get a single Food by its id
*FootballLeagueSeasonApi* | [**footballleagueseasons_get**](docs/FootballLeagueSeasonApi.md#footballleagueseasons_get) | **GET** /footballleagueseasons | List all instances of FootballLeagueSeason
*FootballLeagueSeasonApi* | [**footballleagueseasons_id_get**](docs/FootballLeagueSeasonApi.md#footballleagueseasons_id_get) | **GET** /footballleagueseasons/{id} | Get a single FootballLeagueSeason by its id
*FootballMatchApi* | [**footballmatchs_get**](docs/FootballMatchApi.md#footballmatchs_get) | **GET** /footballmatchs | List all instances of FootballMatch
*FootballMatchApi* | [**footballmatchs_id_get**](docs/FootballMatchApi.md#footballmatchs_id_get) | **GET** /footballmatchs/{id} | Get a single FootballMatch by its id
*FormerMunicipalityApi* | [**formermunicipalitys_get**](docs/FormerMunicipalityApi.md#formermunicipalitys_get) | **GET** /formermunicipalitys | List all instances of FormerMunicipality
*FormerMunicipalityApi* | [**formermunicipalitys_id_get**](docs/FormerMunicipalityApi.md#formermunicipalitys_id_get) | **GET** /formermunicipalitys/{id} | Get a single FormerMunicipality by its id
*FormulaOneRacerApi* | [**formulaoneracers_get**](docs/FormulaOneRacerApi.md#formulaoneracers_get) | **GET** /formulaoneracers | List all instances of FormulaOneRacer
*FormulaOneRacerApi* | [**formulaoneracers_id_get**](docs/FormulaOneRacerApi.md#formulaoneracers_id_get) | **GET** /formulaoneracers/{id} | Get a single FormulaOneRacer by its id
*FormulaOneRacingApi* | [**formulaoneracings_get**](docs/FormulaOneRacingApi.md#formulaoneracings_get) | **GET** /formulaoneracings | List all instances of FormulaOneRacing
*FormulaOneRacingApi* | [**formulaoneracings_id_get**](docs/FormulaOneRacingApi.md#formulaoneracings_id_get) | **GET** /formulaoneracings/{id} | Get a single FormulaOneRacing by its id
*FormulaOneTeamApi* | [**formulaoneteams_get**](docs/FormulaOneTeamApi.md#formulaoneteams_get) | **GET** /formulaoneteams | List all instances of FormulaOneTeam
*FormulaOneTeamApi* | [**formulaoneteams_id_get**](docs/FormulaOneTeamApi.md#formulaoneteams_id_get) | **GET** /formulaoneteams/{id} | Get a single FormulaOneTeam by its id
*FungusApi* | [**funguss_get**](docs/FungusApi.md#funguss_get) | **GET** /funguss | List all instances of Fungus
*FungusApi* | [**funguss_id_get**](docs/FungusApi.md#funguss_id_get) | **GET** /funguss/{id} | Get a single Fungus by its id
*GaelicGamesPlayerApi* | [**gaelicgamesplayers_get**](docs/GaelicGamesPlayerApi.md#gaelicgamesplayers_get) | **GET** /gaelicgamesplayers | List all instances of GaelicGamesPlayer
*GaelicGamesPlayerApi* | [**gaelicgamesplayers_id_get**](docs/GaelicGamesPlayerApi.md#gaelicgamesplayers_id_get) | **GET** /gaelicgamesplayers/{id} | Get a single GaelicGamesPlayer by its id
*GalaxyApi* | [**galaxys_get**](docs/GalaxyApi.md#galaxys_get) | **GET** /galaxys | List all instances of Galaxy
*GalaxyApi* | [**galaxys_id_get**](docs/GalaxyApi.md#galaxys_id_get) | **GET** /galaxys/{id} | Get a single Galaxy by its id
*GameApi* | [**games_get**](docs/GameApi.md#games_get) | **GET** /games | List all instances of Game
*GameApi* | [**games_id_get**](docs/GameApi.md#games_id_get) | **GET** /games/{id} | Get a single Game by its id
*GardenApi* | [**gardens_get**](docs/GardenApi.md#gardens_get) | **GET** /gardens | List all instances of Garden
*GardenApi* | [**gardens_id_get**](docs/GardenApi.md#gardens_id_get) | **GET** /gardens/{id} | Get a single Garden by its id
*GateApi* | [**gates_get**](docs/GateApi.md#gates_get) | **GET** /gates | List all instances of Gate
*GateApi* | [**gates_id_get**](docs/GateApi.md#gates_id_get) | **GET** /gates/{id} | Get a single Gate by its id
*GatedCommunityApi* | [**gatedcommunitys_get**](docs/GatedCommunityApi.md#gatedcommunitys_get) | **GET** /gatedcommunitys | List all instances of GatedCommunity
*GatedCommunityApi* | [**gatedcommunitys_id_get**](docs/GatedCommunityApi.md#gatedcommunitys_id_get) | **GET** /gatedcommunitys/{id} | Get a single GatedCommunity by its id
*GeneApi* | [**genes_get**](docs/GeneApi.md#genes_get) | **GET** /genes | List all instances of Gene
*GeneApi* | [**genes_id_get**](docs/GeneApi.md#genes_id_get) | **GET** /genes/{id} | Get a single Gene by its id
*GeneLocationApi* | [**genelocations_get**](docs/GeneLocationApi.md#genelocations_get) | **GET** /genelocations | List all instances of GeneLocation
*GeneLocationApi* | [**genelocations_id_get**](docs/GeneLocationApi.md#genelocations_id_get) | **GET** /genelocations/{id} | Get a single GeneLocation by its id
*GenreApi* | [**genres_get**](docs/GenreApi.md#genres_get) | **GET** /genres | List all instances of Genre
*GenreApi* | [**genres_id_get**](docs/GenreApi.md#genres_id_get) | **GET** /genres/{id} | Get a single Genre by its id
*GeologicalPeriodApi* | [**geologicalperiods_get**](docs/GeologicalPeriodApi.md#geologicalperiods_get) | **GET** /geologicalperiods | List all instances of GeologicalPeriod
*GeologicalPeriodApi* | [**geologicalperiods_id_get**](docs/GeologicalPeriodApi.md#geologicalperiods_id_get) | **GET** /geologicalperiods/{id} | Get a single GeologicalPeriod by its id
*GeopoliticalOrganisationApi* | [**geopoliticalorganisations_get**](docs/GeopoliticalOrganisationApi.md#geopoliticalorganisations_get) | **GET** /geopoliticalorganisations | List all instances of GeopoliticalOrganisation
*GeopoliticalOrganisationApi* | [**geopoliticalorganisations_id_get**](docs/GeopoliticalOrganisationApi.md#geopoliticalorganisations_id_get) | **GET** /geopoliticalorganisations/{id} | Get a single GeopoliticalOrganisation by its id
*GermanSettlementApi* | [**germansettlements_get**](docs/GermanSettlementApi.md#germansettlements_get) | **GET** /germansettlements | List all instances of GermanSettlement
*GermanSettlementApi* | [**germansettlements_id_get**](docs/GermanSettlementApi.md#germansettlements_id_get) | **GET** /germansettlements/{id} | Get a single GermanSettlement by its id
*GinkgoApi* | [**ginkgos_get**](docs/GinkgoApi.md#ginkgos_get) | **GET** /ginkgos | List all instances of Ginkgo
*GinkgoApi* | [**ginkgos_id_get**](docs/GinkgoApi.md#ginkgos_id_get) | **GET** /ginkgos/{id} | Get a single Ginkgo by its id
*GivenNameApi* | [**givennames_get**](docs/GivenNameApi.md#givennames_get) | **GET** /givennames | List all instances of GivenName
*GivenNameApi* | [**givennames_id_get**](docs/GivenNameApi.md#givennames_id_get) | **GET** /givennames/{id} | Get a single GivenName by its id
*GlacierApi* | [**glaciers_get**](docs/GlacierApi.md#glaciers_get) | **GET** /glaciers | List all instances of Glacier
*GlacierApi* | [**glaciers_id_get**](docs/GlacierApi.md#glaciers_id_get) | **GET** /glaciers/{id} | Get a single Glacier by its id
*GlobularswarmApi* | [**globularswarms_get**](docs/GlobularswarmApi.md#globularswarms_get) | **GET** /globularswarms | List all instances of Globularswarm
*GlobularswarmApi* | [**globularswarms_id_get**](docs/GlobularswarmApi.md#globularswarms_id_get) | **GET** /globularswarms/{id} | Get a single Globularswarm by its id
*GnetophytesApi* | [**gnetophytess_get**](docs/GnetophytesApi.md#gnetophytess_get) | **GET** /gnetophytess | List all instances of Gnetophytes
*GnetophytesApi* | [**gnetophytess_id_get**](docs/GnetophytesApi.md#gnetophytess_id_get) | **GET** /gnetophytess/{id} | Get a single Gnetophytes by its id
*GolfCourseApi* | [**golfcourses_get**](docs/GolfCourseApi.md#golfcourses_get) | **GET** /golfcourses | List all instances of GolfCourse
*GolfCourseApi* | [**golfcourses_id_get**](docs/GolfCourseApi.md#golfcourses_id_get) | **GET** /golfcourses/{id} | Get a single GolfCourse by its id
*GolfLeagueApi* | [**golfleagues_get**](docs/GolfLeagueApi.md#golfleagues_get) | **GET** /golfleagues | List all instances of GolfLeague
*GolfLeagueApi* | [**golfleagues_id_get**](docs/GolfLeagueApi.md#golfleagues_id_get) | **GET** /golfleagues/{id} | Get a single GolfLeague by its id
*GolfPlayerApi* | [**golfplayers_get**](docs/GolfPlayerApi.md#golfplayers_get) | **GET** /golfplayers | List all instances of GolfPlayer
*GolfPlayerApi* | [**golfplayers_id_get**](docs/GolfPlayerApi.md#golfplayers_id_get) | **GET** /golfplayers/{id} | Get a single GolfPlayer by its id
*GolfTournamentApi* | [**golftournaments_get**](docs/GolfTournamentApi.md#golftournaments_get) | **GET** /golftournaments | List all instances of GolfTournament
*GolfTournamentApi* | [**golftournaments_id_get**](docs/GolfTournamentApi.md#golftournaments_id_get) | **GET** /golftournaments/{id} | Get a single GolfTournament by its id
*GovernmentAgencyApi* | [**governmentagencys_get**](docs/GovernmentAgencyApi.md#governmentagencys_get) | **GET** /governmentagencys | List all instances of GovernmentAgency
*GovernmentAgencyApi* | [**governmentagencys_id_get**](docs/GovernmentAgencyApi.md#governmentagencys_id_get) | **GET** /governmentagencys/{id} | Get a single GovernmentAgency by its id
*GovernmentTypeApi* | [**governmenttypes_get**](docs/GovernmentTypeApi.md#governmenttypes_get) | **GET** /governmenttypes | List all instances of GovernmentType
*GovernmentTypeApi* | [**governmenttypes_id_get**](docs/GovernmentTypeApi.md#governmenttypes_id_get) | **GET** /governmenttypes/{id} | Get a single GovernmentType by its id
*GovernmentalAdministrativeRegionApi* | [**governmentaladministrativeregions_get**](docs/GovernmentalAdministrativeRegionApi.md#governmentaladministrativeregions_get) | **GET** /governmentaladministrativeregions | List all instances of GovernmentalAdministrativeRegion
*GovernmentalAdministrativeRegionApi* | [**governmentaladministrativeregions_id_get**](docs/GovernmentalAdministrativeRegionApi.md#governmentaladministrativeregions_id_get) | **GET** /governmentaladministrativeregions/{id} | Get a single GovernmentalAdministrativeRegion by its id
*GovernorApi* | [**governors_get**](docs/GovernorApi.md#governors_get) | **GET** /governors | List all instances of Governor
*GovernorApi* | [**governors_id_get**](docs/GovernorApi.md#governors_id_get) | **GET** /governors/{id} | Get a single Governor by its id
*GrandPrixApi* | [**grandprixs_get**](docs/GrandPrixApi.md#grandprixs_get) | **GET** /grandprixs | List all instances of GrandPrix
*GrandPrixApi* | [**grandprixs_id_get**](docs/GrandPrixApi.md#grandprixs_id_get) | **GET** /grandprixs/{id} | Get a single GrandPrix by its id
*GrapeApi* | [**grapes_get**](docs/GrapeApi.md#grapes_get) | **GET** /grapes | List all instances of Grape
*GrapeApi* | [**grapes_id_get**](docs/GrapeApi.md#grapes_id_get) | **GET** /grapes/{id} | Get a single Grape by its id
*GraveMonumentApi* | [**gravemonuments_get**](docs/GraveMonumentApi.md#gravemonuments_get) | **GET** /gravemonuments | List all instances of GraveMonument
*GraveMonumentApi* | [**gravemonuments_id_get**](docs/GraveMonumentApi.md#gravemonuments_id_get) | **GET** /gravemonuments/{id} | Get a single GraveMonument by its id
*GreenAlgaApi* | [**greenalgas_get**](docs/GreenAlgaApi.md#greenalgas_get) | **GET** /greenalgas | List all instances of GreenAlga
*GreenAlgaApi* | [**greenalgas_id_get**](docs/GreenAlgaApi.md#greenalgas_id_get) | **GET** /greenalgas/{id} | Get a single GreenAlga by its id
*GridironFootballPlayerApi* | [**gridironfootballplayers_get**](docs/GridironFootballPlayerApi.md#gridironfootballplayers_get) | **GET** /gridironfootballplayers | List all instances of GridironFootballPlayer
*GridironFootballPlayerApi* | [**gridironfootballplayers_id_get**](docs/GridironFootballPlayerApi.md#gridironfootballplayers_id_get) | **GET** /gridironfootballplayers/{id} | Get a single GridironFootballPlayer by its id
*GrossDomesticProductApi* | [**grossdomesticproducts_get**](docs/GrossDomesticProductApi.md#grossdomesticproducts_get) | **GET** /grossdomesticproducts | List all instances of GrossDomesticProduct
*GrossDomesticProductApi* | [**grossdomesticproducts_id_get**](docs/GrossDomesticProductApi.md#grossdomesticproducts_id_get) | **GET** /grossdomesticproducts/{id} | Get a single GrossDomesticProduct by its id
*GrossDomesticProductPerCapitaApi* | [**grossdomesticproductpercapitas_get**](docs/GrossDomesticProductPerCapitaApi.md#grossdomesticproductpercapitas_get) | **GET** /grossdomesticproductpercapitas | List all instances of GrossDomesticProductPerCapita
*GrossDomesticProductPerCapitaApi* | [**grossdomesticproductpercapitas_id_get**](docs/GrossDomesticProductPerCapitaApi.md#grossdomesticproductpercapitas_id_get) | **GET** /grossdomesticproductpercapitas/{id} | Get a single GrossDomesticProductPerCapita by its id
*GroupApi* | [**groups_get**](docs/GroupApi.md#groups_get) | **GET** /groups | List all instances of Group
*GroupApi* | [**groups_id_get**](docs/GroupApi.md#groups_id_get) | **GET** /groups/{id} | Get a single Group by its id
*GuitarApi* | [**guitars_get**](docs/GuitarApi.md#guitars_get) | **GET** /guitars | List all instances of Guitar
*GuitarApi* | [**guitars_id_get**](docs/GuitarApi.md#guitars_id_get) | **GET** /guitars/{id} | Get a single Guitar by its id
*GuitaristApi* | [**guitarists_get**](docs/GuitaristApi.md#guitarists_get) | **GET** /guitarists | List all instances of Guitarist
*GuitaristApi* | [**guitarists_id_get**](docs/GuitaristApi.md#guitarists_id_get) | **GET** /guitarists/{id} | Get a single Guitarist by its id
*GymnastApi* | [**gymnasts_get**](docs/GymnastApi.md#gymnasts_get) | **GET** /gymnasts | List all instances of Gymnast
*GymnastApi* | [**gymnasts_id_get**](docs/GymnastApi.md#gymnasts_id_get) | **GET** /gymnasts/{id} | Get a single Gymnast by its id
*HandballLeagueApi* | [**handballleagues_get**](docs/HandballLeagueApi.md#handballleagues_get) | **GET** /handballleagues | List all instances of HandballLeague
*HandballLeagueApi* | [**handballleagues_id_get**](docs/HandballLeagueApi.md#handballleagues_id_get) | **GET** /handballleagues/{id} | Get a single HandballLeague by its id
*HandballPlayerApi* | [**handballplayers_get**](docs/HandballPlayerApi.md#handballplayers_get) | **GET** /handballplayers | List all instances of HandballPlayer
*HandballPlayerApi* | [**handballplayers_id_get**](docs/HandballPlayerApi.md#handballplayers_id_get) | **GET** /handballplayers/{id} | Get a single HandballPlayer by its id
*HandballTeamApi* | [**handballteams_get**](docs/HandballTeamApi.md#handballteams_get) | **GET** /handballteams | List all instances of HandballTeam
*HandballTeamApi* | [**handballteams_id_get**](docs/HandballTeamApi.md#handballteams_id_get) | **GET** /handballteams/{id} | Get a single HandballTeam by its id
*HistorianApi* | [**historians_get**](docs/HistorianApi.md#historians_get) | **GET** /historians | List all instances of Historian
*HistorianApi* | [**historians_id_get**](docs/HistorianApi.md#historians_id_get) | **GET** /historians/{id} | Get a single Historian by its id
*HistoricBuildingApi* | [**historicbuildings_get**](docs/HistoricBuildingApi.md#historicbuildings_get) | **GET** /historicbuildings | List all instances of HistoricBuilding
*HistoricBuildingApi* | [**historicbuildings_id_get**](docs/HistoricBuildingApi.md#historicbuildings_id_get) | **GET** /historicbuildings/{id} | Get a single HistoricBuilding by its id
*HistoricPlaceApi* | [**historicplaces_get**](docs/HistoricPlaceApi.md#historicplaces_get) | **GET** /historicplaces | List all instances of HistoricPlace
*HistoricPlaceApi* | [**historicplaces_id_get**](docs/HistoricPlaceApi.md#historicplaces_id_get) | **GET** /historicplaces/{id} | Get a single HistoricPlace by its id
*HistoricalCountryApi* | [**historicalcountrys_get**](docs/HistoricalCountryApi.md#historicalcountrys_get) | **GET** /historicalcountrys | List all instances of HistoricalCountry
*HistoricalCountryApi* | [**historicalcountrys_id_get**](docs/HistoricalCountryApi.md#historicalcountrys_id_get) | **GET** /historicalcountrys/{id} | Get a single HistoricalCountry by its id
*HistoricalDistrictApi* | [**historicaldistricts_get**](docs/HistoricalDistrictApi.md#historicaldistricts_get) | **GET** /historicaldistricts | List all instances of HistoricalDistrict
*HistoricalDistrictApi* | [**historicaldistricts_id_get**](docs/HistoricalDistrictApi.md#historicaldistricts_id_get) | **GET** /historicaldistricts/{id} | Get a single HistoricalDistrict by its id
*HistoricalPeriodApi* | [**historicalperiods_get**](docs/HistoricalPeriodApi.md#historicalperiods_get) | **GET** /historicalperiods | List all instances of HistoricalPeriod
*HistoricalPeriodApi* | [**historicalperiods_id_get**](docs/HistoricalPeriodApi.md#historicalperiods_id_get) | **GET** /historicalperiods/{id} | Get a single HistoricalPeriod by its id
*HistoricalProvinceApi* | [**historicalprovinces_get**](docs/HistoricalProvinceApi.md#historicalprovinces_get) | **GET** /historicalprovinces | List all instances of HistoricalProvince
*HistoricalProvinceApi* | [**historicalprovinces_id_get**](docs/HistoricalProvinceApi.md#historicalprovinces_id_get) | **GET** /historicalprovinces/{id} | Get a single HistoricalProvince by its id
*HistoricalRegionApi* | [**historicalregions_get**](docs/HistoricalRegionApi.md#historicalregions_get) | **GET** /historicalregions | List all instances of HistoricalRegion
*HistoricalRegionApi* | [**historicalregions_id_get**](docs/HistoricalRegionApi.md#historicalregions_id_get) | **GET** /historicalregions/{id} | Get a single HistoricalRegion by its id
*HistoricalSettlementApi* | [**historicalsettlements_get**](docs/HistoricalSettlementApi.md#historicalsettlements_get) | **GET** /historicalsettlements | List all instances of HistoricalSettlement
*HistoricalSettlementApi* | [**historicalsettlements_id_get**](docs/HistoricalSettlementApi.md#historicalsettlements_id_get) | **GET** /historicalsettlements/{id} | Get a single HistoricalSettlement by its id
*HockeyTeamApi* | [**hockeyteams_get**](docs/HockeyTeamApi.md#hockeyteams_get) | **GET** /hockeyteams | List all instances of HockeyTeam
*HockeyTeamApi* | [**hockeyteams_id_get**](docs/HockeyTeamApi.md#hockeyteams_id_get) | **GET** /hockeyteams/{id} | Get a single HockeyTeam by its id
*HolidayApi* | [**holidays_get**](docs/HolidayApi.md#holidays_get) | **GET** /holidays | List all instances of Holiday
*HolidayApi* | [**holidays_id_get**](docs/HolidayApi.md#holidays_id_get) | **GET** /holidays/{id} | Get a single Holiday by its id
*HollywoodCartoonApi* | [**hollywoodcartoons_get**](docs/HollywoodCartoonApi.md#hollywoodcartoons_get) | **GET** /hollywoodcartoons | List all instances of HollywoodCartoon
*HollywoodCartoonApi* | [**hollywoodcartoons_id_get**](docs/HollywoodCartoonApi.md#hollywoodcartoons_id_get) | **GET** /hollywoodcartoons/{id} | Get a single HollywoodCartoon by its id
*HorseRaceApi* | [**horseraces_get**](docs/HorseRaceApi.md#horseraces_get) | **GET** /horseraces | List all instances of HorseRace
*HorseRaceApi* | [**horseraces_id_get**](docs/HorseRaceApi.md#horseraces_id_get) | **GET** /horseraces/{id} | Get a single HorseRace by its id
*HorseRiderApi* | [**horseriders_get**](docs/HorseRiderApi.md#horseriders_get) | **GET** /horseriders | List all instances of HorseRider
*HorseRiderApi* | [**horseriders_id_get**](docs/HorseRiderApi.md#horseriders_id_get) | **GET** /horseriders/{id} | Get a single HorseRider by its id
*HorseRidingApi* | [**horseridings_get**](docs/HorseRidingApi.md#horseridings_get) | **GET** /horseridings | List all instances of HorseRiding
*HorseRidingApi* | [**horseridings_id_get**](docs/HorseRidingApi.md#horseridings_id_get) | **GET** /horseridings/{id} | Get a single HorseRiding by its id
*HorseTrainerApi* | [**horsetrainers_get**](docs/HorseTrainerApi.md#horsetrainers_get) | **GET** /horsetrainers | List all instances of HorseTrainer
*HorseTrainerApi* | [**horsetrainers_id_get**](docs/HorseTrainerApi.md#horsetrainers_id_get) | **GET** /horsetrainers/{id} | Get a single HorseTrainer by its id
*HospitalApi* | [**hospitals_get**](docs/HospitalApi.md#hospitals_get) | **GET** /hospitals | List all instances of Hospital
*HospitalApi* | [**hospitals_id_get**](docs/HospitalApi.md#hospitals_id_get) | **GET** /hospitals/{id} | Get a single Hospital by its id
*HostApi* | [**hosts_get**](docs/HostApi.md#hosts_get) | **GET** /hosts | List all instances of Host
*HostApi* | [**hosts_id_get**](docs/HostApi.md#hosts_id_get) | **GET** /hosts/{id} | Get a single Host by its id
*HotSpringApi* | [**hotsprings_get**](docs/HotSpringApi.md#hotsprings_get) | **GET** /hotsprings | List all instances of HotSpring
*HotSpringApi* | [**hotsprings_id_get**](docs/HotSpringApi.md#hotsprings_id_get) | **GET** /hotsprings/{id} | Get a single HotSpring by its id
*HotelApi* | [**hotels_get**](docs/HotelApi.md#hotels_get) | **GET** /hotels | List all instances of Hotel
*HotelApi* | [**hotels_id_get**](docs/HotelApi.md#hotels_id_get) | **GET** /hotels/{id} | Get a single Hotel by its id
*HumanDevelopmentIndexApi* | [**humandevelopmentindexs_get**](docs/HumanDevelopmentIndexApi.md#humandevelopmentindexs_get) | **GET** /humandevelopmentindexs | List all instances of HumanDevelopmentIndex
*HumanDevelopmentIndexApi* | [**humandevelopmentindexs_id_get**](docs/HumanDevelopmentIndexApi.md#humandevelopmentindexs_id_get) | **GET** /humandevelopmentindexs/{id} | Get a single HumanDevelopmentIndex by its id
*HumanGeneApi* | [**humangenes_get**](docs/HumanGeneApi.md#humangenes_get) | **GET** /humangenes | List all instances of HumanGene
*HumanGeneApi* | [**humangenes_id_get**](docs/HumanGeneApi.md#humangenes_id_get) | **GET** /humangenes/{id} | Get a single HumanGene by its id
*HumanGeneLocationApi* | [**humangenelocations_get**](docs/HumanGeneLocationApi.md#humangenelocations_get) | **GET** /humangenelocations | List all instances of HumanGeneLocation
*HumanGeneLocationApi* | [**humangenelocations_id_get**](docs/HumanGeneLocationApi.md#humangenelocations_id_get) | **GET** /humangenelocations/{id} | Get a single HumanGeneLocation by its id
*HumoristApi* | [**humorists_get**](docs/HumoristApi.md#humorists_get) | **GET** /humorists | List all instances of Humorist
*HumoristApi* | [**humorists_id_get**](docs/HumoristApi.md#humorists_id_get) | **GET** /humorists/{id} | Get a single Humorist by its id
*HungarySettlementApi* | [**hungarysettlements_get**](docs/HungarySettlementApi.md#hungarysettlements_get) | **GET** /hungarysettlements | List all instances of HungarySettlement
*HungarySettlementApi* | [**hungarysettlements_id_get**](docs/HungarySettlementApi.md#hungarysettlements_id_get) | **GET** /hungarysettlements/{id} | Get a single HungarySettlement by its id
*IceHockeyLeagueApi* | [**icehockeyleagues_get**](docs/IceHockeyLeagueApi.md#icehockeyleagues_get) | **GET** /icehockeyleagues | List all instances of IceHockeyLeague
*IceHockeyLeagueApi* | [**icehockeyleagues_id_get**](docs/IceHockeyLeagueApi.md#icehockeyleagues_id_get) | **GET** /icehockeyleagues/{id} | Get a single IceHockeyLeague by its id
*IceHockeyPlayerApi* | [**icehockeyplayers_get**](docs/IceHockeyPlayerApi.md#icehockeyplayers_get) | **GET** /icehockeyplayers | List all instances of IceHockeyPlayer
*IceHockeyPlayerApi* | [**icehockeyplayers_id_get**](docs/IceHockeyPlayerApi.md#icehockeyplayers_id_get) | **GET** /icehockeyplayers/{id} | Get a single IceHockeyPlayer by its id
*IdeologyApi* | [**ideologys_get**](docs/IdeologyApi.md#ideologys_get) | **GET** /ideologys | List all instances of Ideology
*IdeologyApi* | [**ideologys_id_get**](docs/IdeologyApi.md#ideologys_id_get) | **GET** /ideologys/{id} | Get a single Ideology by its id
*ImageApi* | [**images_get**](docs/ImageApi.md#images_get) | **GET** /images | List all instances of Image
*ImageApi* | [**images_id_get**](docs/ImageApi.md#images_id_get) | **GET** /images/{id} | Get a single Image by its id
*ImdbApi* | [**imdbs_get**](docs/ImdbApi.md#imdbs_get) | **GET** /imdbs | List all instances of Imdb
*ImdbApi* | [**imdbs_id_get**](docs/ImdbApi.md#imdbs_id_get) | **GET** /imdbs/{id} | Get a single Imdb by its id
*InformationApplianceApi* | [**informationappliances_get**](docs/InformationApplianceApi.md#informationappliances_get) | **GET** /informationappliances | List all instances of InformationAppliance
*InformationApplianceApi* | [**informationappliances_id_get**](docs/InformationApplianceApi.md#informationappliances_id_get) | **GET** /informationappliances/{id} | Get a single InformationAppliance by its id
*InfrastructureApi* | [**infrastructures_get**](docs/InfrastructureApi.md#infrastructures_get) | **GET** /infrastructures | List all instances of Infrastructure
*InfrastructureApi* | [**infrastructures_id_get**](docs/InfrastructureApi.md#infrastructures_id_get) | **GET** /infrastructures/{id} | Get a single Infrastructure by its id
*InlineHockeyLeagueApi* | [**inlinehockeyleagues_get**](docs/InlineHockeyLeagueApi.md#inlinehockeyleagues_get) | **GET** /inlinehockeyleagues | List all instances of InlineHockeyLeague
*InlineHockeyLeagueApi* | [**inlinehockeyleagues_id_get**](docs/InlineHockeyLeagueApi.md#inlinehockeyleagues_id_get) | **GET** /inlinehockeyleagues/{id} | Get a single InlineHockeyLeague by its id
*InsectApi* | [**insects_get**](docs/InsectApi.md#insects_get) | **GET** /insects | List all instances of Insect
*InsectApi* | [**insects_id_get**](docs/InsectApi.md#insects_id_get) | **GET** /insects/{id} | Get a single Insect by its id
*InstallmentApi* | [**installments_get**](docs/InstallmentApi.md#installments_get) | **GET** /installments | List all instances of Installment
*InstallmentApi* | [**installments_id_get**](docs/InstallmentApi.md#installments_id_get) | **GET** /installments/{id} | Get a single Installment by its id
*InstrumentApi* | [**instruments_get**](docs/InstrumentApi.md#instruments_get) | **GET** /instruments | List all instances of Instrument
*InstrumentApi* | [**instruments_id_get**](docs/InstrumentApi.md#instruments_id_get) | **GET** /instruments/{id} | Get a single Instrument by its id
*InstrumentalistApi* | [**instrumentalists_get**](docs/InstrumentalistApi.md#instrumentalists_get) | **GET** /instrumentalists | List all instances of Instrumentalist
*InstrumentalistApi* | [**instrumentalists_id_get**](docs/InstrumentalistApi.md#instrumentalists_id_get) | **GET** /instrumentalists/{id} | Get a single Instrumentalist by its id
*IntercommunalityApi* | [**intercommunalitys_get**](docs/IntercommunalityApi.md#intercommunalitys_get) | **GET** /intercommunalitys | List all instances of Intercommunality
*IntercommunalityApi* | [**intercommunalitys_id_get**](docs/IntercommunalityApi.md#intercommunalitys_id_get) | **GET** /intercommunalitys/{id} | Get a single Intercommunality by its id
*IslandApi* | [**islands_get**](docs/IslandApi.md#islands_get) | **GET** /islands | List all instances of Island
*IslandApi* | [**islands_id_get**](docs/IslandApi.md#islands_id_get) | **GET** /islands/{id} | Get a single Island by its id
*JockeyApi* | [**jockeys_get**](docs/JockeyApi.md#jockeys_get) | **GET** /jockeys | List all instances of Jockey
*JockeyApi* | [**jockeys_id_get**](docs/JockeyApi.md#jockeys_id_get) | **GET** /jockeys/{id} | Get a single Jockey by its id
*JournalistApi* | [**journalists_get**](docs/JournalistApi.md#journalists_get) | **GET** /journalists | List all instances of Journalist
*JournalistApi* | [**journalists_id_get**](docs/JournalistApi.md#journalists_id_get) | **GET** /journalists/{id} | Get a single Journalist by its id
*JudgeApi* | [**judges_get**](docs/JudgeApi.md#judges_get) | **GET** /judges | List all instances of Judge
*JudgeApi* | [**judges_id_get**](docs/JudgeApi.md#judges_id_get) | **GET** /judges/{id} | Get a single Judge by its id
*LacrosseLeagueApi* | [**lacrosseleagues_get**](docs/LacrosseLeagueApi.md#lacrosseleagues_get) | **GET** /lacrosseleagues | List all instances of LacrosseLeague
*LacrosseLeagueApi* | [**lacrosseleagues_id_get**](docs/LacrosseLeagueApi.md#lacrosseleagues_id_get) | **GET** /lacrosseleagues/{id} | Get a single LacrosseLeague by its id
*LacrossePlayerApi* | [**lacrosseplayers_get**](docs/LacrossePlayerApi.md#lacrosseplayers_get) | **GET** /lacrosseplayers | List all instances of LacrossePlayer
*LacrossePlayerApi* | [**lacrosseplayers_id_get**](docs/LacrossePlayerApi.md#lacrosseplayers_id_get) | **GET** /lacrosseplayers/{id} | Get a single LacrossePlayer by its id
*LakeApi* | [**lakes_get**](docs/LakeApi.md#lakes_get) | **GET** /lakes | List all instances of Lake
*LakeApi* | [**lakes_id_get**](docs/LakeApi.md#lakes_id_get) | **GET** /lakes/{id} | Get a single Lake by its id
*LanguageApi* | [**languages_get**](docs/LanguageApi.md#languages_get) | **GET** /languages | List all instances of Language
*LanguageApi* | [**languages_id_get**](docs/LanguageApi.md#languages_id_get) | **GET** /languages/{id} | Get a single Language by its id
*LaunchPadApi* | [**launchpads_get**](docs/LaunchPadApi.md#launchpads_get) | **GET** /launchpads | List all instances of LaunchPad
*LaunchPadApi* | [**launchpads_id_get**](docs/LaunchPadApi.md#launchpads_id_get) | **GET** /launchpads/{id} | Get a single LaunchPad by its id
*LawFirmApi* | [**lawfirms_get**](docs/LawFirmApi.md#lawfirms_get) | **GET** /lawfirms | List all instances of LawFirm
*LawFirmApi* | [**lawfirms_id_get**](docs/LawFirmApi.md#lawfirms_id_get) | **GET** /lawfirms/{id} | Get a single LawFirm by its id
*LawyerApi* | [**lawyers_get**](docs/LawyerApi.md#lawyers_get) | **GET** /lawyers | List all instances of Lawyer
*LawyerApi* | [**lawyers_id_get**](docs/LawyerApi.md#lawyers_id_get) | **GET** /lawyers/{id} | Get a single Lawyer by its id
*LebanonSettlementApi* | [**lebanonsettlements_get**](docs/LebanonSettlementApi.md#lebanonsettlements_get) | **GET** /lebanonsettlements | List all instances of LebanonSettlement
*LebanonSettlementApi* | [**lebanonsettlements_id_get**](docs/LebanonSettlementApi.md#lebanonsettlements_id_get) | **GET** /lebanonsettlements/{id} | Get a single LebanonSettlement by its id
*LegalCaseApi* | [**legalcases_get**](docs/LegalCaseApi.md#legalcases_get) | **GET** /legalcases | List all instances of LegalCase
*LegalCaseApi* | [**legalcases_id_get**](docs/LegalCaseApi.md#legalcases_id_get) | **GET** /legalcases/{id} | Get a single LegalCase by its id
*LegislatureApi* | [**legislatures_get**](docs/LegislatureApi.md#legislatures_get) | **GET** /legislatures | List all instances of Legislature
*LegislatureApi* | [**legislatures_id_get**](docs/LegislatureApi.md#legislatures_id_get) | **GET** /legislatures/{id} | Get a single Legislature by its id
*LetterApi* | [**letters_get**](docs/LetterApi.md#letters_get) | **GET** /letters | List all instances of Letter
*LetterApi* | [**letters_id_get**](docs/LetterApi.md#letters_id_get) | **GET** /letters/{id} | Get a single Letter by its id
*LibraryApi* | [**librarys_get**](docs/LibraryApi.md#librarys_get) | **GET** /librarys | List all instances of Library
*LibraryApi* | [**librarys_id_get**](docs/LibraryApi.md#librarys_id_get) | **GET** /librarys/{id} | Get a single Library by its id
*LiechtensteinSettlementApi* | [**liechtensteinsettlements_get**](docs/LiechtensteinSettlementApi.md#liechtensteinsettlements_get) | **GET** /liechtensteinsettlements | List all instances of LiechtensteinSettlement
*LiechtensteinSettlementApi* | [**liechtensteinsettlements_id_get**](docs/LiechtensteinSettlementApi.md#liechtensteinsettlements_id_get) | **GET** /liechtensteinsettlements/{id} | Get a single LiechtensteinSettlement by its id
*LieutenantApi* | [**lieutenants_get**](docs/LieutenantApi.md#lieutenants_get) | **GET** /lieutenants | List all instances of Lieutenant
*LieutenantApi* | [**lieutenants_id_get**](docs/LieutenantApi.md#lieutenants_id_get) | **GET** /lieutenants/{id} | Get a single Lieutenant by its id
*LifeCycleEventApi* | [**lifecycleevents_get**](docs/LifeCycleEventApi.md#lifecycleevents_get) | **GET** /lifecycleevents | List all instances of LifeCycleEvent
*LifeCycleEventApi* | [**lifecycleevents_id_get**](docs/LifeCycleEventApi.md#lifecycleevents_id_get) | **GET** /lifecycleevents/{id} | Get a single LifeCycleEvent by its id
*LigamentApi* | [**ligaments_get**](docs/LigamentApi.md#ligaments_get) | **GET** /ligaments | List all instances of Ligament
*LigamentApi* | [**ligaments_id_get**](docs/LigamentApi.md#ligaments_id_get) | **GET** /ligaments/{id} | Get a single Ligament by its id
*LightNovelApi* | [**lightnovels_get**](docs/LightNovelApi.md#lightnovels_get) | **GET** /lightnovels | List all instances of LightNovel
*LightNovelApi* | [**lightnovels_id_get**](docs/LightNovelApi.md#lightnovels_id_get) | **GET** /lightnovels/{id} | Get a single LightNovel by its id
*LighthouseApi* | [**lighthouses_get**](docs/LighthouseApi.md#lighthouses_get) | **GET** /lighthouses | List all instances of Lighthouse
*LighthouseApi* | [**lighthouses_id_get**](docs/LighthouseApi.md#lighthouses_id_get) | **GET** /lighthouses/{id} | Get a single Lighthouse by its id
*LineOfFashionApi* | [**lineoffashions_get**](docs/LineOfFashionApi.md#lineoffashions_get) | **GET** /lineoffashions | List all instances of LineOfFashion
*LineOfFashionApi* | [**lineoffashions_id_get**](docs/LineOfFashionApi.md#lineoffashions_id_get) | **GET** /lineoffashions/{id} | Get a single LineOfFashion by its id
*LinguistApi* | [**linguists_get**](docs/LinguistApi.md#linguists_get) | **GET** /linguists | List all instances of Linguist
*LinguistApi* | [**linguists_id_get**](docs/LinguistApi.md#linguists_id_get) | **GET** /linguists/{id} | Get a single Linguist by its id
*ListApi* | [**lists_get**](docs/ListApi.md#lists_get) | **GET** /lists | List all instances of List
*ListApi* | [**lists_id_get**](docs/ListApi.md#lists_id_get) | **GET** /lists/{id} | Get a single List by its id
*ListenApi* | [**listens_get**](docs/ListenApi.md#listens_get) | **GET** /listens | List all instances of Listen
*ListenApi* | [**listens_id_get**](docs/ListenApi.md#listens_id_get) | **GET** /listens/{id} | Get a single Listen by its id
*LocalityApi* | [**localitys_get**](docs/LocalityApi.md#localitys_get) | **GET** /localitys | List all instances of Locality
*LocalityApi* | [**localitys_id_get**](docs/LocalityApi.md#localitys_id_get) | **GET** /localitys/{id} | Get a single Locality by its id
*LockApi* | [**locks_get**](docs/LockApi.md#locks_get) | **GET** /locks | List all instances of Lock
*LockApi* | [**locks_id_get**](docs/LockApi.md#locks_id_get) | **GET** /locks/{id} | Get a single Lock by its id
*LocomotiveApi* | [**locomotives_get**](docs/LocomotiveApi.md#locomotives_get) | **GET** /locomotives | List all instances of Locomotive
*LocomotiveApi* | [**locomotives_id_get**](docs/LocomotiveApi.md#locomotives_id_get) | **GET** /locomotives/{id} | Get a single Locomotive by its id
*LunarCraterApi* | [**lunarcraters_get**](docs/LunarCraterApi.md#lunarcraters_get) | **GET** /lunarcraters | List all instances of LunarCrater
*LunarCraterApi* | [**lunarcraters_id_get**](docs/LunarCraterApi.md#lunarcraters_id_get) | **GET** /lunarcraters/{id} | Get a single LunarCrater by its id
*LymphApi* | [**lymphs_get**](docs/LymphApi.md#lymphs_get) | **GET** /lymphs | List all instances of Lymph
*LymphApi* | [**lymphs_id_get**](docs/LymphApi.md#lymphs_id_get) | **GET** /lymphs/{id} | Get a single Lymph by its id
*MagazineApi* | [**magazines_get**](docs/MagazineApi.md#magazines_get) | **GET** /magazines | List all instances of Magazine
*MagazineApi* | [**magazines_id_get**](docs/MagazineApi.md#magazines_id_get) | **GET** /magazines/{id} | Get a single Magazine by its id
*MammalApi* | [**mammals_get**](docs/MammalApi.md#mammals_get) | **GET** /mammals | List all instances of Mammal
*MammalApi* | [**mammals_id_get**](docs/MammalApi.md#mammals_id_get) | **GET** /mammals/{id} | Get a single Mammal by its id
*MangaApi* | [**mangas_get**](docs/MangaApi.md#mangas_get) | **GET** /mangas | List all instances of Manga
*MangaApi* | [**mangas_id_get**](docs/MangaApi.md#mangas_id_get) | **GET** /mangas/{id} | Get a single Manga by its id
*ManhuaApi* | [**manhuas_get**](docs/ManhuaApi.md#manhuas_get) | **GET** /manhuas | List all instances of Manhua
*ManhuaApi* | [**manhuas_id_get**](docs/ManhuaApi.md#manhuas_id_get) | **GET** /manhuas/{id} | Get a single Manhua by its id
*ManhwaApi* | [**manhwas_get**](docs/ManhwaApi.md#manhwas_get) | **GET** /manhwas | List all instances of Manhwa
*ManhwaApi* | [**manhwas_id_get**](docs/ManhwaApi.md#manhwas_id_get) | **GET** /manhwas/{id} | Get a single Manhwa by its id
*MarriageApi* | [**marriages_get**](docs/MarriageApi.md#marriages_get) | **GET** /marriages | List all instances of Marriage
*MarriageApi* | [**marriages_id_get**](docs/MarriageApi.md#marriages_id_get) | **GET** /marriages/{id} | Get a single Marriage by its id
*MartialArtistApi* | [**martialartists_get**](docs/MartialArtistApi.md#martialartists_get) | **GET** /martialartists | List all instances of MartialArtist
*MartialArtistApi* | [**martialartists_id_get**](docs/MartialArtistApi.md#martialartists_id_get) | **GET** /martialartists/{id} | Get a single MartialArtist by its id
*MayorApi* | [**mayors_get**](docs/MayorApi.md#mayors_get) | **GET** /mayors | List all instances of Mayor
*MayorApi* | [**mayors_id_get**](docs/MayorApi.md#mayors_id_get) | **GET** /mayors/{id} | Get a single Mayor by its id
*MeanOfTransportationApi* | [**meanoftransportations_get**](docs/MeanOfTransportationApi.md#meanoftransportations_get) | **GET** /meanoftransportations | List all instances of MeanOfTransportation
*MeanOfTransportationApi* | [**meanoftransportations_id_get**](docs/MeanOfTransportationApi.md#meanoftransportations_id_get) | **GET** /meanoftransportations/{id} | Get a single MeanOfTransportation by its id
*MediaApi* | [**medias_get**](docs/MediaApi.md#medias_get) | **GET** /medias | List all instances of Media
*MediaApi* | [**medias_id_get**](docs/MediaApi.md#medias_id_get) | **GET** /medias/{id} | Get a single Media by its id
*MedicianApi* | [**medicians_get**](docs/MedicianApi.md#medicians_get) | **GET** /medicians | List all instances of Medician
*MedicianApi* | [**medicians_id_get**](docs/MedicianApi.md#medicians_id_get) | **GET** /medicians/{id} | Get a single Medician by its id
*MeetingApi* | [**meetings_get**](docs/MeetingApi.md#meetings_get) | **GET** /meetings | List all instances of Meeting
*MeetingApi* | [**meetings_id_get**](docs/MeetingApi.md#meetings_id_get) | **GET** /meetings/{id} | Get a single Meeting by its id
*MemberOfParliamentApi* | [**memberofparliaments_get**](docs/MemberOfParliamentApi.md#memberofparliaments_get) | **GET** /memberofparliaments | List all instances of MemberOfParliament
*MemberOfParliamentApi* | [**memberofparliaments_id_get**](docs/MemberOfParliamentApi.md#memberofparliaments_id_get) | **GET** /memberofparliaments/{id} | Get a single MemberOfParliament by its id
*MemorialApi* | [**memorials_get**](docs/MemorialApi.md#memorials_get) | **GET** /memorials | List all instances of Memorial
*MemorialApi* | [**memorials_id_get**](docs/MemorialApi.md#memorials_id_get) | **GET** /memorials/{id} | Get a single Memorial by its id
*MetroStationApi* | [**metrostations_get**](docs/MetroStationApi.md#metrostations_get) | **GET** /metrostations | List all instances of MetroStation
*MetroStationApi* | [**metrostations_id_get**](docs/MetroStationApi.md#metrostations_id_get) | **GET** /metrostations/{id} | Get a single MetroStation by its id
*MicroRegionApi* | [**microregions_get**](docs/MicroRegionApi.md#microregions_get) | **GET** /microregions | List all instances of MicroRegion
*MicroRegionApi* | [**microregions_id_get**](docs/MicroRegionApi.md#microregions_id_get) | **GET** /microregions/{id} | Get a single MicroRegion by its id
*MilitaryConflictApi* | [**militaryconflicts_get**](docs/MilitaryConflictApi.md#militaryconflicts_get) | **GET** /militaryconflicts | List all instances of MilitaryConflict
*MilitaryConflictApi* | [**militaryconflicts_id_get**](docs/MilitaryConflictApi.md#militaryconflicts_id_get) | **GET** /militaryconflicts/{id} | Get a single MilitaryConflict by its id
*MilitaryPersonApi* | [**militarypersons_get**](docs/MilitaryPersonApi.md#militarypersons_get) | **GET** /militarypersons | List all instances of MilitaryPerson
*MilitaryPersonApi* | [**militarypersons_id_get**](docs/MilitaryPersonApi.md#militarypersons_id_get) | **GET** /militarypersons/{id} | Get a single MilitaryPerson by its id
*MilitaryStructureApi* | [**militarystructures_get**](docs/MilitaryStructureApi.md#militarystructures_get) | **GET** /militarystructures | List all instances of MilitaryStructure
*MilitaryStructureApi* | [**militarystructures_id_get**](docs/MilitaryStructureApi.md#militarystructures_id_get) | **GET** /militarystructures/{id} | Get a single MilitaryStructure by its id
*MilitaryUnitApi* | [**militaryunits_get**](docs/MilitaryUnitApi.md#militaryunits_get) | **GET** /militaryunits | List all instances of MilitaryUnit
*MilitaryUnitApi* | [**militaryunits_id_get**](docs/MilitaryUnitApi.md#militaryunits_id_get) | **GET** /militaryunits/{id} | Get a single MilitaryUnit by its id
*MillApi* | [**mills_get**](docs/MillApi.md#mills_get) | **GET** /mills | List all instances of Mill
*MillApi* | [**mills_id_get**](docs/MillApi.md#mills_id_get) | **GET** /mills/{id} | Get a single Mill by its id
*MineralApi* | [**minerals_get**](docs/MineralApi.md#minerals_get) | **GET** /minerals | List all instances of Mineral
*MineralApi* | [**minerals_id_get**](docs/MineralApi.md#minerals_id_get) | **GET** /minerals/{id} | Get a single Mineral by its id
*MixedMartialArtsEventApi* | [**mixedmartialartsevents_get**](docs/MixedMartialArtsEventApi.md#mixedmartialartsevents_get) | **GET** /mixedmartialartsevents | List all instances of MixedMartialArtsEvent
*MixedMartialArtsEventApi* | [**mixedmartialartsevents_id_get**](docs/MixedMartialArtsEventApi.md#mixedmartialartsevents_id_get) | **GET** /mixedmartialartsevents/{id} | Get a single MixedMartialArtsEvent by its id
*MixedMartialArtsLeagueApi* | [**mixedmartialartsleagues_get**](docs/MixedMartialArtsLeagueApi.md#mixedmartialartsleagues_get) | **GET** /mixedmartialartsleagues | List all instances of MixedMartialArtsLeague
*MixedMartialArtsLeagueApi* | [**mixedmartialartsleagues_id_get**](docs/MixedMartialArtsLeagueApi.md#mixedmartialartsleagues_id_get) | **GET** /mixedmartialartsleagues/{id} | Get a single MixedMartialArtsLeague by its id
*ModelApi* | [**models_get**](docs/ModelApi.md#models_get) | **GET** /models | List all instances of Model
*ModelApi* | [**models_id_get**](docs/ModelApi.md#models_id_get) | **GET** /models/{id} | Get a single Model by its id
*MolluscaApi* | [**molluscas_get**](docs/MolluscaApi.md#molluscas_get) | **GET** /molluscas | List all instances of Mollusca
*MolluscaApi* | [**molluscas_id_get**](docs/MolluscaApi.md#molluscas_id_get) | **GET** /molluscas/{id} | Get a single Mollusca by its id
*MonarchApi* | [**monarchs_get**](docs/MonarchApi.md#monarchs_get) | **GET** /monarchs | List all instances of Monarch
*MonarchApi* | [**monarchs_id_get**](docs/MonarchApi.md#monarchs_id_get) | **GET** /monarchs/{id} | Get a single Monarch by its id
*MonasteryApi* | [**monasterys_get**](docs/MonasteryApi.md#monasterys_get) | **GET** /monasterys | List all instances of Monastery
*MonasteryApi* | [**monasterys_id_get**](docs/MonasteryApi.md#monasterys_id_get) | **GET** /monasterys/{id} | Get a single Monastery by its id
*MonastryApi* | [**monastrys_get**](docs/MonastryApi.md#monastrys_get) | **GET** /monastrys | List all instances of Monastry
*MonastryApi* | [**monastrys_id_get**](docs/MonastryApi.md#monastrys_id_get) | **GET** /monastrys/{id} | Get a single Monastry by its id
*MonumentApi* | [**monuments_get**](docs/MonumentApi.md#monuments_get) | **GET** /monuments | List all instances of Monument
*MonumentApi* | [**monuments_id_get**](docs/MonumentApi.md#monuments_id_get) | **GET** /monuments/{id} | Get a single Monument by its id
*MosqueApi* | [**mosques_get**](docs/MosqueApi.md#mosques_get) | **GET** /mosques | List all instances of Mosque
*MosqueApi* | [**mosques_id_get**](docs/MosqueApi.md#mosques_id_get) | **GET** /mosques/{id} | Get a single Mosque by its id
*MossApi* | [**mosss_get**](docs/MossApi.md#mosss_get) | **GET** /mosss | List all instances of Moss
*MossApi* | [**mosss_id_get**](docs/MossApi.md#mosss_id_get) | **GET** /mosss/{id} | Get a single Moss by its id
*MotocycleRacerApi* | [**motocycleracers_get**](docs/MotocycleRacerApi.md#motocycleracers_get) | **GET** /motocycleracers | List all instances of MotocycleRacer
*MotocycleRacerApi* | [**motocycleracers_id_get**](docs/MotocycleRacerApi.md#motocycleracers_id_get) | **GET** /motocycleracers/{id} | Get a single MotocycleRacer by its id
*MotorcycleApi* | [**motorcycles_get**](docs/MotorcycleApi.md#motorcycles_get) | **GET** /motorcycles | List all instances of Motorcycle
*MotorcycleApi* | [**motorcycles_id_get**](docs/MotorcycleApi.md#motorcycles_id_get) | **GET** /motorcycles/{id} | Get a single Motorcycle by its id
*MotorcycleRacingLeagueApi* | [**motorcycleracingleagues_get**](docs/MotorcycleRacingLeagueApi.md#motorcycleracingleagues_get) | **GET** /motorcycleracingleagues | List all instances of MotorcycleRacingLeague
*MotorcycleRacingLeagueApi* | [**motorcycleracingleagues_id_get**](docs/MotorcycleRacingLeagueApi.md#motorcycleracingleagues_id_get) | **GET** /motorcycleracingleagues/{id} | Get a single MotorcycleRacingLeague by its id
*MotorcycleRiderApi* | [**motorcycleriders_get**](docs/MotorcycleRiderApi.md#motorcycleriders_get) | **GET** /motorcycleriders | List all instances of MotorcycleRider
*MotorcycleRiderApi* | [**motorcycleriders_id_get**](docs/MotorcycleRiderApi.md#motorcycleriders_id_get) | **GET** /motorcycleriders/{id} | Get a single MotorcycleRider by its id
*MotorsportRacerApi* | [**motorsportracers_get**](docs/MotorsportRacerApi.md#motorsportracers_get) | **GET** /motorsportracers | List all instances of MotorsportRacer
*MotorsportRacerApi* | [**motorsportracers_id_get**](docs/MotorsportRacerApi.md#motorsportracers_id_get) | **GET** /motorsportracers/{id} | Get a single MotorsportRacer by its id
*MotorsportSeasonApi* | [**motorsportseasons_get**](docs/MotorsportSeasonApi.md#motorsportseasons_get) | **GET** /motorsportseasons | List all instances of MotorsportSeason
*MotorsportSeasonApi* | [**motorsportseasons_id_get**](docs/MotorsportSeasonApi.md#motorsportseasons_id_get) | **GET** /motorsportseasons/{id} | Get a single MotorsportSeason by its id
*MountainApi* | [**mountains_get**](docs/MountainApi.md#mountains_get) | **GET** /mountains | List all instances of Mountain
*MountainApi* | [**mountains_id_get**](docs/MountainApi.md#mountains_id_get) | **GET** /mountains/{id} | Get a single Mountain by its id
*MountainPassApi* | [**mountainpasss_get**](docs/MountainPassApi.md#mountainpasss_get) | **GET** /mountainpasss | List all instances of MountainPass
*MountainPassApi* | [**mountainpasss_id_get**](docs/MountainPassApi.md#mountainpasss_id_get) | **GET** /mountainpasss/{id} | Get a single MountainPass by its id
*MountainRangeApi* | [**mountainranges_get**](docs/MountainRangeApi.md#mountainranges_get) | **GET** /mountainranges | List all instances of MountainRange
*MountainRangeApi* | [**mountainranges_id_get**](docs/MountainRangeApi.md#mountainranges_id_get) | **GET** /mountainranges/{id} | Get a single MountainRange by its id
*MouseGeneApi* | [**mousegenes_get**](docs/MouseGeneApi.md#mousegenes_get) | **GET** /mousegenes | List all instances of MouseGene
*MouseGeneApi* | [**mousegenes_id_get**](docs/MouseGeneApi.md#mousegenes_id_get) | **GET** /mousegenes/{id} | Get a single MouseGene by its id
*MouseGeneLocationApi* | [**mousegenelocations_get**](docs/MouseGeneLocationApi.md#mousegenelocations_get) | **GET** /mousegenelocations | List all instances of MouseGeneLocation
*MouseGeneLocationApi* | [**mousegenelocations_id_get**](docs/MouseGeneLocationApi.md#mousegenelocations_id_get) | **GET** /mousegenelocations/{id} | Get a single MouseGeneLocation by its id
*MovieDirectorApi* | [**moviedirectors_get**](docs/MovieDirectorApi.md#moviedirectors_get) | **GET** /moviedirectors | List all instances of MovieDirector
*MovieDirectorApi* | [**moviedirectors_id_get**](docs/MovieDirectorApi.md#moviedirectors_id_get) | **GET** /moviedirectors/{id} | Get a single MovieDirector by its id
*MovieGenreApi* | [**moviegenres_get**](docs/MovieGenreApi.md#moviegenres_get) | **GET** /moviegenres | List all instances of MovieGenre
*MovieGenreApi* | [**moviegenres_id_get**](docs/MovieGenreApi.md#moviegenres_id_get) | **GET** /moviegenres/{id} | Get a single MovieGenre by its id
*MovingImageApi* | [**movingimages_get**](docs/MovingImageApi.md#movingimages_get) | **GET** /movingimages | List all instances of MovingImage
*MovingImageApi* | [**movingimages_id_get**](docs/MovingImageApi.md#movingimages_id_get) | **GET** /movingimages/{id} | Get a single MovingImage by its id
*MultiVolumePublicationApi* | [**multivolumepublications_get**](docs/MultiVolumePublicationApi.md#multivolumepublications_get) | **GET** /multivolumepublications | List all instances of MultiVolumePublication
*MultiVolumePublicationApi* | [**multivolumepublications_id_get**](docs/MultiVolumePublicationApi.md#multivolumepublications_id_get) | **GET** /multivolumepublications/{id} | Get a single MultiVolumePublication by its id
*MunicipalityApi* | [**municipalitys_get**](docs/MunicipalityApi.md#municipalitys_get) | **GET** /municipalitys | List all instances of Municipality
*MunicipalityApi* | [**municipalitys_id_get**](docs/MunicipalityApi.md#municipalitys_id_get) | **GET** /municipalitys/{id} | Get a single Municipality by its id
*MurdererApi* | [**murderers_get**](docs/MurdererApi.md#murderers_get) | **GET** /murderers | List all instances of Murderer
*MurdererApi* | [**murderers_id_get**](docs/MurdererApi.md#murderers_id_get) | **GET** /murderers/{id} | Get a single Murderer by its id
*MuscleApi* | [**muscles_get**](docs/MuscleApi.md#muscles_get) | **GET** /muscles | List all instances of Muscle
*MuscleApi* | [**muscles_id_get**](docs/MuscleApi.md#muscles_id_get) | **GET** /muscles/{id} | Get a single Muscle by its id
*MuseumApi* | [**museums_get**](docs/MuseumApi.md#museums_get) | **GET** /museums | List all instances of Museum
*MuseumApi* | [**museums_id_get**](docs/MuseumApi.md#museums_id_get) | **GET** /museums/{id} | Get a single Museum by its id
*MusicComposerApi* | [**musiccomposers_get**](docs/MusicComposerApi.md#musiccomposers_get) | **GET** /musiccomposers | List all instances of MusicComposer
*MusicComposerApi* | [**musiccomposers_id_get**](docs/MusicComposerApi.md#musiccomposers_id_get) | **GET** /musiccomposers/{id} | Get a single MusicComposer by its id
*MusicDirectorApi* | [**musicdirectors_get**](docs/MusicDirectorApi.md#musicdirectors_get) | **GET** /musicdirectors | List all instances of MusicDirector
*MusicDirectorApi* | [**musicdirectors_id_get**](docs/MusicDirectorApi.md#musicdirectors_id_get) | **GET** /musicdirectors/{id} | Get a single MusicDirector by its id
*MusicFestivalApi* | [**musicfestivals_get**](docs/MusicFestivalApi.md#musicfestivals_get) | **GET** /musicfestivals | List all instances of MusicFestival
*MusicFestivalApi* | [**musicfestivals_id_get**](docs/MusicFestivalApi.md#musicfestivals_id_get) | **GET** /musicfestivals/{id} | Get a single MusicFestival by its id
*MusicGenreApi* | [**musicgenres_get**](docs/MusicGenreApi.md#musicgenres_get) | **GET** /musicgenres | List all instances of MusicGenre
*MusicGenreApi* | [**musicgenres_id_get**](docs/MusicGenreApi.md#musicgenres_id_get) | **GET** /musicgenres/{id} | Get a single MusicGenre by its id
*MusicalApi* | [**musicals_get**](docs/MusicalApi.md#musicals_get) | **GET** /musicals | List all instances of Musical
*MusicalApi* | [**musicals_id_get**](docs/MusicalApi.md#musicals_id_get) | **GET** /musicals/{id} | Get a single Musical by its id
*MusicalArtistApi* | [**musicalartists_get**](docs/MusicalArtistApi.md#musicalartists_get) | **GET** /musicalartists | List all instances of MusicalArtist
*MusicalArtistApi* | [**musicalartists_id_get**](docs/MusicalArtistApi.md#musicalartists_id_get) | **GET** /musicalartists/{id} | Get a single MusicalArtist by its id
*MusicalWorkApi* | [**musicalworks_get**](docs/MusicalWorkApi.md#musicalworks_get) | **GET** /musicalworks | List all instances of MusicalWork
*MusicalWorkApi* | [**musicalworks_id_get**](docs/MusicalWorkApi.md#musicalworks_id_get) | **GET** /musicalworks/{id} | Get a single MusicalWork by its id
*MythologicalFigureApi* | [**mythologicalfigures_get**](docs/MythologicalFigureApi.md#mythologicalfigures_get) | **GET** /mythologicalfigures | List all instances of MythologicalFigure
*MythologicalFigureApi* | [**mythologicalfigures_id_get**](docs/MythologicalFigureApi.md#mythologicalfigures_id_get) | **GET** /mythologicalfigures/{id} | Get a single MythologicalFigure by its id
*NCAATeamSeasonApi* | [**ncaateamseasons_get**](docs/NCAATeamSeasonApi.md#ncaateamseasons_get) | **GET** /ncaateamseasons | List all instances of NCAATeamSeason
*NCAATeamSeasonApi* | [**ncaateamseasons_id_get**](docs/NCAATeamSeasonApi.md#ncaateamseasons_id_get) | **GET** /ncaateamseasons/{id} | Get a single NCAATeamSeason by its id
*NameApi* | [**names_get**](docs/NameApi.md#names_get) | **GET** /names | List all instances of Name
*NameApi* | [**names_id_get**](docs/NameApi.md#names_id_get) | **GET** /names/{id} | Get a single Name by its id
*NarutoCharacterApi* | [**narutocharacters_get**](docs/NarutoCharacterApi.md#narutocharacters_get) | **GET** /narutocharacters | List all instances of NarutoCharacter
*NarutoCharacterApi* | [**narutocharacters_id_get**](docs/NarutoCharacterApi.md#narutocharacters_id_get) | **GET** /narutocharacters/{id} | Get a single NarutoCharacter by its id
*NascarDriverApi* | [**nascardrivers_get**](docs/NascarDriverApi.md#nascardrivers_get) | **GET** /nascardrivers | List all instances of NascarDriver
*NascarDriverApi* | [**nascardrivers_id_get**](docs/NascarDriverApi.md#nascardrivers_id_get) | **GET** /nascardrivers/{id} | Get a single NascarDriver by its id
*NationalAnthemApi* | [**nationalanthems_get**](docs/NationalAnthemApi.md#nationalanthems_get) | **GET** /nationalanthems | List all instances of NationalAnthem
*NationalAnthemApi* | [**nationalanthems_id_get**](docs/NationalAnthemApi.md#nationalanthems_id_get) | **GET** /nationalanthems/{id} | Get a single NationalAnthem by its id
*NationalCollegiateAthleticAssociationAthleteApi* | [**nationalcollegiateathleticassociationathletes_get**](docs/NationalCollegiateAthleticAssociationAthleteApi.md#nationalcollegiateathleticassociationathletes_get) | **GET** /nationalcollegiateathleticassociationathletes | List all instances of NationalCollegiateAthleticAssociationAthlete
*NationalCollegiateAthleticAssociationAthleteApi* | [**nationalcollegiateathleticassociationathletes_id_get**](docs/NationalCollegiateAthleticAssociationAthleteApi.md#nationalcollegiateathleticassociationathletes_id_get) | **GET** /nationalcollegiateathleticassociationathletes/{id} | Get a single NationalCollegiateAthleticAssociationAthlete by its id
*NationalFootballLeagueEventApi* | [**nationalfootballleagueevents_get**](docs/NationalFootballLeagueEventApi.md#nationalfootballleagueevents_get) | **GET** /nationalfootballleagueevents | List all instances of NationalFootballLeagueEvent
*NationalFootballLeagueEventApi* | [**nationalfootballleagueevents_id_get**](docs/NationalFootballLeagueEventApi.md#nationalfootballleagueevents_id_get) | **GET** /nationalfootballleagueevents/{id} | Get a single NationalFootballLeagueEvent by its id
*NationalFootballLeagueSeasonApi* | [**nationalfootballleagueseasons_get**](docs/NationalFootballLeagueSeasonApi.md#nationalfootballleagueseasons_get) | **GET** /nationalfootballleagueseasons | List all instances of NationalFootballLeagueSeason
*NationalFootballLeagueSeasonApi* | [**nationalfootballleagueseasons_id_get**](docs/NationalFootballLeagueSeasonApi.md#nationalfootballleagueseasons_id_get) | **GET** /nationalfootballleagueseasons/{id} | Get a single NationalFootballLeagueSeason by its id
*NationalSoccerClubApi* | [**nationalsoccerclubs_get**](docs/NationalSoccerClubApi.md#nationalsoccerclubs_get) | **GET** /nationalsoccerclubs | List all instances of NationalSoccerClub
*NationalSoccerClubApi* | [**nationalsoccerclubs_id_get**](docs/NationalSoccerClubApi.md#nationalsoccerclubs_id_get) | **GET** /nationalsoccerclubs/{id} | Get a single NationalSoccerClub by its id
*NaturalEventApi* | [**naturalevents_get**](docs/NaturalEventApi.md#naturalevents_get) | **GET** /naturalevents | List all instances of NaturalEvent
*NaturalEventApi* | [**naturalevents_id_get**](docs/NaturalEventApi.md#naturalevents_id_get) | **GET** /naturalevents/{id} | Get a single NaturalEvent by its id
*NaturalPlaceApi* | [**naturalplaces_get**](docs/NaturalPlaceApi.md#naturalplaces_get) | **GET** /naturalplaces | List all instances of NaturalPlace
*NaturalPlaceApi* | [**naturalplaces_id_get**](docs/NaturalPlaceApi.md#naturalplaces_id_get) | **GET** /naturalplaces/{id} | Get a single NaturalPlace by its id
*NaturalRegionApi* | [**naturalregions_get**](docs/NaturalRegionApi.md#naturalregions_get) | **GET** /naturalregions | List all instances of NaturalRegion
*NaturalRegionApi* | [**naturalregions_id_get**](docs/NaturalRegionApi.md#naturalregions_id_get) | **GET** /naturalregions/{id} | Get a single NaturalRegion by its id
*NerveApi* | [**nerves_get**](docs/NerveApi.md#nerves_get) | **GET** /nerves | List all instances of Nerve
*NerveApi* | [**nerves_id_get**](docs/NerveApi.md#nerves_id_get) | **GET** /nerves/{id} | Get a single Nerve by its id
*NetballPlayerApi* | [**netballplayers_get**](docs/NetballPlayerApi.md#netballplayers_get) | **GET** /netballplayers | List all instances of NetballPlayer
*NetballPlayerApi* | [**netballplayers_id_get**](docs/NetballPlayerApi.md#netballplayers_id_get) | **GET** /netballplayers/{id} | Get a single NetballPlayer by its id
*NewspaperApi* | [**newspapers_get**](docs/NewspaperApi.md#newspapers_get) | **GET** /newspapers | List all instances of Newspaper
*NewspaperApi* | [**newspapers_id_get**](docs/NewspaperApi.md#newspapers_id_get) | **GET** /newspapers/{id} | Get a single Newspaper by its id
*NobelPrizeApi* | [**nobelprizes_get**](docs/NobelPrizeApi.md#nobelprizes_get) | **GET** /nobelprizes | List all instances of NobelPrize
*NobelPrizeApi* | [**nobelprizes_id_get**](docs/NobelPrizeApi.md#nobelprizes_id_get) | **GET** /nobelprizes/{id} | Get a single NobelPrize by its id
*NobleApi* | [**nobles_get**](docs/NobleApi.md#nobles_get) | **GET** /nobles | List all instances of Noble
*NobleApi* | [**nobles_id_get**](docs/NobleApi.md#nobles_id_get) | **GET** /nobles/{id} | Get a single Noble by its id
*NobleFamilyApi* | [**noblefamilys_get**](docs/NobleFamilyApi.md#noblefamilys_get) | **GET** /noblefamilys | List all instances of NobleFamily
*NobleFamilyApi* | [**noblefamilys_id_get**](docs/NobleFamilyApi.md#noblefamilys_id_get) | **GET** /noblefamilys/{id} | Get a single NobleFamily by its id
*NonProfitOrganisationApi* | [**non_profitorganisations_get**](docs/NonProfitOrganisationApi.md#non_profitorganisations_get) | **GET** /non-profitorganisations | List all instances of Non-ProfitOrganisation
*NonProfitOrganisationApi* | [**non_profitorganisations_id_get**](docs/NonProfitOrganisationApi.md#non_profitorganisations_id_get) | **GET** /non-profitorganisations/{id} | Get a single Non-ProfitOrganisation by its id
*NorwaySettlementApi* | [**norwaysettlements_get**](docs/NorwaySettlementApi.md#norwaysettlements_get) | **GET** /norwaysettlements | List all instances of NorwaySettlement
*NorwaySettlementApi* | [**norwaysettlements_id_get**](docs/NorwaySettlementApi.md#norwaysettlements_id_get) | **GET** /norwaysettlements/{id} | Get a single NorwaySettlement by its id
*NoteworthyPartOfBuildingApi* | [**noteworthypartofbuildings_get**](docs/NoteworthyPartOfBuildingApi.md#noteworthypartofbuildings_get) | **GET** /noteworthypartofbuildings | List all instances of NoteworthyPartOfBuilding
*NoteworthyPartOfBuildingApi* | [**noteworthypartofbuildings_id_get**](docs/NoteworthyPartOfBuildingApi.md#noteworthypartofbuildings_id_get) | **GET** /noteworthypartofbuildings/{id} | Get a single NoteworthyPartOfBuilding by its id
*NovelApi* | [**novels_get**](docs/NovelApi.md#novels_get) | **GET** /novels | List all instances of Novel
*NovelApi* | [**novels_id_get**](docs/NovelApi.md#novels_id_get) | **GET** /novels/{id} | Get a single Novel by its id
*NuclearPowerStationApi* | [**nuclearpowerstations_get**](docs/NuclearPowerStationApi.md#nuclearpowerstations_get) | **GET** /nuclearpowerstations | List all instances of NuclearPowerStation
*NuclearPowerStationApi* | [**nuclearpowerstations_id_get**](docs/NuclearPowerStationApi.md#nuclearpowerstations_id_get) | **GET** /nuclearpowerstations/{id} | Get a single NuclearPowerStation by its id
*OceanApi* | [**oceans_get**](docs/OceanApi.md#oceans_get) | **GET** /oceans | List all instances of Ocean
*OceanApi* | [**oceans_id_get**](docs/OceanApi.md#oceans_id_get) | **GET** /oceans/{id} | Get a single Ocean by its id
*OfficeHolderApi* | [**officeholders_get**](docs/OfficeHolderApi.md#officeholders_get) | **GET** /officeholders | List all instances of OfficeHolder
*OfficeHolderApi* | [**officeholders_id_get**](docs/OfficeHolderApi.md#officeholders_id_get) | **GET** /officeholders/{id} | Get a single OfficeHolder by its id
*OldTerritoryApi* | [**oldterritorys_get**](docs/OldTerritoryApi.md#oldterritorys_get) | **GET** /oldterritorys | List all instances of OldTerritory
*OldTerritoryApi* | [**oldterritorys_id_get**](docs/OldTerritoryApi.md#oldterritorys_id_get) | **GET** /oldterritorys/{id} | Get a single OldTerritory by its id
*OlympicEventApi* | [**olympicevents_get**](docs/OlympicEventApi.md#olympicevents_get) | **GET** /olympicevents | List all instances of OlympicEvent
*OlympicEventApi* | [**olympicevents_id_get**](docs/OlympicEventApi.md#olympicevents_id_get) | **GET** /olympicevents/{id} | Get a single OlympicEvent by its id
*OlympicResultApi* | [**olympicresults_get**](docs/OlympicResultApi.md#olympicresults_get) | **GET** /olympicresults | List all instances of OlympicResult
*OlympicResultApi* | [**olympicresults_id_get**](docs/OlympicResultApi.md#olympicresults_id_get) | **GET** /olympicresults/{id} | Get a single OlympicResult by its id
*OlympicsApi* | [**olympicss_get**](docs/OlympicsApi.md#olympicss_get) | **GET** /olympicss | List all instances of Olympics
*OlympicsApi* | [**olympicss_id_get**](docs/OlympicsApi.md#olympicss_id_get) | **GET** /olympicss/{id} | Get a single Olympics by its id
*OperaApi* | [**operas_get**](docs/OperaApi.md#operas_get) | **GET** /operas | List all instances of Opera
*OperaApi* | [**operas_id_get**](docs/OperaApi.md#operas_id_get) | **GET** /operas/{id} | Get a single Opera by its id
*OrganApi* | [**organs_get**](docs/OrganApi.md#organs_get) | **GET** /organs | List all instances of Organ
*OrganApi* | [**organs_id_get**](docs/OrganApi.md#organs_id_get) | **GET** /organs/{id} | Get a single Organ by its id
*OrganisationApi* | [**organisations_get**](docs/OrganisationApi.md#organisations_get) | **GET** /organisations | List all instances of Organisation
*OrganisationApi* | [**organisations_id_get**](docs/OrganisationApi.md#organisations_id_get) | **GET** /organisations/{id} | Get a single Organisation by its id
*OrganisationMemberApi* | [**organisationmembers_get**](docs/OrganisationMemberApi.md#organisationmembers_get) | **GET** /organisationmembers | List all instances of OrganisationMember
*OrganisationMemberApi* | [**organisationmembers_id_get**](docs/OrganisationMemberApi.md#organisationmembers_id_get) | **GET** /organisationmembers/{id} | Get a single OrganisationMember by its id
*OverseasDepartmentApi* | [**overseasdepartments_get**](docs/OverseasDepartmentApi.md#overseasdepartments_get) | **GET** /overseasdepartments | List all instances of OverseasDepartment
*OverseasDepartmentApi* | [**overseasdepartments_id_get**](docs/OverseasDepartmentApi.md#overseasdepartments_id_get) | **GET** /overseasdepartments/{id} | Get a single OverseasDepartment by its id
*PaintballLeagueApi* | [**paintballleagues_get**](docs/PaintballLeagueApi.md#paintballleagues_get) | **GET** /paintballleagues | List all instances of PaintballLeague
*PaintballLeagueApi* | [**paintballleagues_id_get**](docs/PaintballLeagueApi.md#paintballleagues_id_get) | **GET** /paintballleagues/{id} | Get a single PaintballLeague by its id
*PainterApi* | [**painters_get**](docs/PainterApi.md#painters_get) | **GET** /painters | List all instances of Painter
*PainterApi* | [**painters_id_get**](docs/PainterApi.md#painters_id_get) | **GET** /painters/{id} | Get a single Painter by its id
*PaintingApi* | [**paintings_get**](docs/PaintingApi.md#paintings_get) | **GET** /paintings | List all instances of Painting
*PaintingApi* | [**paintings_id_get**](docs/PaintingApi.md#paintings_id_get) | **GET** /paintings/{id} | Get a single Painting by its id
*ParishApi* | [**parishs_get**](docs/ParishApi.md#parishs_get) | **GET** /parishs | List all instances of Parish
*ParishApi* | [**parishs_id_get**](docs/ParishApi.md#parishs_id_get) | **GET** /parishs/{id} | Get a single Parish by its id
*ParkApi* | [**parks_get**](docs/ParkApi.md#parks_get) | **GET** /parks | List all instances of Park
*ParkApi* | [**parks_id_get**](docs/ParkApi.md#parks_id_get) | **GET** /parks/{id} | Get a single Park by its id
*ParliamentApi* | [**parliaments_get**](docs/ParliamentApi.md#parliaments_get) | **GET** /parliaments | List all instances of Parliament
*ParliamentApi* | [**parliaments_id_get**](docs/ParliamentApi.md#parliaments_id_get) | **GET** /parliaments/{id} | Get a single Parliament by its id
*PenaltyShootOutApi* | [**penaltyshootouts_get**](docs/PenaltyShootOutApi.md#penaltyshootouts_get) | **GET** /penaltyshootouts | List all instances of PenaltyShootOut
*PenaltyShootOutApi* | [**penaltyshootouts_id_get**](docs/PenaltyShootOutApi.md#penaltyshootouts_id_get) | **GET** /penaltyshootouts/{id} | Get a single PenaltyShootOut by its id
*PeriodOfArtisticStyleApi* | [**periodofartisticstyles_get**](docs/PeriodOfArtisticStyleApi.md#periodofartisticstyles_get) | **GET** /periodofartisticstyles | List all instances of PeriodOfArtisticStyle
*PeriodOfArtisticStyleApi* | [**periodofartisticstyles_id_get**](docs/PeriodOfArtisticStyleApi.md#periodofartisticstyles_id_get) | **GET** /periodofartisticstyles/{id} | Get a single PeriodOfArtisticStyle by its id
*PeriodicalLiteratureApi* | [**periodicalliteratures_get**](docs/PeriodicalLiteratureApi.md#periodicalliteratures_get) | **GET** /periodicalliteratures | List all instances of PeriodicalLiterature
*PeriodicalLiteratureApi* | [**periodicalliteratures_id_get**](docs/PeriodicalLiteratureApi.md#periodicalliteratures_id_get) | **GET** /periodicalliteratures/{id} | Get a single PeriodicalLiterature by its id
*PersonApi* | [**persons_get**](docs/PersonApi.md#persons_get) | **GET** /persons | List all instances of Person
*PersonApi* | [**persons_id_get**](docs/PersonApi.md#persons_id_get) | **GET** /persons/{id} | Get a single Person by its id
*PersonFunctionApi* | [**personfunctions_get**](docs/PersonFunctionApi.md#personfunctions_get) | **GET** /personfunctions | List all instances of PersonFunction
*PersonFunctionApi* | [**personfunctions_id_get**](docs/PersonFunctionApi.md#personfunctions_id_get) | **GET** /personfunctions/{id} | Get a single PersonFunction by its id
*PersonalEventApi* | [**personalevents_get**](docs/PersonalEventApi.md#personalevents_get) | **GET** /personalevents | List all instances of PersonalEvent
*PersonalEventApi* | [**personalevents_id_get**](docs/PersonalEventApi.md#personalevents_id_get) | **GET** /personalevents/{id} | Get a single PersonalEvent by its id
*PhilosopherApi* | [**philosophers_get**](docs/PhilosopherApi.md#philosophers_get) | **GET** /philosophers | List all instances of Philosopher
*PhilosopherApi* | [**philosophers_id_get**](docs/PhilosopherApi.md#philosophers_id_get) | **GET** /philosophers/{id} | Get a single Philosopher by its id
*PhotographerApi* | [**photographers_get**](docs/PhotographerApi.md#photographers_get) | **GET** /photographers | List all instances of Photographer
*PhotographerApi* | [**photographers_id_get**](docs/PhotographerApi.md#photographers_id_get) | **GET** /photographers/{id} | Get a single Photographer by its id
*PlaceApi* | [**places_get**](docs/PlaceApi.md#places_get) | **GET** /places | List all instances of Place
*PlaceApi* | [**places_id_get**](docs/PlaceApi.md#places_id_get) | **GET** /places/{id} | Get a single Place by its id
*PlanetApi* | [**planets_get**](docs/PlanetApi.md#planets_get) | **GET** /planets | List all instances of Planet
*PlanetApi* | [**planets_id_get**](docs/PlanetApi.md#planets_id_get) | **GET** /planets/{id} | Get a single Planet by its id
*PlantApi* | [**plants_get**](docs/PlantApi.md#plants_get) | **GET** /plants | List all instances of Plant
*PlantApi* | [**plants_id_get**](docs/PlantApi.md#plants_id_get) | **GET** /plants/{id} | Get a single Plant by its id
*PlayApi* | [**plays_get**](docs/PlayApi.md#plays_get) | **GET** /plays | List all instances of Play
*PlayApi* | [**plays_id_get**](docs/PlayApi.md#plays_id_get) | **GET** /plays/{id} | Get a single Play by its id
*PlayWrightApi* | [**playwrights_get**](docs/PlayWrightApi.md#playwrights_get) | **GET** /playwrights | List all instances of PlayWright
*PlayWrightApi* | [**playwrights_id_get**](docs/PlayWrightApi.md#playwrights_id_get) | **GET** /playwrights/{id} | Get a single PlayWright by its id
*PlayboyPlaymateApi* | [**playboyplaymates_get**](docs/PlayboyPlaymateApi.md#playboyplaymates_get) | **GET** /playboyplaymates | List all instances of PlayboyPlaymate
*PlayboyPlaymateApi* | [**playboyplaymates_id_get**](docs/PlayboyPlaymateApi.md#playboyplaymates_id_get) | **GET** /playboyplaymates/{id} | Get a single PlayboyPlaymate by its id
*PoemApi* | [**poems_get**](docs/PoemApi.md#poems_get) | **GET** /poems | List all instances of Poem
*PoemApi* | [**poems_id_get**](docs/PoemApi.md#poems_id_get) | **GET** /poems/{id} | Get a single Poem by its id
*PoetApi* | [**poets_get**](docs/PoetApi.md#poets_get) | **GET** /poets | List all instances of Poet
*PoetApi* | [**poets_id_get**](docs/PoetApi.md#poets_id_get) | **GET** /poets/{id} | Get a single Poet by its id
*PokerPlayerApi* | [**pokerplayers_get**](docs/PokerPlayerApi.md#pokerplayers_get) | **GET** /pokerplayers | List all instances of PokerPlayer
*PokerPlayerApi* | [**pokerplayers_id_get**](docs/PokerPlayerApi.md#pokerplayers_id_get) | **GET** /pokerplayers/{id} | Get a single PokerPlayer by its id
*PolishKingApi* | [**polishkings_get**](docs/PolishKingApi.md#polishkings_get) | **GET** /polishkings | List all instances of PolishKing
*PolishKingApi* | [**polishkings_id_get**](docs/PolishKingApi.md#polishkings_id_get) | **GET** /polishkings/{id} | Get a single PolishKing by its id
*PoliticalFunctionApi* | [**politicalfunctions_get**](docs/PoliticalFunctionApi.md#politicalfunctions_get) | **GET** /politicalfunctions | List all instances of PoliticalFunction
*PoliticalFunctionApi* | [**politicalfunctions_id_get**](docs/PoliticalFunctionApi.md#politicalfunctions_id_get) | **GET** /politicalfunctions/{id} | Get a single PoliticalFunction by its id
*PoliticalPartyApi* | [**politicalpartys_get**](docs/PoliticalPartyApi.md#politicalpartys_get) | **GET** /politicalpartys | List all instances of PoliticalParty
*PoliticalPartyApi* | [**politicalpartys_id_get**](docs/PoliticalPartyApi.md#politicalpartys_id_get) | **GET** /politicalpartys/{id} | Get a single PoliticalParty by its id
*PoliticianApi* | [**politicians_get**](docs/PoliticianApi.md#politicians_get) | **GET** /politicians | List all instances of Politician
*PoliticianApi* | [**politicians_id_get**](docs/PoliticianApi.md#politicians_id_get) | **GET** /politicians/{id} | Get a single Politician by its id
*PoliticianSpouseApi* | [**politicianspouses_get**](docs/PoliticianSpouseApi.md#politicianspouses_get) | **GET** /politicianspouses | List all instances of PoliticianSpouse
*PoliticianSpouseApi* | [**politicianspouses_id_get**](docs/PoliticianSpouseApi.md#politicianspouses_id_get) | **GET** /politicianspouses/{id} | Get a single PoliticianSpouse by its id
*PoloLeagueApi* | [**pololeagues_get**](docs/PoloLeagueApi.md#pololeagues_get) | **GET** /pololeagues | List all instances of PoloLeague
*PoloLeagueApi* | [**pololeagues_id_get**](docs/PoloLeagueApi.md#pololeagues_id_get) | **GET** /pololeagues/{id} | Get a single PoloLeague by its id
*PolyhedronApi* | [**polyhedrons_get**](docs/PolyhedronApi.md#polyhedrons_get) | **GET** /polyhedrons | List all instances of Polyhedron
*PolyhedronApi* | [**polyhedrons_id_get**](docs/PolyhedronApi.md#polyhedrons_id_get) | **GET** /polyhedrons/{id} | Get a single Polyhedron by its id
*PopeApi* | [**popes_get**](docs/PopeApi.md#popes_get) | **GET** /popes | List all instances of Pope
*PopeApi* | [**popes_id_get**](docs/PopeApi.md#popes_id_get) | **GET** /popes/{id} | Get a single Pope by its id
*PopulatedPlaceApi* | [**populatedplaces_get**](docs/PopulatedPlaceApi.md#populatedplaces_get) | **GET** /populatedplaces | List all instances of PopulatedPlace
*PopulatedPlaceApi* | [**populatedplaces_id_get**](docs/PopulatedPlaceApi.md#populatedplaces_id_get) | **GET** /populatedplaces/{id} | Get a single PopulatedPlace by its id
*PopulationApi* | [**populations_get**](docs/PopulationApi.md#populations_get) | **GET** /populations | List all instances of Population
*PopulationApi* | [**populations_id_get**](docs/PopulationApi.md#populations_id_get) | **GET** /populations/{id} | Get a single Population by its id
*PortApi* | [**ports_get**](docs/PortApi.md#ports_get) | **GET** /ports | List all instances of Port
*PortApi* | [**ports_id_get**](docs/PortApi.md#ports_id_get) | **GET** /ports/{id} | Get a single Port by its id
*PowerStationApi* | [**powerstations_get**](docs/PowerStationApi.md#powerstations_get) | **GET** /powerstations | List all instances of PowerStation
*PowerStationApi* | [**powerstations_id_get**](docs/PowerStationApi.md#powerstations_id_get) | **GET** /powerstations/{id} | Get a single PowerStation by its id
*PrefectureApi* | [**prefectures_get**](docs/PrefectureApi.md#prefectures_get) | **GET** /prefectures | List all instances of Prefecture
*PrefectureApi* | [**prefectures_id_get**](docs/PrefectureApi.md#prefectures_id_get) | **GET** /prefectures/{id} | Get a single Prefecture by its id
*PrehistoricalPeriodApi* | [**prehistoricalperiods_get**](docs/PrehistoricalPeriodApi.md#prehistoricalperiods_get) | **GET** /prehistoricalperiods | List all instances of PrehistoricalPeriod
*PrehistoricalPeriodApi* | [**prehistoricalperiods_id_get**](docs/PrehistoricalPeriodApi.md#prehistoricalperiods_id_get) | **GET** /prehistoricalperiods/{id} | Get a single PrehistoricalPeriod by its id
*PresenterApi* | [**presenters_get**](docs/PresenterApi.md#presenters_get) | **GET** /presenters | List all instances of Presenter
*PresenterApi* | [**presenters_id_get**](docs/PresenterApi.md#presenters_id_get) | **GET** /presenters/{id} | Get a single Presenter by its id
*PresidentApi* | [**presidents_get**](docs/PresidentApi.md#presidents_get) | **GET** /presidents | List all instances of President
*PresidentApi* | [**presidents_id_get**](docs/PresidentApi.md#presidents_id_get) | **GET** /presidents/{id} | Get a single President by its id
*PriestApi* | [**priests_get**](docs/PriestApi.md#priests_get) | **GET** /priests | List all instances of Priest
*PriestApi* | [**priests_id_get**](docs/PriestApi.md#priests_id_get) | **GET** /priests/{id} | Get a single Priest by its id
*PrimeMinisterApi* | [**primeministers_get**](docs/PrimeMinisterApi.md#primeministers_get) | **GET** /primeministers | List all instances of PrimeMinister
*PrimeMinisterApi* | [**primeministers_id_get**](docs/PrimeMinisterApi.md#primeministers_id_get) | **GET** /primeministers/{id} | Get a single PrimeMinister by its id
*PrisonApi* | [**prisons_get**](docs/PrisonApi.md#prisons_get) | **GET** /prisons | List all instances of Prison
*PrisonApi* | [**prisons_id_get**](docs/PrisonApi.md#prisons_id_get) | **GET** /prisons/{id} | Get a single Prison by its id
*ProducerApi* | [**producers_get**](docs/ProducerApi.md#producers_get) | **GET** /producers | List all instances of Producer
*ProducerApi* | [**producers_id_get**](docs/ProducerApi.md#producers_id_get) | **GET** /producers/{id} | Get a single Producer by its id
*ProfessionApi* | [**professions_get**](docs/ProfessionApi.md#professions_get) | **GET** /professions | List all instances of Profession
*ProfessionApi* | [**professions_id_get**](docs/ProfessionApi.md#professions_id_get) | **GET** /professions/{id} | Get a single Profession by its id
*ProfessorApi* | [**professors_get**](docs/ProfessorApi.md#professors_get) | **GET** /professors | List all instances of Professor
*ProfessorApi* | [**professors_id_get**](docs/ProfessorApi.md#professors_id_get) | **GET** /professors/{id} | Get a single Professor by its id
*ProgrammingLanguageApi* | [**programminglanguages_get**](docs/ProgrammingLanguageApi.md#programminglanguages_get) | **GET** /programminglanguages | List all instances of ProgrammingLanguage
*ProgrammingLanguageApi* | [**programminglanguages_id_get**](docs/ProgrammingLanguageApi.md#programminglanguages_id_get) | **GET** /programminglanguages/{id} | Get a single ProgrammingLanguage by its id
*ProjectApi* | [**projects_get**](docs/ProjectApi.md#projects_get) | **GET** /projects | List all instances of Project
*ProjectApi* | [**projects_id_get**](docs/ProjectApi.md#projects_id_get) | **GET** /projects/{id} | Get a single Project by its id
*ProtectedAreaApi* | [**protectedareas_get**](docs/ProtectedAreaApi.md#protectedareas_get) | **GET** /protectedareas | List all instances of ProtectedArea
*ProtectedAreaApi* | [**protectedareas_id_get**](docs/ProtectedAreaApi.md#protectedareas_id_get) | **GET** /protectedareas/{id} | Get a single ProtectedArea by its id
*ProteinApi* | [**proteins_get**](docs/ProteinApi.md#proteins_get) | **GET** /proteins | List all instances of Protein
*ProteinApi* | [**proteins_id_get**](docs/ProteinApi.md#proteins_id_get) | **GET** /proteins/{id} | Get a single Protein by its id
*ProtohistoricalPeriodApi* | [**protohistoricalperiods_get**](docs/ProtohistoricalPeriodApi.md#protohistoricalperiods_get) | **GET** /protohistoricalperiods | List all instances of ProtohistoricalPeriod
*ProtohistoricalPeriodApi* | [**protohistoricalperiods_id_get**](docs/ProtohistoricalPeriodApi.md#protohistoricalperiods_id_get) | **GET** /protohistoricalperiods/{id} | Get a single ProtohistoricalPeriod by its id
*ProvinceApi* | [**provinces_get**](docs/ProvinceApi.md#provinces_get) | **GET** /provinces | List all instances of Province
*ProvinceApi* | [**provinces_id_get**](docs/ProvinceApi.md#provinces_id_get) | **GET** /provinces/{id} | Get a single Province by its id
*PsychologistApi* | [**psychologists_get**](docs/PsychologistApi.md#psychologists_get) | **GET** /psychologists | List all instances of Psychologist
*PsychologistApi* | [**psychologists_id_get**](docs/PsychologistApi.md#psychologists_id_get) | **GET** /psychologists/{id} | Get a single Psychologist by its id
*PublicServiceApi* | [**publicservices_get**](docs/PublicServiceApi.md#publicservices_get) | **GET** /publicservices | List all instances of PublicService
*PublicServiceApi* | [**publicservices_id_get**](docs/PublicServiceApi.md#publicservices_id_get) | **GET** /publicservices/{id} | Get a single PublicService by its id
*PublicServiceInputApi* | [**publicserviceinputs_get**](docs/PublicServiceInputApi.md#publicserviceinputs_get) | **GET** /publicserviceinputs | List all instances of PublicServiceInput
*PublicServiceInputApi* | [**publicserviceinputs_id_get**](docs/PublicServiceInputApi.md#publicserviceinputs_id_get) | **GET** /publicserviceinputs/{id} | Get a single PublicServiceInput by its id
*PublicServiceOutputApi* | [**publicserviceoutputs_get**](docs/PublicServiceOutputApi.md#publicserviceoutputs_get) | **GET** /publicserviceoutputs | List all instances of PublicServiceOutput
*PublicServiceOutputApi* | [**publicserviceoutputs_id_get**](docs/PublicServiceOutputApi.md#publicserviceoutputs_id_get) | **GET** /publicserviceoutputs/{id} | Get a single PublicServiceOutput by its id
*PublicTransitSystemApi* | [**publictransitsystems_get**](docs/PublicTransitSystemApi.md#publictransitsystems_get) | **GET** /publictransitsystems | List all instances of PublicTransitSystem
*PublicTransitSystemApi* | [**publictransitsystems_id_get**](docs/PublicTransitSystemApi.md#publictransitsystems_id_get) | **GET** /publictransitsystems/{id} | Get a single PublicTransitSystem by its id
*PublisherApi* | [**publishers_get**](docs/PublisherApi.md#publishers_get) | **GET** /publishers | List all instances of Publisher
*PublisherApi* | [**publishers_id_get**](docs/PublisherApi.md#publishers_id_get) | **GET** /publishers/{id} | Get a single Publisher by its id
*PyramidApi* | [**pyramids_get**](docs/PyramidApi.md#pyramids_get) | **GET** /pyramids | List all instances of Pyramid
*PyramidApi* | [**pyramids_id_get**](docs/PyramidApi.md#pyramids_id_get) | **GET** /pyramids/{id} | Get a single Pyramid by its id
*RaceApi* | [**races_get**](docs/RaceApi.md#races_get) | **GET** /races | List all instances of Race
*RaceApi* | [**races_id_get**](docs/RaceApi.md#races_id_get) | **GET** /races/{id} | Get a single Race by its id
*RaceHorseApi* | [**racehorses_get**](docs/RaceHorseApi.md#racehorses_get) | **GET** /racehorses | List all instances of RaceHorse
*RaceHorseApi* | [**racehorses_id_get**](docs/RaceHorseApi.md#racehorses_id_get) | **GET** /racehorses/{id} | Get a single RaceHorse by its id
*RaceTrackApi* | [**racetracks_get**](docs/RaceTrackApi.md#racetracks_get) | **GET** /racetracks | List all instances of RaceTrack
*RaceTrackApi* | [**racetracks_id_get**](docs/RaceTrackApi.md#racetracks_id_get) | **GET** /racetracks/{id} | Get a single RaceTrack by its id
*RacecourseApi* | [**racecourses_get**](docs/RacecourseApi.md#racecourses_get) | **GET** /racecourses | List all instances of Racecourse
*RacecourseApi* | [**racecourses_id_get**](docs/RacecourseApi.md#racecourses_id_get) | **GET** /racecourses/{id} | Get a single Racecourse by its id
*RacingDriverApi* | [**racingdrivers_get**](docs/RacingDriverApi.md#racingdrivers_get) | **GET** /racingdrivers | List all instances of RacingDriver
*RacingDriverApi* | [**racingdrivers_id_get**](docs/RacingDriverApi.md#racingdrivers_id_get) | **GET** /racingdrivers/{id} | Get a single RacingDriver by its id
*RadioControlledRacingLeagueApi* | [**radiocontrolledracingleagues_get**](docs/RadioControlledRacingLeagueApi.md#radiocontrolledracingleagues_get) | **GET** /radiocontrolledracingleagues | List all instances of RadioControlledRacingLeague
*RadioControlledRacingLeagueApi* | [**radiocontrolledracingleagues_id_get**](docs/RadioControlledRacingLeagueApi.md#radiocontrolledracingleagues_id_get) | **GET** /radiocontrolledracingleagues/{id} | Get a single RadioControlledRacingLeague by its id
*RadioHostApi* | [**radiohosts_get**](docs/RadioHostApi.md#radiohosts_get) | **GET** /radiohosts | List all instances of RadioHost
*RadioHostApi* | [**radiohosts_id_get**](docs/RadioHostApi.md#radiohosts_id_get) | **GET** /radiohosts/{id} | Get a single RadioHost by its id
*RadioProgramApi* | [**radioprograms_get**](docs/RadioProgramApi.md#radioprograms_get) | **GET** /radioprograms | List all instances of RadioProgram
*RadioProgramApi* | [**radioprograms_id_get**](docs/RadioProgramApi.md#radioprograms_id_get) | **GET** /radioprograms/{id} | Get a single RadioProgram by its id
*RadioStationApi* | [**radiostations_get**](docs/RadioStationApi.md#radiostations_get) | **GET** /radiostations | List all instances of RadioStation
*RadioStationApi* | [**radiostations_id_get**](docs/RadioStationApi.md#radiostations_id_get) | **GET** /radiostations/{id} | Get a single RadioStation by its id
*RailwayLineApi* | [**railwaylines_get**](docs/RailwayLineApi.md#railwaylines_get) | **GET** /railwaylines | List all instances of RailwayLine
*RailwayLineApi* | [**railwaylines_id_get**](docs/RailwayLineApi.md#railwaylines_id_get) | **GET** /railwaylines/{id} | Get a single RailwayLine by its id
*RailwayStationApi* | [**railwaystations_get**](docs/RailwayStationApi.md#railwaystations_get) | **GET** /railwaystations | List all instances of RailwayStation
*RailwayStationApi* | [**railwaystations_id_get**](docs/RailwayStationApi.md#railwaystations_id_get) | **GET** /railwaystations/{id} | Get a single RailwayStation by its id
*RailwayTunnelApi* | [**railwaytunnels_get**](docs/RailwayTunnelApi.md#railwaytunnels_get) | **GET** /railwaytunnels | List all instances of RailwayTunnel
*RailwayTunnelApi* | [**railwaytunnels_id_get**](docs/RailwayTunnelApi.md#railwaytunnels_id_get) | **GET** /railwaytunnels/{id} | Get a single RailwayTunnel by its id
*RallyDriverApi* | [**rallydrivers_get**](docs/RallyDriverApi.md#rallydrivers_get) | **GET** /rallydrivers | List all instances of RallyDriver
*RallyDriverApi* | [**rallydrivers_id_get**](docs/RallyDriverApi.md#rallydrivers_id_get) | **GET** /rallydrivers/{id} | Get a single RallyDriver by its id
*RecordLabelApi* | [**recordlabels_get**](docs/RecordLabelApi.md#recordlabels_get) | **GET** /recordlabels | List all instances of RecordLabel
*RecordLabelApi* | [**recordlabels_id_get**](docs/RecordLabelApi.md#recordlabels_id_get) | **GET** /recordlabels/{id} | Get a single RecordLabel by its id
*RecordOfficeApi* | [**recordoffices_get**](docs/RecordOfficeApi.md#recordoffices_get) | **GET** /recordoffices | List all instances of RecordOffice
*RecordOfficeApi* | [**recordoffices_id_get**](docs/RecordOfficeApi.md#recordoffices_id_get) | **GET** /recordoffices/{id} | Get a single RecordOffice by its id
*RefereeApi* | [**referees_get**](docs/RefereeApi.md#referees_get) | **GET** /referees | List all instances of Referee
*RefereeApi* | [**referees_id_get**](docs/RefereeApi.md#referees_id_get) | **GET** /referees/{id} | Get a single Referee by its id
*ReferenceApi* | [**references_get**](docs/ReferenceApi.md#references_get) | **GET** /references | List all instances of Reference
*ReferenceApi* | [**references_id_get**](docs/ReferenceApi.md#references_id_get) | **GET** /references/{id} | Get a single Reference by its id
*RegencyApi* | [**regencys_get**](docs/RegencyApi.md#regencys_get) | **GET** /regencys | List all instances of Regency
*RegencyApi* | [**regencys_id_get**](docs/RegencyApi.md#regencys_id_get) | **GET** /regencys/{id} | Get a single Regency by its id
*RegionApi* | [**regions_get**](docs/RegionApi.md#regions_get) | **GET** /regions | List all instances of Region
*RegionApi* | [**regions_id_get**](docs/RegionApi.md#regions_id_get) | **GET** /regions/{id} | Get a single Region by its id
*ReligiousApi* | [**religiouss_get**](docs/ReligiousApi.md#religiouss_get) | **GET** /religiouss | List all instances of Religious
*ReligiousApi* | [**religiouss_id_get**](docs/ReligiousApi.md#religiouss_id_get) | **GET** /religiouss/{id} | Get a single Religious by its id
*ReligiousBuildingApi* | [**religiousbuildings_get**](docs/ReligiousBuildingApi.md#religiousbuildings_get) | **GET** /religiousbuildings | List all instances of ReligiousBuilding
*ReligiousBuildingApi* | [**religiousbuildings_id_get**](docs/ReligiousBuildingApi.md#religiousbuildings_id_get) | **GET** /religiousbuildings/{id} | Get a single ReligiousBuilding by its id
*ReptileApi* | [**reptiles_get**](docs/ReptileApi.md#reptiles_get) | **GET** /reptiles | List all instances of Reptile
*ReptileApi* | [**reptiles_id_get**](docs/ReptileApi.md#reptiles_id_get) | **GET** /reptiles/{id} | Get a single Reptile by its id
*ResearchProjectApi* | [**researchprojects_get**](docs/ResearchProjectApi.md#researchprojects_get) | **GET** /researchprojects | List all instances of ResearchProject
*ResearchProjectApi* | [**researchprojects_id_get**](docs/ResearchProjectApi.md#researchprojects_id_get) | **GET** /researchprojects/{id} | Get a single ResearchProject by its id
*RestaurantApi* | [**restaurants_get**](docs/RestaurantApi.md#restaurants_get) | **GET** /restaurants | List all instances of Restaurant
*RestaurantApi* | [**restaurants_id_get**](docs/RestaurantApi.md#restaurants_id_get) | **GET** /restaurants/{id} | Get a single Restaurant by its id
*ResumeApi* | [**resumes_get**](docs/ResumeApi.md#resumes_get) | **GET** /resumes | List all instances of Resume
*ResumeApi* | [**resumes_id_get**](docs/ResumeApi.md#resumes_id_get) | **GET** /resumes/{id} | Get a single Resume by its id
*RiverApi* | [**rivers_get**](docs/RiverApi.md#rivers_get) | **GET** /rivers | List all instances of River
*RiverApi* | [**rivers_id_get**](docs/RiverApi.md#rivers_id_get) | **GET** /rivers/{id} | Get a single River by its id
*RoadApi* | [**roads_get**](docs/RoadApi.md#roads_get) | **GET** /roads | List all instances of Road
*RoadApi* | [**roads_id_get**](docs/RoadApi.md#roads_id_get) | **GET** /roads/{id} | Get a single Road by its id
*RoadJunctionApi* | [**roadjunctions_get**](docs/RoadJunctionApi.md#roadjunctions_get) | **GET** /roadjunctions | List all instances of RoadJunction
*RoadJunctionApi* | [**roadjunctions_id_get**](docs/RoadJunctionApi.md#roadjunctions_id_get) | **GET** /roadjunctions/{id} | Get a single RoadJunction by its id
*RoadTunnelApi* | [**roadtunnels_get**](docs/RoadTunnelApi.md#roadtunnels_get) | **GET** /roadtunnels | List all instances of RoadTunnel
*RoadTunnelApi* | [**roadtunnels_id_get**](docs/RoadTunnelApi.md#roadtunnels_id_get) | **GET** /roadtunnels/{id} | Get a single RoadTunnel by its id
*RocketApi* | [**rockets_get**](docs/RocketApi.md#rockets_get) | **GET** /rockets | List all instances of Rocket
*RocketApi* | [**rockets_id_get**](docs/RocketApi.md#rockets_id_get) | **GET** /rockets/{id} | Get a single Rocket by its id
*RollerCoasterApi* | [**rollercoasters_get**](docs/RollerCoasterApi.md#rollercoasters_get) | **GET** /rollercoasters | List all instances of RollerCoaster
*RollerCoasterApi* | [**rollercoasters_id_get**](docs/RollerCoasterApi.md#rollercoasters_id_get) | **GET** /rollercoasters/{id} | Get a single RollerCoaster by its id
*RomanEmperorApi* | [**romanemperors_get**](docs/RomanEmperorApi.md#romanemperors_get) | **GET** /romanemperors | List all instances of RomanEmperor
*RomanEmperorApi* | [**romanemperors_id_get**](docs/RomanEmperorApi.md#romanemperors_id_get) | **GET** /romanemperors/{id} | Get a single RomanEmperor by its id
*RomaniaSettlementApi* | [**romaniasettlements_get**](docs/RomaniaSettlementApi.md#romaniasettlements_get) | **GET** /romaniasettlements | List all instances of RomaniaSettlement
*RomaniaSettlementApi* | [**romaniasettlements_id_get**](docs/RomaniaSettlementApi.md#romaniasettlements_id_get) | **GET** /romaniasettlements/{id} | Get a single RomaniaSettlement by its id
*RouteOfTransportationApi* | [**routeoftransportations_get**](docs/RouteOfTransportationApi.md#routeoftransportations_get) | **GET** /routeoftransportations | List all instances of RouteOfTransportation
*RouteOfTransportationApi* | [**routeoftransportations_id_get**](docs/RouteOfTransportationApi.md#routeoftransportations_id_get) | **GET** /routeoftransportations/{id} | Get a single RouteOfTransportation by its id
*RowerApi* | [**rowers_get**](docs/RowerApi.md#rowers_get) | **GET** /rowers | List all instances of Rower
*RowerApi* | [**rowers_id_get**](docs/RowerApi.md#rowers_id_get) | **GET** /rowers/{id} | Get a single Rower by its id
*RoyaltyApi* | [**royaltys_get**](docs/RoyaltyApi.md#royaltys_get) | **GET** /royaltys | List all instances of Royalty
*RoyaltyApi* | [**royaltys_id_get**](docs/RoyaltyApi.md#royaltys_id_get) | **GET** /royaltys/{id} | Get a single Royalty by its id
*RugbyClubApi* | [**rugbyclubs_get**](docs/RugbyClubApi.md#rugbyclubs_get) | **GET** /rugbyclubs | List all instances of RugbyClub
*RugbyClubApi* | [**rugbyclubs_id_get**](docs/RugbyClubApi.md#rugbyclubs_id_get) | **GET** /rugbyclubs/{id} | Get a single RugbyClub by its id
*RugbyLeagueApi* | [**rugbyleagues_get**](docs/RugbyLeagueApi.md#rugbyleagues_get) | **GET** /rugbyleagues | List all instances of RugbyLeague
*RugbyLeagueApi* | [**rugbyleagues_id_get**](docs/RugbyLeagueApi.md#rugbyleagues_id_get) | **GET** /rugbyleagues/{id} | Get a single RugbyLeague by its id
*RugbyPlayerApi* | [**rugbyplayers_get**](docs/RugbyPlayerApi.md#rugbyplayers_get) | **GET** /rugbyplayers | List all instances of RugbyPlayer
*RugbyPlayerApi* | [**rugbyplayers_id_get**](docs/RugbyPlayerApi.md#rugbyplayers_id_get) | **GET** /rugbyplayers/{id} | Get a single RugbyPlayer by its id
*SaintApi* | [**saints_get**](docs/SaintApi.md#saints_get) | **GET** /saints | List all instances of Saint
*SaintApi* | [**saints_id_get**](docs/SaintApi.md#saints_id_get) | **GET** /saints/{id} | Get a single Saint by its id
*SalesApi* | [**saless_get**](docs/SalesApi.md#saless_get) | **GET** /saless | List all instances of Sales
*SalesApi* | [**saless_id_get**](docs/SalesApi.md#saless_id_get) | **GET** /saless/{id} | Get a single Sales by its id
*SambaSchoolApi* | [**sambaschools_get**](docs/SambaSchoolApi.md#sambaschools_get) | **GET** /sambaschools | List all instances of SambaSchool
*SambaSchoolApi* | [**sambaschools_id_get**](docs/SambaSchoolApi.md#sambaschools_id_get) | **GET** /sambaschools/{id} | Get a single SambaSchool by its id
*SatelliteApi* | [**satellites_get**](docs/SatelliteApi.md#satellites_get) | **GET** /satellites | List all instances of Satellite
*SatelliteApi* | [**satellites_id_get**](docs/SatelliteApi.md#satellites_id_get) | **GET** /satellites/{id} | Get a single Satellite by its id
*SchoolApi* | [**schools_get**](docs/SchoolApi.md#schools_get) | **GET** /schools | List all instances of School
*SchoolApi* | [**schools_id_get**](docs/SchoolApi.md#schools_id_get) | **GET** /schools/{id} | Get a single School by its id
*ScientistApi* | [**scientists_get**](docs/ScientistApi.md#scientists_get) | **GET** /scientists | List all instances of Scientist
*ScientistApi* | [**scientists_id_get**](docs/ScientistApi.md#scientists_id_get) | **GET** /scientists/{id} | Get a single Scientist by its id
*ScreenWriterApi* | [**screenwriters_get**](docs/ScreenWriterApi.md#screenwriters_get) | **GET** /screenwriters | List all instances of ScreenWriter
*ScreenWriterApi* | [**screenwriters_id_get**](docs/ScreenWriterApi.md#screenwriters_id_get) | **GET** /screenwriters/{id} | Get a single ScreenWriter by its id
*SculptorApi* | [**sculptors_get**](docs/SculptorApi.md#sculptors_get) | **GET** /sculptors | List all instances of Sculptor
*SculptorApi* | [**sculptors_id_get**](docs/SculptorApi.md#sculptors_id_get) | **GET** /sculptors/{id} | Get a single Sculptor by its id
*SculptureApi* | [**sculptures_get**](docs/SculptureApi.md#sculptures_get) | **GET** /sculptures | List all instances of Sculpture
*SculptureApi* | [**sculptures_id_get**](docs/SculptureApi.md#sculptures_id_get) | **GET** /sculptures/{id} | Get a single Sculpture by its id
*SeaApi* | [**seas_get**](docs/SeaApi.md#seas_get) | **GET** /seas | List all instances of Sea
*SeaApi* | [**seas_id_get**](docs/SeaApi.md#seas_id_get) | **GET** /seas/{id} | Get a single Sea by its id
*SenatorApi* | [**senators_get**](docs/SenatorApi.md#senators_get) | **GET** /senators | List all instances of Senator
*SenatorApi* | [**senators_id_get**](docs/SenatorApi.md#senators_id_get) | **GET** /senators/{id} | Get a single Senator by its id
*SerialKillerApi* | [**serialkillers_get**](docs/SerialKillerApi.md#serialkillers_get) | **GET** /serialkillers | List all instances of SerialKiller
*SerialKillerApi* | [**serialkillers_id_get**](docs/SerialKillerApi.md#serialkillers_id_get) | **GET** /serialkillers/{id} | Get a single SerialKiller by its id
*SettlementApi* | [**settlements_get**](docs/SettlementApi.md#settlements_get) | **GET** /settlements | List all instances of Settlement
*SettlementApi* | [**settlements_id_get**](docs/SettlementApi.md#settlements_id_get) | **GET** /settlements/{id} | Get a single Settlement by its id
*ShipApi* | [**ships_get**](docs/ShipApi.md#ships_get) | **GET** /ships | List all instances of Ship
*ShipApi* | [**ships_id_get**](docs/ShipApi.md#ships_id_get) | **GET** /ships/{id} | Get a single Ship by its id
*ShoppingMallApi* | [**shoppingmalls_get**](docs/ShoppingMallApi.md#shoppingmalls_get) | **GET** /shoppingmalls | List all instances of ShoppingMall
*ShoppingMallApi* | [**shoppingmalls_id_get**](docs/ShoppingMallApi.md#shoppingmalls_id_get) | **GET** /shoppingmalls/{id} | Get a single ShoppingMall by its id
*ShrineApi* | [**shrines_get**](docs/ShrineApi.md#shrines_get) | **GET** /shrines | List all instances of Shrine
*ShrineApi* | [**shrines_id_get**](docs/ShrineApi.md#shrines_id_get) | **GET** /shrines/{id} | Get a single Shrine by its id
*SingerApi* | [**singers_get**](docs/SingerApi.md#singers_get) | **GET** /singers | List all instances of Singer
*SingerApi* | [**singers_id_get**](docs/SingerApi.md#singers_id_get) | **GET** /singers/{id} | Get a single Singer by its id
*SingleApi* | [**singles_get**](docs/SingleApi.md#singles_get) | **GET** /singles | List all instances of Single
*SingleApi* | [**singles_id_get**](docs/SingleApi.md#singles_id_get) | **GET** /singles/{id} | Get a single Single by its id
*SiteOfSpecialScientificInterestApi* | [**siteofspecialscientificinterests_get**](docs/SiteOfSpecialScientificInterestApi.md#siteofspecialscientificinterests_get) | **GET** /siteofspecialscientificinterests | List all instances of SiteOfSpecialScientificInterest
*SiteOfSpecialScientificInterestApi* | [**siteofspecialscientificinterests_id_get**](docs/SiteOfSpecialScientificInterestApi.md#siteofspecialscientificinterests_id_get) | **GET** /siteofspecialscientificinterests/{id} | Get a single SiteOfSpecialScientificInterest by its id
*SkaterApi* | [**skaters_get**](docs/SkaterApi.md#skaters_get) | **GET** /skaters | List all instances of Skater
*SkaterApi* | [**skaters_id_get**](docs/SkaterApi.md#skaters_id_get) | **GET** /skaters/{id} | Get a single Skater by its id
*SkiAreaApi* | [**skiareas_get**](docs/SkiAreaApi.md#skiareas_get) | **GET** /skiareas | List all instances of SkiArea
*SkiAreaApi* | [**skiareas_id_get**](docs/SkiAreaApi.md#skiareas_id_get) | **GET** /skiareas/{id} | Get a single SkiArea by its id
*SkiResortApi* | [**skiresorts_get**](docs/SkiResortApi.md#skiresorts_get) | **GET** /skiresorts | List all instances of SkiResort
*SkiResortApi* | [**skiresorts_id_get**](docs/SkiResortApi.md#skiresorts_id_get) | **GET** /skiresorts/{id} | Get a single SkiResort by its id
*SkierApi* | [**skiers_get**](docs/SkierApi.md#skiers_get) | **GET** /skiers | List all instances of Skier
*SkierApi* | [**skiers_id_get**](docs/SkierApi.md#skiers_id_get) | **GET** /skiers/{id} | Get a single Skier by its id
*SkyscraperApi* | [**skyscrapers_get**](docs/SkyscraperApi.md#skyscrapers_get) | **GET** /skyscrapers | List all instances of Skyscraper
*SkyscraperApi* | [**skyscrapers_id_get**](docs/SkyscraperApi.md#skyscrapers_id_get) | **GET** /skyscrapers/{id} | Get a single Skyscraper by its id
*SnookerChampApi* | [**snookerchamps_get**](docs/SnookerChampApi.md#snookerchamps_get) | **GET** /snookerchamps | List all instances of SnookerChamp
*SnookerChampApi* | [**snookerchamps_id_get**](docs/SnookerChampApi.md#snookerchamps_id_get) | **GET** /snookerchamps/{id} | Get a single SnookerChamp by its id
*SnookerPlayerApi* | [**snookerplayers_get**](docs/SnookerPlayerApi.md#snookerplayers_get) | **GET** /snookerplayers | List all instances of SnookerPlayer
*SnookerPlayerApi* | [**snookerplayers_id_get**](docs/SnookerPlayerApi.md#snookerplayers_id_get) | **GET** /snookerplayers/{id} | Get a single SnookerPlayer by its id
*SnookerWorldRankingApi* | [**snookerworldrankings_get**](docs/SnookerWorldRankingApi.md#snookerworldrankings_get) | **GET** /snookerworldrankings | List all instances of SnookerWorldRanking
*SnookerWorldRankingApi* | [**snookerworldrankings_id_get**](docs/SnookerWorldRankingApi.md#snookerworldrankings_id_get) | **GET** /snookerworldrankings/{id} | Get a single SnookerWorldRanking by its id
*SoapCharacterApi* | [**soapcharacters_get**](docs/SoapCharacterApi.md#soapcharacters_get) | **GET** /soapcharacters | List all instances of SoapCharacter
*SoapCharacterApi* | [**soapcharacters_id_get**](docs/SoapCharacterApi.md#soapcharacters_id_get) | **GET** /soapcharacters/{id} | Get a single SoapCharacter by its id
*SoccerClubApi* | [**soccerclubs_get**](docs/SoccerClubApi.md#soccerclubs_get) | **GET** /soccerclubs | List all instances of SoccerClub
*SoccerClubApi* | [**soccerclubs_id_get**](docs/SoccerClubApi.md#soccerclubs_id_get) | **GET** /soccerclubs/{id} | Get a single SoccerClub by its id
*SoccerClubSeasonApi* | [**soccerclubseasons_get**](docs/SoccerClubSeasonApi.md#soccerclubseasons_get) | **GET** /soccerclubseasons | List all instances of SoccerClubSeason
*SoccerClubSeasonApi* | [**soccerclubseasons_id_get**](docs/SoccerClubSeasonApi.md#soccerclubseasons_id_get) | **GET** /soccerclubseasons/{id} | Get a single SoccerClubSeason by its id
*SoccerLeagueApi* | [**soccerleagues_get**](docs/SoccerLeagueApi.md#soccerleagues_get) | **GET** /soccerleagues | List all instances of SoccerLeague
*SoccerLeagueApi* | [**soccerleagues_id_get**](docs/SoccerLeagueApi.md#soccerleagues_id_get) | **GET** /soccerleagues/{id} | Get a single SoccerLeague by its id
*SoccerLeagueSeasonApi* | [**soccerleagueseasons_get**](docs/SoccerLeagueSeasonApi.md#soccerleagueseasons_get) | **GET** /soccerleagueseasons | List all instances of SoccerLeagueSeason
*SoccerLeagueSeasonApi* | [**soccerleagueseasons_id_get**](docs/SoccerLeagueSeasonApi.md#soccerleagueseasons_id_get) | **GET** /soccerleagueseasons/{id} | Get a single SoccerLeagueSeason by its id
*SoccerManagerApi* | [**soccermanagers_get**](docs/SoccerManagerApi.md#soccermanagers_get) | **GET** /soccermanagers | List all instances of SoccerManager
*SoccerManagerApi* | [**soccermanagers_id_get**](docs/SoccerManagerApi.md#soccermanagers_id_get) | **GET** /soccermanagers/{id} | Get a single SoccerManager by its id
*SoccerPlayerApi* | [**soccerplayers_get**](docs/SoccerPlayerApi.md#soccerplayers_get) | **GET** /soccerplayers | List all instances of SoccerPlayer
*SoccerPlayerApi* | [**soccerplayers_id_get**](docs/SoccerPlayerApi.md#soccerplayers_id_get) | **GET** /soccerplayers/{id} | Get a single SoccerPlayer by its id
*SoccerTournamentApi* | [**soccertournaments_get**](docs/SoccerTournamentApi.md#soccertournaments_get) | **GET** /soccertournaments | List all instances of SoccerTournament
*SoccerTournamentApi* | [**soccertournaments_id_get**](docs/SoccerTournamentApi.md#soccertournaments_id_get) | **GET** /soccertournaments/{id} | Get a single SoccerTournament by its id
*SocietalEventApi* | [**societalevents_get**](docs/SocietalEventApi.md#societalevents_get) | **GET** /societalevents | List all instances of SocietalEvent
*SocietalEventApi* | [**societalevents_id_get**](docs/SocietalEventApi.md#societalevents_id_get) | **GET** /societalevents/{id} | Get a single SocietalEvent by its id
*SoftballLeagueApi* | [**softballleagues_get**](docs/SoftballLeagueApi.md#softballleagues_get) | **GET** /softballleagues | List all instances of SoftballLeague
*SoftballLeagueApi* | [**softballleagues_id_get**](docs/SoftballLeagueApi.md#softballleagues_id_get) | **GET** /softballleagues/{id} | Get a single SoftballLeague by its id
*SoftwareApi* | [**softwares_get**](docs/SoftwareApi.md#softwares_get) | **GET** /softwares | List all instances of Software
*SoftwareApi* | [**softwares_id_get**](docs/SoftwareApi.md#softwares_id_get) | **GET** /softwares/{id} | Get a single Software by its id
*SolarEclipseApi* | [**solareclipses_get**](docs/SolarEclipseApi.md#solareclipses_get) | **GET** /solareclipses | List all instances of SolarEclipse
*SolarEclipseApi* | [**solareclipses_id_get**](docs/SolarEclipseApi.md#solareclipses_id_get) | **GET** /solareclipses/{id} | Get a single SolarEclipse by its id
*SongApi* | [**songs_get**](docs/SongApi.md#songs_get) | **GET** /songs | List all instances of Song
*SongApi* | [**songs_id_get**](docs/SongApi.md#songs_id_get) | **GET** /songs/{id} | Get a single Song by its id
*SongWriterApi* | [**songwriters_get**](docs/SongWriterApi.md#songwriters_get) | **GET** /songwriters | List all instances of SongWriter
*SongWriterApi* | [**songwriters_id_get**](docs/SongWriterApi.md#songwriters_id_get) | **GET** /songwriters/{id} | Get a single SongWriter by its id
*SoundApi* | [**sounds_get**](docs/SoundApi.md#sounds_get) | **GET** /sounds | List all instances of Sound
*SoundApi* | [**sounds_id_get**](docs/SoundApi.md#sounds_id_get) | **GET** /sounds/{id} | Get a single Sound by its id
*SpaceMissionApi* | [**spacemissions_get**](docs/SpaceMissionApi.md#spacemissions_get) | **GET** /spacemissions | List all instances of SpaceMission
*SpaceMissionApi* | [**spacemissions_id_get**](docs/SpaceMissionApi.md#spacemissions_id_get) | **GET** /spacemissions/{id} | Get a single SpaceMission by its id
*SpaceShuttleApi* | [**spaceshuttles_get**](docs/SpaceShuttleApi.md#spaceshuttles_get) | **GET** /spaceshuttles | List all instances of SpaceShuttle
*SpaceShuttleApi* | [**spaceshuttles_id_get**](docs/SpaceShuttleApi.md#spaceshuttles_id_get) | **GET** /spaceshuttles/{id} | Get a single SpaceShuttle by its id
*SpaceStationApi* | [**spacestations_get**](docs/SpaceStationApi.md#spacestations_get) | **GET** /spacestations | List all instances of SpaceStation
*SpaceStationApi* | [**spacestations_id_get**](docs/SpaceStationApi.md#spacestations_id_get) | **GET** /spacestations/{id} | Get a single SpaceStation by its id
*SpacecraftApi* | [**spacecrafts_get**](docs/SpacecraftApi.md#spacecrafts_get) | **GET** /spacecrafts | List all instances of Spacecraft
*SpacecraftApi* | [**spacecrafts_id_get**](docs/SpacecraftApi.md#spacecrafts_id_get) | **GET** /spacecrafts/{id} | Get a single Spacecraft by its id
*SpeciesApi* | [**speciess_get**](docs/SpeciesApi.md#speciess_get) | **GET** /speciess | List all instances of Species
*SpeciesApi* | [**speciess_id_get**](docs/SpeciesApi.md#speciess_id_get) | **GET** /speciess/{id} | Get a single Species by its id
*SpeedwayLeagueApi* | [**speedwayleagues_get**](docs/SpeedwayLeagueApi.md#speedwayleagues_get) | **GET** /speedwayleagues | List all instances of SpeedwayLeague
*SpeedwayLeagueApi* | [**speedwayleagues_id_get**](docs/SpeedwayLeagueApi.md#speedwayleagues_id_get) | **GET** /speedwayleagues/{id} | Get a single SpeedwayLeague by its id
*SpeedwayRiderApi* | [**speedwayriders_get**](docs/SpeedwayRiderApi.md#speedwayriders_get) | **GET** /speedwayriders | List all instances of SpeedwayRider
*SpeedwayRiderApi* | [**speedwayriders_id_get**](docs/SpeedwayRiderApi.md#speedwayriders_id_get) | **GET** /speedwayriders/{id} | Get a single SpeedwayRider by its id
*SpeedwayTeamApi* | [**speedwayteams_get**](docs/SpeedwayTeamApi.md#speedwayteams_get) | **GET** /speedwayteams | List all instances of SpeedwayTeam
*SpeedwayTeamApi* | [**speedwayteams_id_get**](docs/SpeedwayTeamApi.md#speedwayteams_id_get) | **GET** /speedwayteams/{id} | Get a single SpeedwayTeam by its id
*SportApi* | [**sports_get**](docs/SportApi.md#sports_get) | **GET** /sports | List all instances of Sport
*SportApi* | [**sports_id_get**](docs/SportApi.md#sports_id_get) | **GET** /sports/{id} | Get a single Sport by its id
*SportCompetitionResultApi* | [**sportcompetitionresults_get**](docs/SportCompetitionResultApi.md#sportcompetitionresults_get) | **GET** /sportcompetitionresults | List all instances of SportCompetitionResult
*SportCompetitionResultApi* | [**sportcompetitionresults_id_get**](docs/SportCompetitionResultApi.md#sportcompetitionresults_id_get) | **GET** /sportcompetitionresults/{id} | Get a single SportCompetitionResult by its id
*SportFacilityApi* | [**sportfacilitys_get**](docs/SportFacilityApi.md#sportfacilitys_get) | **GET** /sportfacilitys | List all instances of SportFacility
*SportFacilityApi* | [**sportfacilitys_id_get**](docs/SportFacilityApi.md#sportfacilitys_id_get) | **GET** /sportfacilitys/{id} | Get a single SportFacility by its id
*SportsEventApi* | [**sportsevents_get**](docs/SportsEventApi.md#sportsevents_get) | **GET** /sportsevents | List all instances of SportsEvent
*SportsEventApi* | [**sportsevents_id_get**](docs/SportsEventApi.md#sportsevents_id_get) | **GET** /sportsevents/{id} | Get a single SportsEvent by its id
*SportsLeagueApi* | [**sportsleagues_get**](docs/SportsLeagueApi.md#sportsleagues_get) | **GET** /sportsleagues | List all instances of SportsLeague
*SportsLeagueApi* | [**sportsleagues_id_get**](docs/SportsLeagueApi.md#sportsleagues_id_get) | **GET** /sportsleagues/{id} | Get a single SportsLeague by its id
*SportsManagerApi* | [**sportsmanagers_get**](docs/SportsManagerApi.md#sportsmanagers_get) | **GET** /sportsmanagers | List all instances of SportsManager
*SportsManagerApi* | [**sportsmanagers_id_get**](docs/SportsManagerApi.md#sportsmanagers_id_get) | **GET** /sportsmanagers/{id} | Get a single SportsManager by its id
*SportsSeasonApi* | [**sportsseasons_get**](docs/SportsSeasonApi.md#sportsseasons_get) | **GET** /sportsseasons | List all instances of SportsSeason
*SportsSeasonApi* | [**sportsseasons_id_get**](docs/SportsSeasonApi.md#sportsseasons_id_get) | **GET** /sportsseasons/{id} | Get a single SportsSeason by its id
*SportsTeamApi* | [**sportsteams_get**](docs/SportsTeamApi.md#sportsteams_get) | **GET** /sportsteams | List all instances of SportsTeam
*SportsTeamApi* | [**sportsteams_id_get**](docs/SportsTeamApi.md#sportsteams_id_get) | **GET** /sportsteams/{id} | Get a single SportsTeam by its id
*SportsTeamMemberApi* | [**sportsteammembers_get**](docs/SportsTeamMemberApi.md#sportsteammembers_get) | **GET** /sportsteammembers | List all instances of SportsTeamMember
*SportsTeamMemberApi* | [**sportsteammembers_id_get**](docs/SportsTeamMemberApi.md#sportsteammembers_id_get) | **GET** /sportsteammembers/{id} | Get a single SportsTeamMember by its id
*SportsTeamSeasonApi* | [**sportsteamseasons_get**](docs/SportsTeamSeasonApi.md#sportsteamseasons_get) | **GET** /sportsteamseasons | List all instances of SportsTeamSeason
*SportsTeamSeasonApi* | [**sportsteamseasons_id_get**](docs/SportsTeamSeasonApi.md#sportsteamseasons_id_get) | **GET** /sportsteamseasons/{id} | Get a single SportsTeamSeason by its id
*SquareApi* | [**squares_get**](docs/SquareApi.md#squares_get) | **GET** /squares | List all instances of Square
*SquareApi* | [**squares_id_get**](docs/SquareApi.md#squares_id_get) | **GET** /squares/{id} | Get a single Square by its id
*SquashPlayerApi* | [**squashplayers_get**](docs/SquashPlayerApi.md#squashplayers_get) | **GET** /squashplayers | List all instances of SquashPlayer
*SquashPlayerApi* | [**squashplayers_id_get**](docs/SquashPlayerApi.md#squashplayers_id_get) | **GET** /squashplayers/{id} | Get a single SquashPlayer by its id
*StadiumApi* | [**stadiums_get**](docs/StadiumApi.md#stadiums_get) | **GET** /stadiums | List all instances of Stadium
*StadiumApi* | [**stadiums_id_get**](docs/StadiumApi.md#stadiums_id_get) | **GET** /stadiums/{id} | Get a single Stadium by its id
*StarApi* | [**stars_get**](docs/StarApi.md#stars_get) | **GET** /stars | List all instances of Star
*StarApi* | [**stars_id_get**](docs/StarApi.md#stars_id_get) | **GET** /stars/{id} | Get a single Star by its id
*StateApi* | [**states_get**](docs/StateApi.md#states_get) | **GET** /states | List all instances of State
*StateApi* | [**states_id_get**](docs/StateApi.md#states_id_get) | **GET** /states/{id} | Get a single State by its id
*StatedResolutionApi* | [**statedresolutions_get**](docs/StatedResolutionApi.md#statedresolutions_get) | **GET** /statedresolutions | List all instances of StatedResolution
*StatedResolutionApi* | [**statedresolutions_id_get**](docs/StatedResolutionApi.md#statedresolutions_id_get) | **GET** /statedresolutions/{id} | Get a single StatedResolution by its id
*StationApi* | [**stations_get**](docs/StationApi.md#stations_get) | **GET** /stations | List all instances of Station
*StationApi* | [**stations_id_get**](docs/StationApi.md#stations_id_get) | **GET** /stations/{id} | Get a single Station by its id
*StatisticApi* | [**statistics_get**](docs/StatisticApi.md#statistics_get) | **GET** /statistics | List all instances of Statistic
*StatisticApi* | [**statistics_id_get**](docs/StatisticApi.md#statistics_id_get) | **GET** /statistics/{id} | Get a single Statistic by its id
*StillImageApi* | [**stillimages_get**](docs/StillImageApi.md#stillimages_get) | **GET** /stillimages | List all instances of StillImage
*StillImageApi* | [**stillimages_id_get**](docs/StillImageApi.md#stillimages_id_get) | **GET** /stillimages/{id} | Get a single StillImage by its id
*StreamApi* | [**streams_get**](docs/StreamApi.md#streams_get) | **GET** /streams | List all instances of Stream
*StreamApi* | [**streams_id_get**](docs/StreamApi.md#streams_id_get) | **GET** /streams/{id} | Get a single Stream by its id
*StreetApi* | [**streets_get**](docs/StreetApi.md#streets_get) | **GET** /streets | List all instances of Street
*StreetApi* | [**streets_id_get**](docs/StreetApi.md#streets_id_get) | **GET** /streets/{id} | Get a single Street by its id
*SubMunicipalityApi* | [**submunicipalitys_get**](docs/SubMunicipalityApi.md#submunicipalitys_get) | **GET** /submunicipalitys | List all instances of SubMunicipality
*SubMunicipalityApi* | [**submunicipalitys_id_get**](docs/SubMunicipalityApi.md#submunicipalitys_id_get) | **GET** /submunicipalitys/{id} | Get a single SubMunicipality by its id
*SumoWrestlerApi* | [**sumowrestlers_get**](docs/SumoWrestlerApi.md#sumowrestlers_get) | **GET** /sumowrestlers | List all instances of SumoWrestler
*SumoWrestlerApi* | [**sumowrestlers_id_get**](docs/SumoWrestlerApi.md#sumowrestlers_id_get) | **GET** /sumowrestlers/{id} | Get a single SumoWrestler by its id
*SupremeCourtOfTheUnitedStatesCaseApi* | [**supremecourtoftheunitedstatescases_get**](docs/SupremeCourtOfTheUnitedStatesCaseApi.md#supremecourtoftheunitedstatescases_get) | **GET** /supremecourtoftheunitedstatescases | List all instances of SupremeCourtOfTheUnitedStatesCase
*SupremeCourtOfTheUnitedStatesCaseApi* | [**supremecourtoftheunitedstatescases_id_get**](docs/SupremeCourtOfTheUnitedStatesCaseApi.md#supremecourtoftheunitedstatescases_id_get) | **GET** /supremecourtoftheunitedstatescases/{id} | Get a single SupremeCourtOfTheUnitedStatesCase by its id
*SurferApi* | [**surfers_get**](docs/SurferApi.md#surfers_get) | **GET** /surfers | List all instances of Surfer
*SurferApi* | [**surfers_id_get**](docs/SurferApi.md#surfers_id_get) | **GET** /surfers/{id} | Get a single Surfer by its id
*SurnameApi* | [**surnames_get**](docs/SurnameApi.md#surnames_get) | **GET** /surnames | List all instances of Surname
*SurnameApi* | [**surnames_id_get**](docs/SurnameApi.md#surnames_id_get) | **GET** /surnames/{id} | Get a single Surname by its id
*SwarmApi* | [**swarms_get**](docs/SwarmApi.md#swarms_get) | **GET** /swarms | List all instances of Swarm
*SwarmApi* | [**swarms_id_get**](docs/SwarmApi.md#swarms_id_get) | **GET** /swarms/{id} | Get a single Swarm by its id
*SwimmerApi* | [**swimmers_get**](docs/SwimmerApi.md#swimmers_get) | **GET** /swimmers | List all instances of Swimmer
*SwimmerApi* | [**swimmers_id_get**](docs/SwimmerApi.md#swimmers_id_get) | **GET** /swimmers/{id} | Get a single Swimmer by its id
*SwitzerlandSettlementApi* | [**switzerlandsettlements_get**](docs/SwitzerlandSettlementApi.md#switzerlandsettlements_get) | **GET** /switzerlandsettlements | List all instances of SwitzerlandSettlement
*SwitzerlandSettlementApi* | [**switzerlandsettlements_id_get**](docs/SwitzerlandSettlementApi.md#switzerlandsettlements_id_get) | **GET** /switzerlandsettlements/{id} | Get a single SwitzerlandSettlement by its id
*SynagogueApi* | [**synagogues_get**](docs/SynagogueApi.md#synagogues_get) | **GET** /synagogues | List all instances of Synagogue
*SynagogueApi* | [**synagogues_id_get**](docs/SynagogueApi.md#synagogues_id_get) | **GET** /synagogues/{id} | Get a single Synagogue by its id
*SystemOfLawApi* | [**systemoflaws_get**](docs/SystemOfLawApi.md#systemoflaws_get) | **GET** /systemoflaws | List all instances of SystemOfLaw
*SystemOfLawApi* | [**systemoflaws_id_get**](docs/SystemOfLawApi.md#systemoflaws_id_get) | **GET** /systemoflaws/{id} | Get a single SystemOfLaw by its id
*TableTennisPlayerApi* | [**tabletennisplayers_get**](docs/TableTennisPlayerApi.md#tabletennisplayers_get) | **GET** /tabletennisplayers | List all instances of TableTennisPlayer
*TableTennisPlayerApi* | [**tabletennisplayers_id_get**](docs/TableTennisPlayerApi.md#tabletennisplayers_id_get) | **GET** /tabletennisplayers/{id} | Get a single TableTennisPlayer by its id
*TaxApi* | [**taxs_get**](docs/TaxApi.md#taxs_get) | **GET** /taxs | List all instances of Tax
*TaxApi* | [**taxs_id_get**](docs/TaxApi.md#taxs_id_get) | **GET** /taxs/{id} | Get a single Tax by its id
*TaxonApi* | [**taxons_get**](docs/TaxonApi.md#taxons_get) | **GET** /taxons | List all instances of Taxon
*TaxonApi* | [**taxons_id_get**](docs/TaxonApi.md#taxons_id_get) | **GET** /taxons/{id} | Get a single Taxon by its id
*TeamMemberApi* | [**teammembers_get**](docs/TeamMemberApi.md#teammembers_get) | **GET** /teammembers | List all instances of TeamMember
*TeamMemberApi* | [**teammembers_id_get**](docs/TeamMemberApi.md#teammembers_id_get) | **GET** /teammembers/{id} | Get a single TeamMember by its id
*TelevisionDirectorApi* | [**televisiondirectors_get**](docs/TelevisionDirectorApi.md#televisiondirectors_get) | **GET** /televisiondirectors | List all instances of TelevisionDirector
*TelevisionDirectorApi* | [**televisiondirectors_id_get**](docs/TelevisionDirectorApi.md#televisiondirectors_id_get) | **GET** /televisiondirectors/{id} | Get a single TelevisionDirector by its id
*TelevisionEpisodeApi* | [**televisionepisodes_get**](docs/TelevisionEpisodeApi.md#televisionepisodes_get) | **GET** /televisionepisodes | List all instances of TelevisionEpisode
*TelevisionEpisodeApi* | [**televisionepisodes_id_get**](docs/TelevisionEpisodeApi.md#televisionepisodes_id_get) | **GET** /televisionepisodes/{id} | Get a single TelevisionEpisode by its id
*TelevisionHostApi* | [**televisionhosts_get**](docs/TelevisionHostApi.md#televisionhosts_get) | **GET** /televisionhosts | List all instances of TelevisionHost
*TelevisionHostApi* | [**televisionhosts_id_get**](docs/TelevisionHostApi.md#televisionhosts_id_get) | **GET** /televisionhosts/{id} | Get a single TelevisionHost by its id
*TelevisionPersonalityApi* | [**televisionpersonalitys_get**](docs/TelevisionPersonalityApi.md#televisionpersonalitys_get) | **GET** /televisionpersonalitys | List all instances of TelevisionPersonality
*TelevisionPersonalityApi* | [**televisionpersonalitys_id_get**](docs/TelevisionPersonalityApi.md#televisionpersonalitys_id_get) | **GET** /televisionpersonalitys/{id} | Get a single TelevisionPersonality by its id
*TelevisionSeasonApi* | [**televisionseasons_get**](docs/TelevisionSeasonApi.md#televisionseasons_get) | **GET** /televisionseasons | List all instances of TelevisionSeason
*TelevisionSeasonApi* | [**televisionseasons_id_get**](docs/TelevisionSeasonApi.md#televisionseasons_id_get) | **GET** /televisionseasons/{id} | Get a single TelevisionSeason by its id
*TelevisionShowApi* | [**televisionshows_get**](docs/TelevisionShowApi.md#televisionshows_get) | **GET** /televisionshows | List all instances of TelevisionShow
*TelevisionShowApi* | [**televisionshows_id_get**](docs/TelevisionShowApi.md#televisionshows_id_get) | **GET** /televisionshows/{id} | Get a single TelevisionShow by its id
*TelevisionStationApi* | [**televisionstations_get**](docs/TelevisionStationApi.md#televisionstations_get) | **GET** /televisionstations | List all instances of TelevisionStation
*TelevisionStationApi* | [**televisionstations_id_get**](docs/TelevisionStationApi.md#televisionstations_id_get) | **GET** /televisionstations/{id} | Get a single TelevisionStation by its id
*TempleApi* | [**temples_get**](docs/TempleApi.md#temples_get) | **GET** /temples | List all instances of Temple
*TempleApi* | [**temples_id_get**](docs/TempleApi.md#temples_id_get) | **GET** /temples/{id} | Get a single Temple by its id
*TennisLeagueApi* | [**tennisleagues_get**](docs/TennisLeagueApi.md#tennisleagues_get) | **GET** /tennisleagues | List all instances of TennisLeague
*TennisLeagueApi* | [**tennisleagues_id_get**](docs/TennisLeagueApi.md#tennisleagues_id_get) | **GET** /tennisleagues/{id} | Get a single TennisLeague by its id
*TennisPlayerApi* | [**tennisplayers_get**](docs/TennisPlayerApi.md#tennisplayers_get) | **GET** /tennisplayers | List all instances of TennisPlayer
*TennisPlayerApi* | [**tennisplayers_id_get**](docs/TennisPlayerApi.md#tennisplayers_id_get) | **GET** /tennisplayers/{id} | Get a single TennisPlayer by its id
*TennisTournamentApi* | [**tennistournaments_get**](docs/TennisTournamentApi.md#tennistournaments_get) | **GET** /tennistournaments | List all instances of TennisTournament
*TennisTournamentApi* | [**tennistournaments_id_get**](docs/TennisTournamentApi.md#tennistournaments_id_get) | **GET** /tennistournaments/{id} | Get a single TennisTournament by its id
*TermOfOfficeApi* | [**termofoffices_get**](docs/TermOfOfficeApi.md#termofoffices_get) | **GET** /termofoffices | List all instances of TermOfOffice
*TermOfOfficeApi* | [**termofoffices_id_get**](docs/TermOfOfficeApi.md#termofoffices_id_get) | **GET** /termofoffices/{id} | Get a single TermOfOffice by its id
*TerritoryApi* | [**territorys_get**](docs/TerritoryApi.md#territorys_get) | **GET** /territorys | List all instances of Territory
*TerritoryApi* | [**territorys_id_get**](docs/TerritoryApi.md#territorys_id_get) | **GET** /territorys/{id} | Get a single Territory by its id
*TheatreApi* | [**theatres_get**](docs/TheatreApi.md#theatres_get) | **GET** /theatres | List all instances of Theatre
*TheatreApi* | [**theatres_id_get**](docs/TheatreApi.md#theatres_id_get) | **GET** /theatres/{id} | Get a single Theatre by its id
*TheatreDirectorApi* | [**theatredirectors_get**](docs/TheatreDirectorApi.md#theatredirectors_get) | **GET** /theatredirectors | List all instances of TheatreDirector
*TheatreDirectorApi* | [**theatredirectors_id_get**](docs/TheatreDirectorApi.md#theatredirectors_id_get) | **GET** /theatredirectors/{id} | Get a single TheatreDirector by its id
*ThingApi* | [**things_get**](docs/ThingApi.md#things_get) | **GET** /things | List all instances of Thing
*ThingApi* | [**things_id_get**](docs/ThingApi.md#things_id_get) | **GET** /things/{id} | Get a single Thing by its id
*TimePeriodApi* | [**timeperiods_get**](docs/TimePeriodApi.md#timeperiods_get) | **GET** /timeperiods | List all instances of TimePeriod
*TimePeriodApi* | [**timeperiods_id_get**](docs/TimePeriodApi.md#timeperiods_id_get) | **GET** /timeperiods/{id} | Get a single TimePeriod by its id
*TopicalConceptApi* | [**topicalconcepts_get**](docs/TopicalConceptApi.md#topicalconcepts_get) | **GET** /topicalconcepts | List all instances of TopicalConcept
*TopicalConceptApi* | [**topicalconcepts_id_get**](docs/TopicalConceptApi.md#topicalconcepts_id_get) | **GET** /topicalconcepts/{id} | Get a single TopicalConcept by its id
*TournamentApi* | [**tournaments_get**](docs/TournamentApi.md#tournaments_get) | **GET** /tournaments | List all instances of Tournament
*TournamentApi* | [**tournaments_id_get**](docs/TournamentApi.md#tournaments_id_get) | **GET** /tournaments/{id} | Get a single Tournament by its id
*TowerApi* | [**towers_get**](docs/TowerApi.md#towers_get) | **GET** /towers | List all instances of Tower
*TowerApi* | [**towers_id_get**](docs/TowerApi.md#towers_id_get) | **GET** /towers/{id} | Get a single Tower by its id
*TownApi* | [**towns_get**](docs/TownApi.md#towns_get) | **GET** /towns | List all instances of Town
*TownApi* | [**towns_id_get**](docs/TownApi.md#towns_id_get) | **GET** /towns/{id} | Get a single Town by its id
*TrackListApi* | [**tracklists_get**](docs/TrackListApi.md#tracklists_get) | **GET** /tracklists | List all instances of TrackList
*TrackListApi* | [**tracklists_id_get**](docs/TrackListApi.md#tracklists_id_get) | **GET** /tracklists/{id} | Get a single TrackList by its id
*TradeUnionApi* | [**tradeunions_get**](docs/TradeUnionApi.md#tradeunions_get) | **GET** /tradeunions | List all instances of TradeUnion
*TradeUnionApi* | [**tradeunions_id_get**](docs/TradeUnionApi.md#tradeunions_id_get) | **GET** /tradeunions/{id} | Get a single TradeUnion by its id
*TrainApi* | [**trains_get**](docs/TrainApi.md#trains_get) | **GET** /trains | List all instances of Train
*TrainApi* | [**trains_id_get**](docs/TrainApi.md#trains_id_get) | **GET** /trains/{id} | Get a single Train by its id
*TreadmillApi* | [**treadmills_get**](docs/TreadmillApi.md#treadmills_get) | **GET** /treadmills | List all instances of Treadmill
*TreadmillApi* | [**treadmills_id_get**](docs/TreadmillApi.md#treadmills_id_get) | **GET** /treadmills/{id} | Get a single Treadmill by its id
*TunnelApi* | [**tunnels_get**](docs/TunnelApi.md#tunnels_get) | **GET** /tunnels | List all instances of Tunnel
*TunnelApi* | [**tunnels_id_get**](docs/TunnelApi.md#tunnels_id_get) | **GET** /tunnels/{id} | Get a single Tunnel by its id
*TypeApi* | [**types_get**](docs/TypeApi.md#types_get) | **GET** /types | List all instances of Type
*TypeApi* | [**types_id_get**](docs/TypeApi.md#types_id_get) | **GET** /types/{id} | Get a single Type by its id
*UnitOfWorkApi* | [**unitofworks_get**](docs/UnitOfWorkApi.md#unitofworks_get) | **GET** /unitofworks | List all instances of UnitOfWork
*UnitOfWorkApi* | [**unitofworks_id_get**](docs/UnitOfWorkApi.md#unitofworks_id_get) | **GET** /unitofworks/{id} | Get a single UnitOfWork by its id
*UniversityApi* | [**universitys_get**](docs/UniversityApi.md#universitys_get) | **GET** /universitys | List all instances of University
*UniversityApi* | [**universitys_id_get**](docs/UniversityApi.md#universitys_id_get) | **GET** /universitys/{id} | Get a single University by its id
*UnknownApi* | [**unknowns_get**](docs/UnknownApi.md#unknowns_get) | **GET** /unknowns | List all instances of Unknown
*UnknownApi* | [**unknowns_id_get**](docs/UnknownApi.md#unknowns_id_get) | **GET** /unknowns/{id} | Get a single Unknown by its id
*ValleyApi* | [**valleys_get**](docs/ValleyApi.md#valleys_get) | **GET** /valleys | List all instances of Valley
*ValleyApi* | [**valleys_id_get**](docs/ValleyApi.md#valleys_id_get) | **GET** /valleys/{id} | Get a single Valley by its id
*VeinApi* | [**veins_get**](docs/VeinApi.md#veins_get) | **GET** /veins | List all instances of Vein
*VeinApi* | [**veins_id_get**](docs/VeinApi.md#veins_id_get) | **GET** /veins/{id} | Get a single Vein by its id
*VenueApi* | [**venues_get**](docs/VenueApi.md#venues_get) | **GET** /venues | List all instances of Venue
*VenueApi* | [**venues_id_get**](docs/VenueApi.md#venues_id_get) | **GET** /venues/{id} | Get a single Venue by its id
*VicarApi* | [**vicars_get**](docs/VicarApi.md#vicars_get) | **GET** /vicars | List all instances of Vicar
*VicarApi* | [**vicars_id_get**](docs/VicarApi.md#vicars_id_get) | **GET** /vicars/{id} | Get a single Vicar by its id
*VicePresidentApi* | [**vicepresidents_get**](docs/VicePresidentApi.md#vicepresidents_get) | **GET** /vicepresidents | List all instances of VicePresident
*VicePresidentApi* | [**vicepresidents_id_get**](docs/VicePresidentApi.md#vicepresidents_id_get) | **GET** /vicepresidents/{id} | Get a single VicePresident by its id
*VicePrimeMinisterApi* | [**viceprimeministers_get**](docs/VicePrimeMinisterApi.md#viceprimeministers_get) | **GET** /viceprimeministers | List all instances of VicePrimeMinister
*VicePrimeMinisterApi* | [**viceprimeministers_id_get**](docs/VicePrimeMinisterApi.md#viceprimeministers_id_get) | **GET** /viceprimeministers/{id} | Get a single VicePrimeMinister by its id
*VideoGameApi* | [**videogames_get**](docs/VideoGameApi.md#videogames_get) | **GET** /videogames | List all instances of VideoGame
*VideoGameApi* | [**videogames_id_get**](docs/VideoGameApi.md#videogames_id_get) | **GET** /videogames/{id} | Get a single VideoGame by its id
*VideogamesLeagueApi* | [**videogamesleagues_get**](docs/VideogamesLeagueApi.md#videogamesleagues_get) | **GET** /videogamesleagues | List all instances of VideogamesLeague
*VideogamesLeagueApi* | [**videogamesleagues_id_get**](docs/VideogamesLeagueApi.md#videogamesleagues_id_get) | **GET** /videogamesleagues/{id} | Get a single VideogamesLeague by its id
*VillageApi* | [**villages_get**](docs/VillageApi.md#villages_get) | **GET** /villages | List all instances of Village
*VillageApi* | [**villages_id_get**](docs/VillageApi.md#villages_id_get) | **GET** /villages/{id} | Get a single Village by its id
*VoiceActorApi* | [**voiceactors_get**](docs/VoiceActorApi.md#voiceactors_get) | **GET** /voiceactors | List all instances of VoiceActor
*VoiceActorApi* | [**voiceactors_id_get**](docs/VoiceActorApi.md#voiceactors_id_get) | **GET** /voiceactors/{id} | Get a single VoiceActor by its id
*VolcanoApi* | [**volcanos_get**](docs/VolcanoApi.md#volcanos_get) | **GET** /volcanos | List all instances of Volcano
*VolcanoApi* | [**volcanos_id_get**](docs/VolcanoApi.md#volcanos_id_get) | **GET** /volcanos/{id} | Get a single Volcano by its id
*VolleyballCoachApi* | [**volleyballcoachs_get**](docs/VolleyballCoachApi.md#volleyballcoachs_get) | **GET** /volleyballcoachs | List all instances of VolleyballCoach
*VolleyballCoachApi* | [**volleyballcoachs_id_get**](docs/VolleyballCoachApi.md#volleyballcoachs_id_get) | **GET** /volleyballcoachs/{id} | Get a single VolleyballCoach by its id
*VolleyballLeagueApi* | [**volleyballleagues_get**](docs/VolleyballLeagueApi.md#volleyballleagues_get) | **GET** /volleyballleagues | List all instances of VolleyballLeague
*VolleyballLeagueApi* | [**volleyballleagues_id_get**](docs/VolleyballLeagueApi.md#volleyballleagues_id_get) | **GET** /volleyballleagues/{id} | Get a single VolleyballLeague by its id
*VolleyballPlayerApi* | [**volleyballplayers_get**](docs/VolleyballPlayerApi.md#volleyballplayers_get) | **GET** /volleyballplayers | List all instances of VolleyballPlayer
*VolleyballPlayerApi* | [**volleyballplayers_id_get**](docs/VolleyballPlayerApi.md#volleyballplayers_id_get) | **GET** /volleyballplayers/{id} | Get a single VolleyballPlayer by its id
*WaterPoloPlayerApi* | [**waterpoloplayers_get**](docs/WaterPoloPlayerApi.md#waterpoloplayers_get) | **GET** /waterpoloplayers | List all instances of WaterPoloPlayer
*WaterPoloPlayerApi* | [**waterpoloplayers_id_get**](docs/WaterPoloPlayerApi.md#waterpoloplayers_id_get) | **GET** /waterpoloplayers/{id} | Get a single WaterPoloPlayer by its id
*WaterRideApi* | [**waterrides_get**](docs/WaterRideApi.md#waterrides_get) | **GET** /waterrides | List all instances of WaterRide
*WaterRideApi* | [**waterrides_id_get**](docs/WaterRideApi.md#waterrides_id_get) | **GET** /waterrides/{id} | Get a single WaterRide by its id
*WaterTowerApi* | [**watertowers_get**](docs/WaterTowerApi.md#watertowers_get) | **GET** /watertowers | List all instances of WaterTower
*WaterTowerApi* | [**watertowers_id_get**](docs/WaterTowerApi.md#watertowers_id_get) | **GET** /watertowers/{id} | Get a single WaterTower by its id
*WatermillApi* | [**watermills_get**](docs/WatermillApi.md#watermills_get) | **GET** /watermills | List all instances of Watermill
*WatermillApi* | [**watermills_id_get**](docs/WatermillApi.md#watermills_id_get) | **GET** /watermills/{id} | Get a single Watermill by its id
*WaterwayTunnelApi* | [**waterwaytunnels_get**](docs/WaterwayTunnelApi.md#waterwaytunnels_get) | **GET** /waterwaytunnels | List all instances of WaterwayTunnel
*WaterwayTunnelApi* | [**waterwaytunnels_id_get**](docs/WaterwayTunnelApi.md#waterwaytunnels_id_get) | **GET** /waterwaytunnels/{id} | Get a single WaterwayTunnel by its id
*WeaponApi* | [**weapons_get**](docs/WeaponApi.md#weapons_get) | **GET** /weapons | List all instances of Weapon
*WeaponApi* | [**weapons_id_get**](docs/WeaponApi.md#weapons_id_get) | **GET** /weapons/{id} | Get a single Weapon by its id
*WebsiteApi* | [**websites_get**](docs/WebsiteApi.md#websites_get) | **GET** /websites | List all instances of Website
*WebsiteApi* | [**websites_id_get**](docs/WebsiteApi.md#websites_id_get) | **GET** /websites/{id} | Get a single Website by its id
*WindMotorApi* | [**windmotors_get**](docs/WindMotorApi.md#windmotors_get) | **GET** /windmotors | List all instances of WindMotor
*WindMotorApi* | [**windmotors_id_get**](docs/WindMotorApi.md#windmotors_id_get) | **GET** /windmotors/{id} | Get a single WindMotor by its id
*WindmillApi* | [**windmills_get**](docs/WindmillApi.md#windmills_get) | **GET** /windmills | List all instances of Windmill
*WindmillApi* | [**windmills_id_get**](docs/WindmillApi.md#windmills_id_get) | **GET** /windmills/{id} | Get a single Windmill by its id
*WineApi* | [**wines_get**](docs/WineApi.md#wines_get) | **GET** /wines | List all instances of Wine
*WineApi* | [**wines_id_get**](docs/WineApi.md#wines_id_get) | **GET** /wines/{id} | Get a single Wine by its id
*WineRegionApi* | [**wineregions_get**](docs/WineRegionApi.md#wineregions_get) | **GET** /wineregions | List all instances of WineRegion
*WineRegionApi* | [**wineregions_id_get**](docs/WineRegionApi.md#wineregions_id_get) | **GET** /wineregions/{id} | Get a single WineRegion by its id
*WineryApi* | [**winerys_get**](docs/WineryApi.md#winerys_get) | **GET** /winerys | List all instances of Winery
*WineryApi* | [**winerys_id_get**](docs/WineryApi.md#winerys_id_get) | **GET** /winerys/{id} | Get a single Winery by its id
*WomensTennisAssociationTournamentApi* | [**womenstennisassociationtournaments_get**](docs/WomensTennisAssociationTournamentApi.md#womenstennisassociationtournaments_get) | **GET** /womenstennisassociationtournaments | List all instances of WomensTennisAssociationTournament
*WomensTennisAssociationTournamentApi* | [**womenstennisassociationtournaments_id_get**](docs/WomensTennisAssociationTournamentApi.md#womenstennisassociationtournaments_id_get) | **GET** /womenstennisassociationtournaments/{id} | Get a single WomensTennisAssociationTournament by its id
*WorkApi* | [**works_get**](docs/WorkApi.md#works_get) | **GET** /works | List all instances of Work
*WorkApi* | [**works_id_get**](docs/WorkApi.md#works_id_get) | **GET** /works/{id} | Get a single Work by its id
*WorldHeritageSiteApi* | [**worldheritagesites_get**](docs/WorldHeritageSiteApi.md#worldheritagesites_get) | **GET** /worldheritagesites | List all instances of WorldHeritageSite
*WorldHeritageSiteApi* | [**worldheritagesites_id_get**](docs/WorldHeritageSiteApi.md#worldheritagesites_id_get) | **GET** /worldheritagesites/{id} | Get a single WorldHeritageSite by its id
*WrestlerApi* | [**wrestlers_get**](docs/WrestlerApi.md#wrestlers_get) | **GET** /wrestlers | List all instances of Wrestler
*WrestlerApi* | [**wrestlers_id_get**](docs/WrestlerApi.md#wrestlers_id_get) | **GET** /wrestlers/{id} | Get a single Wrestler by its id
*WrestlingEventApi* | [**wrestlingevents_get**](docs/WrestlingEventApi.md#wrestlingevents_get) | **GET** /wrestlingevents | List all instances of WrestlingEvent
*WrestlingEventApi* | [**wrestlingevents_id_get**](docs/WrestlingEventApi.md#wrestlingevents_id_get) | **GET** /wrestlingevents/{id} | Get a single WrestlingEvent by its id
*WriterApi* | [**writers_get**](docs/WriterApi.md#writers_get) | **GET** /writers | List all instances of Writer
*WriterApi* | [**writers_id_get**](docs/WriterApi.md#writers_id_get) | **GET** /writers/{id} | Get a single Writer by its id
*WrittenWorkApi* | [**writtenworks_get**](docs/WrittenWorkApi.md#writtenworks_get) | **GET** /writtenworks | List all instances of WrittenWork
*WrittenWorkApi* | [**writtenworks_id_get**](docs/WrittenWorkApi.md#writtenworks_id_get) | **GET** /writtenworks/{id} | Get a single WrittenWork by its id
*YearApi* | [**years_get**](docs/YearApi.md#years_get) | **GET** /years | List all instances of Year
*YearApi* | [**years_id_get**](docs/YearApi.md#years_id_get) | **GET** /years/{id} | Get a single Year by its id
*YearInSpaceflightApi* | [**yearinspaceflights_get**](docs/YearInSpaceflightApi.md#yearinspaceflights_get) | **GET** /yearinspaceflights | List all instances of YearInSpaceflight
*YearInSpaceflightApi* | [**yearinspaceflights_id_get**](docs/YearInSpaceflightApi.md#yearinspaceflights_id_get) | **GET** /yearinspaceflights/{id} | Get a single YearInSpaceflight by its id
*ZooApi* | [**zoos_get**](docs/ZooApi.md#zoos_get) | **GET** /zoos | List all instances of Zoo
*ZooApi* | [**zoos_id_get**](docs/ZooApi.md#zoos_id_get) | **GET** /zoos/{id} | Get a single Zoo by its id
*OpenswarmApi* | [**openswarms_get**](docs/OpenswarmApi.md#openswarms_get) | **GET** /openswarms | List all instances of openswarm
*OpenswarmApi* | [**openswarms_id_get**](docs/OpenswarmApi.md#openswarms_id_get) | **GET** /openswarms/{id} | Get a single openswarm by its id


## Documentation For Models

 - [Abbey](docs/Abbey.md)
 - [AcademicJournal](docs/AcademicJournal.md)
 - [Activity](docs/Activity.md)
 - [Actor](docs/Actor.md)
 - [AdministrativeRegion](docs/AdministrativeRegion.md)
 - [AdultActor](docs/AdultActor.md)
 - [Agent](docs/Agent.md)
 - [Agglomeration](docs/Agglomeration.md)
 - [Aircraft](docs/Aircraft.md)
 - [Airline](docs/Airline.md)
 - [Airport](docs/Airport.md)
 - [Album](docs/Album.md)
 - [AlgerianSettlement](docs/AlgerianSettlement.md)
 - [Altitude](docs/Altitude.md)
 - [AmateurBoxer](docs/AmateurBoxer.md)
 - [Ambassador](docs/Ambassador.md)
 - [AmericanFootballCoach](docs/AmericanFootballCoach.md)
 - [AmericanFootballLeague](docs/AmericanFootballLeague.md)
 - [AmericanFootballPlayer](docs/AmericanFootballPlayer.md)
 - [AmericanFootballTeam](docs/AmericanFootballTeam.md)
 - [Amphibian](docs/Amphibian.md)
 - [AmusementParkAttraction](docs/AmusementParkAttraction.md)
 - [AnatomicalStructure](docs/AnatomicalStructure.md)
 - [Animal](docs/Animal.md)
 - [AnimangaCharacter](docs/AnimangaCharacter.md)
 - [Anime](docs/Anime.md)
 - [Annotation](docs/Annotation.md)
 - [Arachnid](docs/Arachnid.md)
 - [Archaea](docs/Archaea.md)
 - [Archeologist](docs/Archeologist.md)
 - [Archipelago](docs/Archipelago.md)
 - [Architect](docs/Architect.md)
 - [ArchitecturalStructure](docs/ArchitecturalStructure.md)
 - [Archive](docs/Archive.md)
 - [Area](docs/Area.md)
 - [Arena](docs/Arena.md)
 - [Aristocrat](docs/Aristocrat.md)
 - [Artery](docs/Artery.md)
 - [ArtificialSatellite](docs/ArtificialSatellite.md)
 - [Artist](docs/Artist.md)
 - [ArtistDiscography](docs/ArtistDiscography.md)
 - [Artwork](docs/Artwork.md)
 - [Asteroid](docs/Asteroid.md)
 - [Astronaut](docs/Astronaut.md)
 - [Athlete](docs/Athlete.md)
 - [Athletics](docs/Athletics.md)
 - [AthleticsPlayer](docs/AthleticsPlayer.md)
 - [Atoll](docs/Atoll.md)
 - [AustralianFootballLeague](docs/AustralianFootballLeague.md)
 - [AustralianFootballTeam](docs/AustralianFootballTeam.md)
 - [AustralianRulesFootballPlayer](docs/AustralianRulesFootballPlayer.md)
 - [AustrianAdministrativeRegion](docs/AustrianAdministrativeRegion.md)
 - [AustrianSettlement](docs/AustrianSettlement.md)
 - [AutoRacingLeague](docs/AutoRacingLeague.md)
 - [Automobile](docs/Automobile.md)
 - [AutomobileEngine](docs/AutomobileEngine.md)
 - [Award](docs/Award.md)
 - [BackScene](docs/BackScene.md)
 - [Bacteria](docs/Bacteria.md)
 - [BadmintonPlayer](docs/BadmintonPlayer.md)
 - [Band](docs/Band.md)
 - [Baronet](docs/Baronet.md)
 - [BaseballLeague](docs/BaseballLeague.md)
 - [BaseballPlayer](docs/BaseballPlayer.md)
 - [BaseballSeason](docs/BaseballSeason.md)
 - [BaseballTeam](docs/BaseballTeam.md)
 - [BasketballLeague](docs/BasketballLeague.md)
 - [BasketballPlayer](docs/BasketballPlayer.md)
 - [BasketballTeam](docs/BasketballTeam.md)
 - [BeachVolleyballPlayer](docs/BeachVolleyballPlayer.md)
 - [BeautyQueen](docs/BeautyQueen.md)
 - [Beer](docs/Beer.md)
 - [BelgiumSettlement](docs/BelgiumSettlement.md)
 - [Beverage](docs/Beverage.md)
 - [BiologicalDatabase](docs/BiologicalDatabase.md)
 - [Biomolecule](docs/Biomolecule.md)
 - [Bird](docs/Bird.md)
 - [Birth](docs/Birth.md)
 - [Blazon](docs/Blazon.md)
 - [BoardGame](docs/BoardGame.md)
 - [BodyOfWater](docs/BodyOfWater.md)
 - [Bodybuilder](docs/Bodybuilder.md)
 - [Bone](docs/Bone.md)
 - [Book](docs/Book.md)
 - [BowlingLeague](docs/BowlingLeague.md)
 - [Boxer](docs/Boxer.md)
 - [Boxing](docs/Boxing.md)
 - [BoxingCategory](docs/BoxingCategory.md)
 - [BoxingLeague](docs/BoxingLeague.md)
 - [BoxingStyle](docs/BoxingStyle.md)
 - [Brain](docs/Brain.md)
 - [Brewery](docs/Brewery.md)
 - [Bridge](docs/Bridge.md)
 - [BritishRoyalty](docs/BritishRoyalty.md)
 - [BroadcastNetwork](docs/BroadcastNetwork.md)
 - [Broadcaster](docs/Broadcaster.md)
 - [BrownDwarf](docs/BrownDwarf.md)
 - [Building](docs/Building.md)
 - [BullFighter](docs/BullFighter.md)
 - [Bullfighter](docs/Bullfighter.md)
 - [BusCompany](docs/BusCompany.md)
 - [BusinessPerson](docs/BusinessPerson.md)
 - [Camera](docs/Camera.md)
 - [CanadianFootballLeague](docs/CanadianFootballLeague.md)
 - [CanadianFootballPlayer](docs/CanadianFootballPlayer.md)
 - [CanadianFootballTeam](docs/CanadianFootballTeam.md)
 - [Canal](docs/Canal.md)
 - [Canoeist](docs/Canoeist.md)
 - [Capital](docs/Capital.md)
 - [CapitalOfRegion](docs/CapitalOfRegion.md)
 - [Cardinal](docs/Cardinal.md)
 - [CareerStation](docs/CareerStation.md)
 - [Cartoon](docs/Cartoon.md)
 - [Case](docs/Case.md)
 - [Casino](docs/Casino.md)
 - [Castle](docs/Castle.md)
 - [Cave](docs/Cave.md)
 - [Celebrity](docs/Celebrity.md)
 - [CelestialBody](docs/CelestialBody.md)
 - [Cemetery](docs/Cemetery.md)
 - [Chancellor](docs/Chancellor.md)
 - [ChartsPlacements](docs/ChartsPlacements.md)
 - [Cheese](docs/Cheese.md)
 - [Chef](docs/Chef.md)
 - [ChemicalCompound](docs/ChemicalCompound.md)
 - [ChemicalElement](docs/ChemicalElement.md)
 - [ChemicalSubstance](docs/ChemicalSubstance.md)
 - [ChessPlayer](docs/ChessPlayer.md)
 - [ChristianBishop](docs/ChristianBishop.md)
 - [ChristianDoctrine](docs/ChristianDoctrine.md)
 - [ChristianPatriarch](docs/ChristianPatriarch.md)
 - [Church](docs/Church.md)
 - [City](docs/City.md)
 - [CityDistrict](docs/CityDistrict.md)
 - [ClassicalMusicArtist](docs/ClassicalMusicArtist.md)
 - [ClassicalMusicComposition](docs/ClassicalMusicComposition.md)
 - [Cleric](docs/Cleric.md)
 - [ClericalAdministrativeRegion](docs/ClericalAdministrativeRegion.md)
 - [ClericalOrder](docs/ClericalOrder.md)
 - [ClubMoss](docs/ClubMoss.md)
 - [Coach](docs/Coach.md)
 - [CollectionOfValuables](docs/CollectionOfValuables.md)
 - [College](docs/College.md)
 - [CollegeCoach](docs/CollegeCoach.md)
 - [Colour](docs/Colour.md)
 - [Comedian](docs/Comedian.md)
 - [ComedyGroup](docs/ComedyGroup.md)
 - [Comic](docs/Comic.md)
 - [ComicStrip](docs/ComicStrip.md)
 - [Comics](docs/Comics.md)
 - [ComicsCharacter](docs/ComicsCharacter.md)
 - [ComicsCreator](docs/ComicsCreator.md)
 - [Community](docs/Community.md)
 - [Company](docs/Company.md)
 - [Competition](docs/Competition.md)
 - [Congressman](docs/Congressman.md)
 - [Conifer](docs/Conifer.md)
 - [Constellation](docs/Constellation.md)
 - [Contest](docs/Contest.md)
 - [Continent](docs/Continent.md)
 - [ControlledDesignationOfOriginWine](docs/ControlledDesignationOfOriginWine.md)
 - [Convention](docs/Convention.md)
 - [Country](docs/Country.md)
 - [CountrySeat](docs/CountrySeat.md)
 - [Crater](docs/Crater.md)
 - [CricketGround](docs/CricketGround.md)
 - [CricketLeague](docs/CricketLeague.md)
 - [CricketTeam](docs/CricketTeam.md)
 - [Cricketer](docs/Cricketer.md)
 - [Criminal](docs/Criminal.md)
 - [Crustacean](docs/Crustacean.md)
 - [CultivatedVariety](docs/CultivatedVariety.md)
 - [Curler](docs/Curler.md)
 - [CurlingLeague](docs/CurlingLeague.md)
 - [Currency](docs/Currency.md)
 - [Cycad](docs/Cycad.md)
 - [CyclingCompetition](docs/CyclingCompetition.md)
 - [CyclingLeague](docs/CyclingLeague.md)
 - [CyclingRace](docs/CyclingRace.md)
 - [CyclingTeam](docs/CyclingTeam.md)
 - [Cyclist](docs/Cyclist.md)
 - [Dam](docs/Dam.md)
 - [Dancer](docs/Dancer.md)
 - [DartsPlayer](docs/DartsPlayer.md)
 - [Database](docs/Database.md)
 - [Deanery](docs/Deanery.md)
 - [Death](docs/Death.md)
 - [Decoration](docs/Decoration.md)
 - [Deity](docs/Deity.md)
 - [Demographics](docs/Demographics.md)
 - [Department](docs/Department.md)
 - [Depth](docs/Depth.md)
 - [Deputy](docs/Deputy.md)
 - [Desert](docs/Desert.md)
 - [Device](docs/Device.md)
 - [DigitalCamera](docs/DigitalCamera.md)
 - [Diocese](docs/Diocese.md)
 - [Diploma](docs/Diploma.md)
 - [Disease](docs/Disease.md)
 - [DisneyCharacter](docs/DisneyCharacter.md)
 - [District](docs/District.md)
 - [DistrictWaterBoard](docs/DistrictWaterBoard.md)
 - [Divorce](docs/Divorce.md)
 - [Document](docs/Document.md)
 - [DocumentType](docs/DocumentType.md)
 - [Dog](docs/Dog.md)
 - [Drama](docs/Drama.md)
 - [Drug](docs/Drug.md)
 - [Economist](docs/Economist.md)
 - [EducationalInstitution](docs/EducationalInstitution.md)
 - [Egyptologist](docs/Egyptologist.md)
 - [Election](docs/Election.md)
 - [ElectionDiagram](docs/ElectionDiagram.md)
 - [Embryology](docs/Embryology.md)
 - [Employer](docs/Employer.md)
 - [Engineer](docs/Engineer.md)
 - [Entomologist](docs/Entomologist.md)
 - [Enzyme](docs/Enzyme.md)
 - [EthnicGroup](docs/EthnicGroup.md)
 - [Eukaryote](docs/Eukaryote.md)
 - [EurovisionSongContestEntry](docs/EurovisionSongContestEntry.md)
 - [Event](docs/Event.md)
 - [Factory](docs/Factory.md)
 - [Family](docs/Family.md)
 - [Farmer](docs/Farmer.md)
 - [Fashion](docs/Fashion.md)
 - [FashionDesigner](docs/FashionDesigner.md)
 - [Fencer](docs/Fencer.md)
 - [Fern](docs/Fern.md)
 - [FictionalCharacter](docs/FictionalCharacter.md)
 - [FieldHockeyLeague](docs/FieldHockeyLeague.md)
 - [FigureSkater](docs/FigureSkater.md)
 - [Film](docs/Film.md)
 - [FilmFestival](docs/FilmFestival.md)
 - [Fish](docs/Fish.md)
 - [Flag](docs/Flag.md)
 - [FloweringPlant](docs/FloweringPlant.md)
 - [Food](docs/Food.md)
 - [FootballLeagueSeason](docs/FootballLeagueSeason.md)
 - [FootballMatch](docs/FootballMatch.md)
 - [FormerMunicipality](docs/FormerMunicipality.md)
 - [FormulaOneRacer](docs/FormulaOneRacer.md)
 - [FormulaOneRacing](docs/FormulaOneRacing.md)
 - [FormulaOneTeam](docs/FormulaOneTeam.md)
 - [Fungus](docs/Fungus.md)
 - [GaelicGamesPlayer](docs/GaelicGamesPlayer.md)
 - [Galaxy](docs/Galaxy.md)
 - [Game](docs/Game.md)
 - [Garden](docs/Garden.md)
 - [Gate](docs/Gate.md)
 - [GatedCommunity](docs/GatedCommunity.md)
 - [Gene](docs/Gene.md)
 - [GeneLocation](docs/GeneLocation.md)
 - [Genre](docs/Genre.md)
 - [GeologicalPeriod](docs/GeologicalPeriod.md)
 - [GeopoliticalOrganisation](docs/GeopoliticalOrganisation.md)
 - [GermanSettlement](docs/GermanSettlement.md)
 - [Ginkgo](docs/Ginkgo.md)
 - [GivenName](docs/GivenName.md)
 - [Glacier](docs/Glacier.md)
 - [Globularswarm](docs/Globularswarm.md)
 - [Gnetophytes](docs/Gnetophytes.md)
 - [GolfCourse](docs/GolfCourse.md)
 - [GolfLeague](docs/GolfLeague.md)
 - [GolfPlayer](docs/GolfPlayer.md)
 - [GolfTournament](docs/GolfTournament.md)
 - [GovernmentAgency](docs/GovernmentAgency.md)
 - [GovernmentType](docs/GovernmentType.md)
 - [GovernmentalAdministrativeRegion](docs/GovernmentalAdministrativeRegion.md)
 - [Governor](docs/Governor.md)
 - [GrandPrix](docs/GrandPrix.md)
 - [Grape](docs/Grape.md)
 - [GraveMonument](docs/GraveMonument.md)
 - [GreenAlga](docs/GreenAlga.md)
 - [GridironFootballPlayer](docs/GridironFootballPlayer.md)
 - [GrossDomesticProduct](docs/GrossDomesticProduct.md)
 - [GrossDomesticProductPerCapita](docs/GrossDomesticProductPerCapita.md)
 - [Group](docs/Group.md)
 - [Guitar](docs/Guitar.md)
 - [Guitarist](docs/Guitarist.md)
 - [Gymnast](docs/Gymnast.md)
 - [HandballLeague](docs/HandballLeague.md)
 - [HandballPlayer](docs/HandballPlayer.md)
 - [HandballTeam](docs/HandballTeam.md)
 - [Historian](docs/Historian.md)
 - [HistoricBuilding](docs/HistoricBuilding.md)
 - [HistoricPlace](docs/HistoricPlace.md)
 - [HistoricalCountry](docs/HistoricalCountry.md)
 - [HistoricalDistrict](docs/HistoricalDistrict.md)
 - [HistoricalPeriod](docs/HistoricalPeriod.md)
 - [HistoricalProvince](docs/HistoricalProvince.md)
 - [HistoricalRegion](docs/HistoricalRegion.md)
 - [HistoricalSettlement](docs/HistoricalSettlement.md)
 - [HockeyTeam](docs/HockeyTeam.md)
 - [Holiday](docs/Holiday.md)
 - [HollywoodCartoon](docs/HollywoodCartoon.md)
 - [HorseRace](docs/HorseRace.md)
 - [HorseRider](docs/HorseRider.md)
 - [HorseRiding](docs/HorseRiding.md)
 - [HorseTrainer](docs/HorseTrainer.md)
 - [Hospital](docs/Hospital.md)
 - [Host](docs/Host.md)
 - [HotSpring](docs/HotSpring.md)
 - [Hotel](docs/Hotel.md)
 - [HumanDevelopmentIndex](docs/HumanDevelopmentIndex.md)
 - [HumanGene](docs/HumanGene.md)
 - [HumanGeneLocation](docs/HumanGeneLocation.md)
 - [Humorist](docs/Humorist.md)
 - [HungarySettlement](docs/HungarySettlement.md)
 - [IceHockeyLeague](docs/IceHockeyLeague.md)
 - [IceHockeyPlayer](docs/IceHockeyPlayer.md)
 - [Ideology](docs/Ideology.md)
 - [Image](docs/Image.md)
 - [Imdb](docs/Imdb.md)
 - [InformationAppliance](docs/InformationAppliance.md)
 - [Infrastructure](docs/Infrastructure.md)
 - [InlineHockeyLeague](docs/InlineHockeyLeague.md)
 - [Insect](docs/Insect.md)
 - [Installment](docs/Installment.md)
 - [Instrument](docs/Instrument.md)
 - [Instrumentalist](docs/Instrumentalist.md)
 - [Intercommunality](docs/Intercommunality.md)
 - [Island](docs/Island.md)
 - [Jockey](docs/Jockey.md)
 - [Journalist](docs/Journalist.md)
 - [Judge](docs/Judge.md)
 - [LacrosseLeague](docs/LacrosseLeague.md)
 - [LacrossePlayer](docs/LacrossePlayer.md)
 - [Lake](docs/Lake.md)
 - [Language](docs/Language.md)
 - [LaunchPad](docs/LaunchPad.md)
 - [LawFirm](docs/LawFirm.md)
 - [Lawyer](docs/Lawyer.md)
 - [LebanonSettlement](docs/LebanonSettlement.md)
 - [LegalCase](docs/LegalCase.md)
 - [Legislature](docs/Legislature.md)
 - [Letter](docs/Letter.md)
 - [Library](docs/Library.md)
 - [LiechtensteinSettlement](docs/LiechtensteinSettlement.md)
 - [Lieutenant](docs/Lieutenant.md)
 - [LifeCycleEvent](docs/LifeCycleEvent.md)
 - [Ligament](docs/Ligament.md)
 - [LightNovel](docs/LightNovel.md)
 - [Lighthouse](docs/Lighthouse.md)
 - [LineOfFashion](docs/LineOfFashion.md)
 - [Linguist](docs/Linguist.md)
 - [List](docs/List.md)
 - [Listen](docs/Listen.md)
 - [Locality](docs/Locality.md)
 - [Lock](docs/Lock.md)
 - [Locomotive](docs/Locomotive.md)
 - [LunarCrater](docs/LunarCrater.md)
 - [Lymph](docs/Lymph.md)
 - [Magazine](docs/Magazine.md)
 - [Mammal](docs/Mammal.md)
 - [Manga](docs/Manga.md)
 - [Manhua](docs/Manhua.md)
 - [Manhwa](docs/Manhwa.md)
 - [Marriage](docs/Marriage.md)
 - [MartialArtist](docs/MartialArtist.md)
 - [Mayor](docs/Mayor.md)
 - [MeanOfTransportation](docs/MeanOfTransportation.md)
 - [Media](docs/Media.md)
 - [Medician](docs/Medician.md)
 - [Meeting](docs/Meeting.md)
 - [MemberOfParliament](docs/MemberOfParliament.md)
 - [Memorial](docs/Memorial.md)
 - [MetroStation](docs/MetroStation.md)
 - [MicroRegion](docs/MicroRegion.md)
 - [MilitaryConflict](docs/MilitaryConflict.md)
 - [MilitaryPerson](docs/MilitaryPerson.md)
 - [MilitaryStructure](docs/MilitaryStructure.md)
 - [MilitaryUnit](docs/MilitaryUnit.md)
 - [Mill](docs/Mill.md)
 - [Mineral](docs/Mineral.md)
 - [MixedMartialArtsEvent](docs/MixedMartialArtsEvent.md)
 - [MixedMartialArtsLeague](docs/MixedMartialArtsLeague.md)
 - [Model](docs/Model.md)
 - [Mollusca](docs/Mollusca.md)
 - [Monarch](docs/Monarch.md)
 - [Monastery](docs/Monastery.md)
 - [Monastry](docs/Monastry.md)
 - [Monument](docs/Monument.md)
 - [Mosque](docs/Mosque.md)
 - [Moss](docs/Moss.md)
 - [MotocycleRacer](docs/MotocycleRacer.md)
 - [Motorcycle](docs/Motorcycle.md)
 - [MotorcycleRacingLeague](docs/MotorcycleRacingLeague.md)
 - [MotorcycleRider](docs/MotorcycleRider.md)
 - [MotorsportRacer](docs/MotorsportRacer.md)
 - [MotorsportSeason](docs/MotorsportSeason.md)
 - [Mountain](docs/Mountain.md)
 - [MountainPass](docs/MountainPass.md)
 - [MountainRange](docs/MountainRange.md)
 - [MouseGene](docs/MouseGene.md)
 - [MouseGeneLocation](docs/MouseGeneLocation.md)
 - [MovieDirector](docs/MovieDirector.md)
 - [MovieGenre](docs/MovieGenre.md)
 - [MovingImage](docs/MovingImage.md)
 - [MultiVolumePublication](docs/MultiVolumePublication.md)
 - [Municipality](docs/Municipality.md)
 - [Murderer](docs/Murderer.md)
 - [Muscle](docs/Muscle.md)
 - [Museum](docs/Museum.md)
 - [MusicComposer](docs/MusicComposer.md)
 - [MusicDirector](docs/MusicDirector.md)
 - [MusicFestival](docs/MusicFestival.md)
 - [MusicGenre](docs/MusicGenre.md)
 - [Musical](docs/Musical.md)
 - [MusicalArtist](docs/MusicalArtist.md)
 - [MusicalWork](docs/MusicalWork.md)
 - [MythologicalFigure](docs/MythologicalFigure.md)
 - [NCAATeamSeason](docs/NCAATeamSeason.md)
 - [Name](docs/Name.md)
 - [NarutoCharacter](docs/NarutoCharacter.md)
 - [NascarDriver](docs/NascarDriver.md)
 - [NationalAnthem](docs/NationalAnthem.md)
 - [NationalCollegiateAthleticAssociationAthlete](docs/NationalCollegiateAthleticAssociationAthlete.md)
 - [NationalFootballLeagueEvent](docs/NationalFootballLeagueEvent.md)
 - [NationalFootballLeagueSeason](docs/NationalFootballLeagueSeason.md)
 - [NationalSoccerClub](docs/NationalSoccerClub.md)
 - [NaturalEvent](docs/NaturalEvent.md)
 - [NaturalPlace](docs/NaturalPlace.md)
 - [NaturalRegion](docs/NaturalRegion.md)
 - [Nerve](docs/Nerve.md)
 - [NetballPlayer](docs/NetballPlayer.md)
 - [Newspaper](docs/Newspaper.md)
 - [NobelPrize](docs/NobelPrize.md)
 - [Noble](docs/Noble.md)
 - [NobleFamily](docs/NobleFamily.md)
 - [NonProfitOrganisation](docs/NonProfitOrganisation.md)
 - [NorwaySettlement](docs/NorwaySettlement.md)
 - [NoteworthyPartOfBuilding](docs/NoteworthyPartOfBuilding.md)
 - [Novel](docs/Novel.md)
 - [NuclearPowerStation](docs/NuclearPowerStation.md)
 - [Ocean](docs/Ocean.md)
 - [OfficeHolder](docs/OfficeHolder.md)
 - [OldTerritory](docs/OldTerritory.md)
 - [OlympicEvent](docs/OlympicEvent.md)
 - [OlympicResult](docs/OlympicResult.md)
 - [Olympics](docs/Olympics.md)
 - [Openswarm](docs/Openswarm.md)
 - [Opera](docs/Opera.md)
 - [Organ](docs/Organ.md)
 - [Organisation](docs/Organisation.md)
 - [OrganisationMember](docs/OrganisationMember.md)
 - [OverseasDepartment](docs/OverseasDepartment.md)
 - [PaintballLeague](docs/PaintballLeague.md)
 - [Painter](docs/Painter.md)
 - [Painting](docs/Painting.md)
 - [Parish](docs/Parish.md)
 - [Park](docs/Park.md)
 - [Parliament](docs/Parliament.md)
 - [PenaltyShootOut](docs/PenaltyShootOut.md)
 - [PeriodOfArtisticStyle](docs/PeriodOfArtisticStyle.md)
 - [PeriodicalLiterature](docs/PeriodicalLiterature.md)
 - [Person](docs/Person.md)
 - [PersonFunction](docs/PersonFunction.md)
 - [PersonalEvent](docs/PersonalEvent.md)
 - [Philosopher](docs/Philosopher.md)
 - [Photographer](docs/Photographer.md)
 - [Place](docs/Place.md)
 - [Planet](docs/Planet.md)
 - [Plant](docs/Plant.md)
 - [Play](docs/Play.md)
 - [PlayWright](docs/PlayWright.md)
 - [PlayboyPlaymate](docs/PlayboyPlaymate.md)
 - [Poem](docs/Poem.md)
 - [Poet](docs/Poet.md)
 - [PokerPlayer](docs/PokerPlayer.md)
 - [PolishKing](docs/PolishKing.md)
 - [PoliticalFunction](docs/PoliticalFunction.md)
 - [PoliticalParty](docs/PoliticalParty.md)
 - [Politician](docs/Politician.md)
 - [PoliticianSpouse](docs/PoliticianSpouse.md)
 - [PoloLeague](docs/PoloLeague.md)
 - [Polyhedron](docs/Polyhedron.md)
 - [Pope](docs/Pope.md)
 - [PopulatedPlace](docs/PopulatedPlace.md)
 - [Population](docs/Population.md)
 - [Port](docs/Port.md)
 - [PowerStation](docs/PowerStation.md)
 - [Prefecture](docs/Prefecture.md)
 - [PrehistoricalPeriod](docs/PrehistoricalPeriod.md)
 - [Presenter](docs/Presenter.md)
 - [President](docs/President.md)
 - [Priest](docs/Priest.md)
 - [PrimeMinister](docs/PrimeMinister.md)
 - [Prison](docs/Prison.md)
 - [Producer](docs/Producer.md)
 - [Profession](docs/Profession.md)
 - [Professor](docs/Professor.md)
 - [ProgrammingLanguage](docs/ProgrammingLanguage.md)
 - [Project](docs/Project.md)
 - [ProtectedArea](docs/ProtectedArea.md)
 - [Protein](docs/Protein.md)
 - [ProtohistoricalPeriod](docs/ProtohistoricalPeriod.md)
 - [Province](docs/Province.md)
 - [Psychologist](docs/Psychologist.md)
 - [PublicService](docs/PublicService.md)
 - [PublicServiceInput](docs/PublicServiceInput.md)
 - [PublicServiceOutput](docs/PublicServiceOutput.md)
 - [PublicTransitSystem](docs/PublicTransitSystem.md)
 - [Publisher](docs/Publisher.md)
 - [Pyramid](docs/Pyramid.md)
 - [Race](docs/Race.md)
 - [RaceHorse](docs/RaceHorse.md)
 - [RaceTrack](docs/RaceTrack.md)
 - [Racecourse](docs/Racecourse.md)
 - [RacingDriver](docs/RacingDriver.md)
 - [RadioControlledRacingLeague](docs/RadioControlledRacingLeague.md)
 - [RadioHost](docs/RadioHost.md)
 - [RadioProgram](docs/RadioProgram.md)
 - [RadioStation](docs/RadioStation.md)
 - [RailwayLine](docs/RailwayLine.md)
 - [RailwayStation](docs/RailwayStation.md)
 - [RailwayTunnel](docs/RailwayTunnel.md)
 - [RallyDriver](docs/RallyDriver.md)
 - [RecordLabel](docs/RecordLabel.md)
 - [RecordOffice](docs/RecordOffice.md)
 - [Referee](docs/Referee.md)
 - [Reference](docs/Reference.md)
 - [Regency](docs/Regency.md)
 - [Region](docs/Region.md)
 - [Religious](docs/Religious.md)
 - [ReligiousBuilding](docs/ReligiousBuilding.md)
 - [Reptile](docs/Reptile.md)
 - [ResearchProject](docs/ResearchProject.md)
 - [Restaurant](docs/Restaurant.md)
 - [Resume](docs/Resume.md)
 - [River](docs/River.md)
 - [Road](docs/Road.md)
 - [RoadJunction](docs/RoadJunction.md)
 - [RoadTunnel](docs/RoadTunnel.md)
 - [Rocket](docs/Rocket.md)
 - [RollerCoaster](docs/RollerCoaster.md)
 - [RomanEmperor](docs/RomanEmperor.md)
 - [RomaniaSettlement](docs/RomaniaSettlement.md)
 - [RouteOfTransportation](docs/RouteOfTransportation.md)
 - [Rower](docs/Rower.md)
 - [Royalty](docs/Royalty.md)
 - [RugbyClub](docs/RugbyClub.md)
 - [RugbyLeague](docs/RugbyLeague.md)
 - [RugbyPlayer](docs/RugbyPlayer.md)
 - [Saint](docs/Saint.md)
 - [Sales](docs/Sales.md)
 - [SambaSchool](docs/SambaSchool.md)
 - [Satellite](docs/Satellite.md)
 - [School](docs/School.md)
 - [Scientist](docs/Scientist.md)
 - [ScreenWriter](docs/ScreenWriter.md)
 - [Sculptor](docs/Sculptor.md)
 - [Sculpture](docs/Sculpture.md)
 - [Sea](docs/Sea.md)
 - [Senator](docs/Senator.md)
 - [SerialKiller](docs/SerialKiller.md)
 - [Settlement](docs/Settlement.md)
 - [Ship](docs/Ship.md)
 - [ShoppingMall](docs/ShoppingMall.md)
 - [Shrine](docs/Shrine.md)
 - [Singer](docs/Singer.md)
 - [Single](docs/Single.md)
 - [SiteOfSpecialScientificInterest](docs/SiteOfSpecialScientificInterest.md)
 - [Skater](docs/Skater.md)
 - [SkiArea](docs/SkiArea.md)
 - [SkiResort](docs/SkiResort.md)
 - [Skier](docs/Skier.md)
 - [Skyscraper](docs/Skyscraper.md)
 - [SnookerChamp](docs/SnookerChamp.md)
 - [SnookerPlayer](docs/SnookerPlayer.md)
 - [SnookerWorldRanking](docs/SnookerWorldRanking.md)
 - [SoapCharacter](docs/SoapCharacter.md)
 - [SoccerClub](docs/SoccerClub.md)
 - [SoccerClubSeason](docs/SoccerClubSeason.md)
 - [SoccerLeague](docs/SoccerLeague.md)
 - [SoccerLeagueSeason](docs/SoccerLeagueSeason.md)
 - [SoccerManager](docs/SoccerManager.md)
 - [SoccerPlayer](docs/SoccerPlayer.md)
 - [SoccerTournament](docs/SoccerTournament.md)
 - [SocietalEvent](docs/SocietalEvent.md)
 - [SoftballLeague](docs/SoftballLeague.md)
 - [Software](docs/Software.md)
 - [SolarEclipse](docs/SolarEclipse.md)
 - [Song](docs/Song.md)
 - [SongWriter](docs/SongWriter.md)
 - [Sound](docs/Sound.md)
 - [SpaceMission](docs/SpaceMission.md)
 - [SpaceShuttle](docs/SpaceShuttle.md)
 - [SpaceStation](docs/SpaceStation.md)
 - [Spacecraft](docs/Spacecraft.md)
 - [Species](docs/Species.md)
 - [SpeedwayLeague](docs/SpeedwayLeague.md)
 - [SpeedwayRider](docs/SpeedwayRider.md)
 - [SpeedwayTeam](docs/SpeedwayTeam.md)
 - [Sport](docs/Sport.md)
 - [SportCompetitionResult](docs/SportCompetitionResult.md)
 - [SportFacility](docs/SportFacility.md)
 - [SportsEvent](docs/SportsEvent.md)
 - [SportsLeague](docs/SportsLeague.md)
 - [SportsManager](docs/SportsManager.md)
 - [SportsSeason](docs/SportsSeason.md)
 - [SportsTeam](docs/SportsTeam.md)
 - [SportsTeamMember](docs/SportsTeamMember.md)
 - [SportsTeamSeason](docs/SportsTeamSeason.md)
 - [Square](docs/Square.md)
 - [SquashPlayer](docs/SquashPlayer.md)
 - [Stadium](docs/Stadium.md)
 - [Star](docs/Star.md)
 - [State](docs/State.md)
 - [StatedResolution](docs/StatedResolution.md)
 - [Station](docs/Station.md)
 - [Statistic](docs/Statistic.md)
 - [StillImage](docs/StillImage.md)
 - [Stream](docs/Stream.md)
 - [Street](docs/Street.md)
 - [SubMunicipality](docs/SubMunicipality.md)
 - [SumoWrestler](docs/SumoWrestler.md)
 - [SupremeCourtOfTheUnitedStatesCase](docs/SupremeCourtOfTheUnitedStatesCase.md)
 - [Surfer](docs/Surfer.md)
 - [Surname](docs/Surname.md)
 - [Swarm](docs/Swarm.md)
 - [Swimmer](docs/Swimmer.md)
 - [SwitzerlandSettlement](docs/SwitzerlandSettlement.md)
 - [Synagogue](docs/Synagogue.md)
 - [SystemOfLaw](docs/SystemOfLaw.md)
 - [TableTennisPlayer](docs/TableTennisPlayer.md)
 - [Tax](docs/Tax.md)
 - [Taxon](docs/Taxon.md)
 - [TeamMember](docs/TeamMember.md)
 - [TelevisionDirector](docs/TelevisionDirector.md)
 - [TelevisionEpisode](docs/TelevisionEpisode.md)
 - [TelevisionHost](docs/TelevisionHost.md)
 - [TelevisionPersonality](docs/TelevisionPersonality.md)
 - [TelevisionSeason](docs/TelevisionSeason.md)
 - [TelevisionShow](docs/TelevisionShow.md)
 - [TelevisionStation](docs/TelevisionStation.md)
 - [Temple](docs/Temple.md)
 - [TennisLeague](docs/TennisLeague.md)
 - [TennisPlayer](docs/TennisPlayer.md)
 - [TennisTournament](docs/TennisTournament.md)
 - [TermOfOffice](docs/TermOfOffice.md)
 - [Territory](docs/Territory.md)
 - [Theatre](docs/Theatre.md)
 - [TheatreDirector](docs/TheatreDirector.md)
 - [Thing](docs/Thing.md)
 - [TimePeriod](docs/TimePeriod.md)
 - [TopicalConcept](docs/TopicalConcept.md)
 - [Tournament](docs/Tournament.md)
 - [Tower](docs/Tower.md)
 - [Town](docs/Town.md)
 - [TrackList](docs/TrackList.md)
 - [TradeUnion](docs/TradeUnion.md)
 - [Train](docs/Train.md)
 - [Treadmill](docs/Treadmill.md)
 - [Tunnel](docs/Tunnel.md)
 - [Type](docs/Type.md)
 - [UnitOfWork](docs/UnitOfWork.md)
 - [University](docs/University.md)
 - [Unknown](docs/Unknown.md)
 - [Valley](docs/Valley.md)
 - [Vein](docs/Vein.md)
 - [Venue](docs/Venue.md)
 - [Vicar](docs/Vicar.md)
 - [VicePresident](docs/VicePresident.md)
 - [VicePrimeMinister](docs/VicePrimeMinister.md)
 - [VideoGame](docs/VideoGame.md)
 - [VideogamesLeague](docs/VideogamesLeague.md)
 - [Village](docs/Village.md)
 - [VoiceActor](docs/VoiceActor.md)
 - [Volcano](docs/Volcano.md)
 - [VolleyballCoach](docs/VolleyballCoach.md)
 - [VolleyballLeague](docs/VolleyballLeague.md)
 - [VolleyballPlayer](docs/VolleyballPlayer.md)
 - [WaterPoloPlayer](docs/WaterPoloPlayer.md)
 - [WaterRide](docs/WaterRide.md)
 - [WaterTower](docs/WaterTower.md)
 - [Watermill](docs/Watermill.md)
 - [WaterwayTunnel](docs/WaterwayTunnel.md)
 - [Weapon](docs/Weapon.md)
 - [Website](docs/Website.md)
 - [WindMotor](docs/WindMotor.md)
 - [Windmill](docs/Windmill.md)
 - [Wine](docs/Wine.md)
 - [WineRegion](docs/WineRegion.md)
 - [Winery](docs/Winery.md)
 - [WomensTennisAssociationTournament](docs/WomensTennisAssociationTournament.md)
 - [Work](docs/Work.md)
 - [WorldHeritageSite](docs/WorldHeritageSite.md)
 - [Wrestler](docs/Wrestler.md)
 - [WrestlingEvent](docs/WrestlingEvent.md)
 - [Writer](docs/Writer.md)
 - [WrittenWork](docs/WrittenWork.md)
 - [Year](docs/Year.md)
 - [YearInSpaceflight](docs/YearInSpaceflight.md)
 - [Zoo](docs/Zoo.md)


## Documentation For Authorization


## BearerAuth

- **Type**: Bearer authentication (JWT)


## Author




